"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _avatar = require("../../tokens/avatar");

var _AvatarStyles = _interopRequireDefault(require("./AvatarStyles"));

var textToInitials = function textToInitials(text) {
  if (!text) {
    return {
      avatarText: '',
      isInitial: false
    };
  }

  var textSplit = text.split(' ').filter(function (word) {
    return word.match(/^[A-Z0-9]/i);
  });
  var wordCount = textSplit.length;

  if (wordCount > 1) {
    return {
      isInitial: true,
      avatarText: [textSplit[0], textSplit[wordCount - 1]].map(function (word) {
        return word.slice(0, 1);
      }).join('')
    };
  }

  return {
    isInitial: false,
    avatarText: textSplit[0].slice(0, 2)
  };
};

var Avatar = function Avatar(_ref) {
  var _ref$text = _ref.text,
      text = _ref$text === void 0 ? '' : _ref$text,
      _ref$brand = _ref.brand,
      brand = _ref$brand === void 0 ? false : _ref$brand,
      _ref$secondary = _ref.secondary,
      secondary = _ref$secondary === void 0 ? false : _ref$secondary,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? _avatar.AvatarConstants.sizes.medium : _ref$size,
      inverse = _ref.inverse;

  var _textToInitials = textToInitials(text),
      isInitial = _textToInitials.isInitial,
      avatarText = _textToInitials.avatarText;

  return _react["default"].createElement(_AvatarStyles["default"].Container, {
    size: size,
    borderColor: inverse ? _tokens["default"].avatar.color[(0, _avatar.getAvatarColor)(brand, secondary)][(0, _avatar.getAvatarTextKey)(inverse)] : null,
    color: _tokens["default"].avatar.color[(0, _avatar.getAvatarColor)(brand, secondary)][(0, _avatar.getAvatarBackgroundKey)(inverse)]
  }, _react["default"].createElement(_AvatarStyles["default"].Text, {
    size: size,
    isInitial: isInitial,
    color: _tokens["default"].avatar.color[(0, _avatar.getAvatarColor)(brand, secondary)][(0, _avatar.getAvatarTextKey)(inverse)]
  }, avatarText));
};

var _default = Avatar;
exports["default"] = _default;