"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var sizeToHeight = {
  xsmall: 17,
  small: 30,
  medium: 40,
  large: 50
};
var sizeToWidth = {
  xsmall: 17,
  small: 30,
  medium: 40,
  large: 50
};

var Container = _styledComponents["default"].div.withConfig({
  displayName: "AvatarStyles__Container",
  componentId: "sc-16owrvl-0"
})(["", ";border-radius:50%;display:flex;flex-direction:column;justify-content:center;align-items:center;"], function (_ref) {
  var size = _ref.size,
      color = _ref.color,
      borderColor = _ref.borderColor;
  return "\n    min-height: ".concat(sizeToHeight[size], "px;\n    min-width: ").concat(sizeToWidth[size], "px;\n    height: ").concat(sizeToHeight[size], "px;\n    width: ").concat(sizeToWidth[size], "px;\n    background-color: ").concat(color, ";\n    border: ").concat(borderColor ? "1px solid ".concat(borderColor) : 'none', ";\n  ");
});

var Text = _styledComponents["default"].div.withConfig({
  displayName: "AvatarStyles__Text",
  componentId: "sc-16owrvl-1"
})(["color:", ";font-size:", ";font-family:", ";font-weight:", ";text-transform:", ";"], function (_ref2) {
  var color = _ref2.color;
  return color;
}, function (_ref3) {
  var size = _ref3.size;
  return _tokens["default"].avatar.text.size[size];
}, _tokens["default"].avatar.text.family, _tokens["default"].avatar.text.weight, function (_ref4) {
  var isInitial = _ref4.isInitial;
  return isInitial ? 'uppercase' : 'capitalize';
});

var _default = {
  Container: Container,
  Text: Text
};
exports["default"] = _default;