"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _ButtonText = _interopRequireDefault(require("./ButtonText"));

var _ButtonWrapper = _interopRequireDefault(require("./ButtonWrapper"));

var _tokens = _interopRequireWildcard(require("../../tokens"));

var _button = require("../../tokens/button");

var Button =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2["default"])(Button, _React$PureComponent);

  function Button() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Button);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Button)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "iconAllowed", function () {
      var size = _this.props.size;
      return size === _tokens.ButtonConstants.sizes.xsmall || size === _tokens.ButtonConstants.sizes.small || size === _tokens.ButtonConstants.sizes.medium;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "iconSize", function () {
      switch (_this.props.size) {
        case _tokens.ButtonConstants.sizes.xsmall:
          return 11;

        case _tokens.ButtonConstants.sizes.small:
          return 12;

        case _tokens.ButtonConstants.sizes.medium:
          return 16;

        default:
          return 0;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "textColor", function () {
      var active = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var _this$props = _this.props,
          style = _this$props.style,
          color = _this$props.color,
          disabled = _this$props.disabled;

      if (style === _tokens.ButtonConstants.styles.filled) {
        return _tokens["default"].button.text.color;
      }

      return _tokens["default"].button.colors[style][color][(0, _button.getButtonState)(disabled, active)];
    });
    return _this;
  }

  (0, _createClass2["default"])(Button, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          backgroundColor = _this$props2.backgroundColor,
          disabled = _this$props2.disabled,
          icon = _this$props2.icon,
          iconProps = _this$props2.iconProps,
          mixins = _this$props2.mixins,
          onClick = _this$props2.onClick,
          size = _this$props2.size,
          style = _this$props2.style,
          target = _this$props2.target,
          text = _this$props2.text,
          type = _this$props2.type,
          url = _this$props2.url,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["backgroundColor", "disabled", "icon", "iconProps", "mixins", "onClick", "size", "style", "target", "text", "type", "url"]);
      var wrapperProps = (0, _objectSpread2["default"])({
        type: type,
        target: target,
        disabled: disabled,
        to: url,
        size: size,
        mixins: mixins,
        backgroundColor: backgroundColor,
        buttonStyle: style,
        hasIcon: Boolean(icon),
        hasText: Boolean(text),
        onClick: undefined
      }, otherProps);

      if (!disabled && onClick) {
        if (type === 'button') {
          wrapperProps.onClick = function (event) {
            event.preventDefault();
            event.stopPropagation();
            onClick && onClick(event);
          };
        } else if (type === 'link') {
          wrapperProps.onClick = onClick;
        }
      }

      var Wrapper = type === 'link' && !disabled ? _ButtonWrapper["default"].link : _ButtonWrapper["default"].button;
      return _react["default"].createElement(Wrapper, (0, _extends2["default"])({}, wrapperProps, {
        className: "SML-Button"
      }), icon && this.iconAllowed() && _react["default"].createElement(_Icon["default"], (0, _extends2["default"])({
        icon: icon,
        size: this.iconSize(),
        color: this.textColor(false),
        activeColor: this.textColor(true)
      }, iconProps)), text && _react["default"].createElement(_ButtonText["default"], {
        size: size
      }, text));
    }
  }]);
  return Button;
}(_react["default"].PureComponent);

exports["default"] = Button;
(0, _defineProperty2["default"])(Button, "defaultProps", {
  style: _tokens.ButtonConstants.styles.filled,
  size: _tokens.ButtonConstants.sizes.small,
  color: 'primary',
  type: 'button',
  disabled: false,
  target: '',
  mixins: []
});