"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _ICONS = _interopRequireDefault(require("../../constants/ICONS"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _CheckboxStyles = _interopRequireDefault(require("./CheckboxStyles"));

var Checkbox =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(Checkbox, _React$Component);

  function Checkbox(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Checkbox);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(Checkbox).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnChange", function () {
      var _this$props = _this.props,
          handleStateExternally = _this$props.handleStateExternally,
          disabled = _this$props.disabled,
          onChange = _this$props.onChange,
          checked = _this$props.checked;

      if (!disabled) {
        if (handleStateExternally) {
          onChange && onChange(!checked);
        } else {
          _this.setState(function (prevState) {
            onChange && onChange(!prevState.checked);
            return {
              checked: !prevState.checked
            };
          });
        }
      }
    });
    _this.state = {
      checked: Boolean(props.checked)
    };
    return _this;
  }

  (0, _createClass2["default"])(Checkbox, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          mixins = _this$props2.mixins,
          handleStateExternally = _this$props2.handleStateExternally,
          small = _this$props2.small,
          checkedProps = _this$props2.checked,
          children = _this$props2.children,
          noHover = _this$props2.noHover,
          multiLineLabel = _this$props2.multiLineLabel;
      var checkedState = this.state.checked;
      var checked = handleStateExternally ? checkedProps : checkedState;
      return _react["default"].createElement(_CheckboxStyles["default"].Label, {
        disabled: disabled,
        mixins: mixins,
        small: small
      }, _react["default"].createElement(_CheckboxStyles["default"].Text, {
        multiLineLabel: multiLineLabel
      }, children), _react["default"].createElement(_CheckboxStyles["default"].Input, {
        type: "checkbox",
        onChange: this.handleOnChange
      }), _react["default"].createElement(_CheckboxStyles["default"].Checkmark, {
        checked: checked,
        disabled: disabled,
        small: small
      }), checked && _react["default"].createElement(_Icon["default"], {
        icon: _ICONS["default"].check,
        size: small ? 8 : 10,
        color: _tokens["default"].checkbox.icon.color,
        mixins: [_CheckboxStyles["default"].Icon(small)],
        noHover: noHover
      }));
    }
  }]);
  return Checkbox;
}(_react["default"].Component);

exports["default"] = Checkbox;