"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _checkbox = require("../../tokens/checkbox");

var Input = _styledComponents["default"].input.withConfig({
  displayName: "CheckboxStyles__Input",
  componentId: "sc-1ed3jfi-0"
})(["opacity:0;cursor:pointer;position:absolute;"]);

var Label = _styledComponents["default"].label.withConfig({
  displayName: "CheckboxStyles__Label",
  componentId: "sc-1ed3jfi-1"
})(["line-height:1;position:relative;display:block;padding-left:29px;cursor:", ";opacity:", ";font-weight:", ";font-size:", ";color:", ";font-family:", ";-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;", ""], function (_ref) {
  var disabled = _ref.disabled;
  return disabled ? 'not-allowed' : 'pointer';
}, function (_ref2) {
  var disabled = _ref2.disabled;
  return disabled ? 0.3 : 1;
}, _tokens["default"].checkbox.text.weight, function (_ref3) {
  var small = _ref3.small;
  return _tokens["default"].checkbox.text.size[(0, _checkbox.getCheckboxSize)(small)];
}, _tokens["default"].checkbox.text.color, _tokens["default"].checkbox.text.family, function (_ref4) {
  var mixins = _ref4.mixins;
  return mixins;
});

var Checkmark = _styledComponents["default"].span.withConfig({
  displayName: "CheckboxStyles__Checkmark",
  componentId: "sc-1ed3jfi-2"
})(["position:absolute;top:0;left:0;height:", "px;width:", "px;background-color:", ";", " box-sizing:border-box;", ":hover &{", "}"], function (_ref5) {
  var small = _ref5.small;
  return _tokens["default"].checkbox.size[(0, _checkbox.getCheckboxSize)(small)];
}, function (_ref6) {
  var small = _ref6.small;
  return _tokens["default"].checkbox.size[(0, _checkbox.getCheckboxSize)(small)];
}, function (_ref7) {
  var checked = _ref7.checked;
  return _tokens["default"].checkbox.background.color[(0, _checkbox.getCheckboxState)(checked)];
}, function (_ref8) {
  var checked = _ref8.checked,
      small = _ref8.small;

  if (checked === true) {
    return '';
  }

  var width = _tokens["default"].checkbox.border.width[(0, _checkbox.getCheckboxSize)(small)];

  var color = _tokens["default"].checkbox.border.color["default"];
  return "border: ".concat(width, "px solid ").concat(color, ";");
}, Label, function (_ref9) {
  var checked = _ref9.checked,
      disabled = _ref9.disabled;

  if (disabled === true) {
    return '';
  }

  if (checked) {
    return "background-color: ".concat(_tokens["default"].checkbox.background.color.hover, ";");
  }

  return "border-color: ".concat(_tokens["default"].checkbox.border.color.hover, ";");
});

var Icon = function Icon(small) {
  return (0, _styledComponents.css)(["position:absolute;left:5px;top:", "px;left:", "px;"], small ? 2 : 3, small ? 2 : 3);
};

var Text = _styledComponents["default"].span.withConfig({
  displayName: "CheckboxStyles__Text",
  componentId: "sc-1ed3jfi-3"
})(["", ""], function (_ref10) {
  var multiLineLabel = _ref10.multiLineLabel;
  return multiLineLabel ? "\n    position: relative;\n    bottom: 7px;\n  " : '';
});

var _default = {
  Label: Label,
  Icon: Icon,
  Input: Input,
  Checkmark: Checkmark,
  Text: Text
};
exports["default"] = _default;