"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Caret = exports.Body = exports.Header = exports.Container = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _ANIMATIONS = _interopRequireDefault(require("../../constants/ANIMATIONS"));

var _Icon = require("../Icon/Icon");

var _tokens = _interopRequireDefault(require("../../tokens"));

var Container = _styledComponents["default"].div.withConfig({
  displayName: "Collapsestyles__Container",
  componentId: "sc-1ktpsub-0"
})(["", ";"], function (_ref) {
  var mixins = _ref.mixins;
  return mixins;
});

exports.Container = Container;

var getMarginRight = function getMarginRight(_ref2) {
  var caretOnRight = _ref2.caretOnRight;
  return caretOnRight ? 0 : 5;
};

var getJustifyContent = function getJustifyContent(_ref3) {
  var caretOnRight = _ref3.caretOnRight;
  return caretOnRight ? 'space-between' : 'initial';
};

var Header = _styledComponents["default"].div.withConfig({
  displayName: "Collapsestyles__Header",
  componentId: "sc-1ktpsub-1"
})(["user-select:none;cursor:pointer;display:flex;flex-direction:row;align-items:center;justify-content:", ";& ", "{margin-right:", "px;}}"], getJustifyContent, _Icon.StyledSVG, getMarginRight);

exports.Header = Header;

var Body = _styledComponents["default"].div.withConfig({
  displayName: "Collapsestyles__Body",
  componentId: "sc-1ktpsub-2"
})(["height:auto;", ";", ""], function (_ref4) {
  var caretOnRight = _ref4.caretOnRight;
  return caretOnRight ? '' : 'padding-left: 15px';
}, function (_ref5) {
  var collapsed = _ref5.collapsed,
      noTransition = _ref5.noTransition;

  if (noTransition) {
    if (collapsed) {
      return (0, _styledComponents.css)(["height:0;overflow:hidden;"]);
    }

    return (0, _styledComponents.css)(["height:auto;"]);
  }

  if (collapsed) {
    return (0, _styledComponents.css)(["max-height:0;transition:max-height 0.5s cubic-bezier(0,1,0,1);overflow:hidden;"]);
  }

  return (0, _styledComponents.css)(["max-height:10000px;transition:max-height 1s ease-in;", ";"], _ANIMATIONS["default"].delay({
    property: 'overflow',
    startValue: 'hidden',
    endValue: 'visible',
    time: 1.5
  }));
});

exports.Body = Body;

var Caret = _styledComponents["default"].div.withConfig({
  displayName: "Collapsestyles__Caret",
  componentId: "sc-1ktpsub-3"
})(["display:flex;justify-content:flex-end;", ";", ":hover &{& svg{fill:", ";}}"], function (_ref6) {
  var caretOnRight = _ref6.caretOnRight;
  return caretOnRight ? 'order: 2;' : '';
}, Header, _tokens["default"].colors.brand500);

exports.Caret = Caret;