"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _entry = _interopRequireDefault(require("react-datetime-picker/dist/entry.nostyle"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _Button = _interopRequireDefault(require("../../Button"));

var _Calendar = _interopRequireDefault(require("../../Calendar"));

var _ICONS = _interopRequireDefault(require("../../../constants/ICONS"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _DateTimeStyles = _interopRequireDefault(require("../DateTimeStyles"));

var overlayRoot = document.body;

var DateTimePicker =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(DateTimePicker, _React$Component);

  function DateTimePicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, DateTimePicker);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(DateTimePicker).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDateChange", function (date) {
      var onChange = _this.props.onChange;
      onChange && onChange(date);

      _this.closeCalendar();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openCalendar", function () {
      var overlay = _this.props.overlay;
      overlay && overlayRoot && overlayRoot.appendChild(_this.el);
      document.addEventListener('mousedown', _this.handleClickOutside);

      _this.setState(function (prevState) {
        return {
          show: !prevState.show
        };
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closeCalendar", function () {
      var overlay = _this.props.overlay;
      var show = _this.state.show;
      overlay && overlayRoot && overlayRoot.removeChild(_this.el);
      document.removeEventListener('mousedown', _this.handleClickOutside);

      if (show) {
        _this.setState({
          show: false
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setContainerRef", function (c) {
      return _this.containerRef = c;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setCalendarWrapperRef", function (c) {
      return _this.calendarWrapperRef = c;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setCalendarButtonRef", function (c) {
      return _this.calendarButtonRef = c;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickOutside", function (event) {
      var show = _this.state.show;

      if (show && _this.calendarWrapperRef && !_this.calendarWrapperRef.contains(event.target) && _this.calendarButtonRef && !_this.calendarButtonRef.contains(event.target)) {
        _this.closeCalendar();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCalendarClick", function (event) {
      event.preventDefault();
      event.stopPropagation();
      _this.state.show ? _this.closeCalendar() : _this.openCalendar();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearIcon", function () {
      return _react["default"].createElement(_Icon["default"], {
        icon: _ICONS["default"].x,
        color: _tokens["default"].datetimepicker.input.clearIcon.color["default"],
        activeColor: _tokens["default"].datetimepicker.input.clearIcon.color.active,
        size: 10
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calendarIcon", function () {
      return _react["default"].createElement(_Icon["default"], {
        icon: _ICONS["default"].calendar,
        color: _tokens["default"].datetimepicker.input.calendarIcon.color,
        size: 14
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderCalendar", function () {
      var _this$props = _this.props,
          overlay = _this$props.overlay,
          date = _this$props.date;
      return _react["default"].createElement(_DateTimeStyles["default"].CalendarWrapper, {
        overlay: overlay,
        ref: _this.setCalendarWrapperRef
      }, _react["default"].createElement(_Calendar["default"], {
        date: date,
        onChange: _this.handleDateChange
      }));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderDateTextField", function () {
      var _this$props2 = _this.props,
          date = _this$props2.date,
          label = _this$props2.label;
      return _react["default"].createElement(_DateTimeStyles["default"].Input, null, label && label, _react["default"].createElement(_entry["default"], {
        showLeadingZeros: true,
        locale: "en-GB",
        minDetail: "month",
        returnValue: "start",
        selectRange: false,
        onChange: _this.handleDateChange,
        value: date,
        calendarIcon: _this.calendarIcon(),
        clearIcon: _this.clearIcon(),
        disableClock: true
      }));
    });
    _this.el = document.createElement('div');
    _this.state = {
      show: false
    };
    return _this;
  }

  (0, _createClass2["default"])(DateTimePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var buttons = _reactDom["default"].findDOMNode(this).getElementsByClassName('react-datetime-picker__calendar-button');

      Array.from(buttons)[0].addEventListener('click', this.handleCalendarClick.bind(this));
      this.setCalendarButtonRef(Array.from(buttons)[0]);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var buttons = _reactDom["default"].findDOMNode(this).getElementsByClassName('react-datetime-picker__calendar-button');

      Array.from(buttons)[0].removeEventListener('click', this.handleCalendarClick.bind(this));
    }
  }, {
    key: "render",
    value: function render() {
      var overlay = this.props.overlay;
      var show = this.state.show;
      return _react["default"].createElement(_DateTimeStyles["default"].Container, {
        ref: this.setContainerRef
      }, this.renderDateTextField(), show && (overlay ? _reactDom["default"].createPortal(_react["default"].createElement(_DateTimeStyles["default"].OverlayWrapper, {
        top: this.containerRef.getBoundingClientRect().top,
        left: this.containerRef.getBoundingClientRect().left,
        right: this.containerRef.getBoundingClientRect().right
      }, this.renderCalendar()), this.el) : this.renderCalendar()));
    }
  }]);
  return DateTimePicker;
}(_react["default"].Component);

exports["default"] = DateTimePicker;