"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _entry = _interopRequireDefault(require("react-datetime-picker/dist/entry.nostyle"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _Button = _interopRequireDefault(require("../../Button"));

var _Calendar = _interopRequireDefault(require("../../Calendar"));

var _ICONS = _interopRequireDefault(require("../../../constants/ICONS"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _DateTimeStyles = _interopRequireDefault(require("../DateTimeStyles"));

var overlayRoot = document.body;

var DateTimeRangePicker =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(DateTimeRangePicker, _React$Component);

  function DateTimeRangePicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, DateTimeRangePicker);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(DateTimeRangePicker).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDateChange", function (type) {
      return function (date) {
        var _this$props = _this.props,
            onChange = _this$props.onChange,
            fromDate = _this$props.fromDate,
            toDate = _this$props.toDate;
        var show = _this.state.show;

        if (type === 'from') {
          onChange && onChange([date, toDate]);
        } else if (type === 'to') {
          onChange && onChange([fromDate, date]);
        }

        if (show) {
          _this.closeCalendar();
        }
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openCalendar", function (type) {
      return function () {
        var overlay = _this.props.overlay;
        overlay && overlayRoot && overlayRoot.appendChild(_this.el);
        document.addEventListener('mousedown', _this.handleClickOutside);

        _this.setState({
          show: true,
          calendarType: type
        });
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closeCalendar", function () {
      var overlay = _this.props.overlay;
      overlay && overlayRoot && overlayRoot.removeChild(_this.el);
      document.removeEventListener('mousedown', _this.handleClickOutside);

      _this.setState({
        show: false,
        calendarType: null
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setContainerRef", function (c) {
      return _this.containerRef = c;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setCalendarWrapperRef", function (c) {
      return _this.calendarWrapperRef = c;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setCalendarButtonRef", function (type) {
      return function (c) {
        if (type === 'from') {
          _this.fromCalendarButtonRef = c;
        } else if (type === 'to') {
          _this.toCalendarButtonRef = c;
        }
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickOutside", function (event) {
      var _this$state = _this.state,
          show = _this$state.show,
          calendarType = _this$state.calendarType;

      if (show && _this.calendarWrapperRef && !_this.calendarWrapperRef.contains(event.target) && (calendarType === 'from' && _this.fromCalendarButtonRef && !_this.fromCalendarButtonRef.contains(event.target) || calendarType === 'to' && _this.toCalendarButtonRef && !_this.toCalendarButtonRef.contains(event.target))) {
        _this.closeCalendar();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCalendarClick", function (type) {
      return function (event) {
        event.preventDefault();
        event.stopPropagation();
        _this.state.show ? _this.closeCalendar() : _this.openCalendar(type)();
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearIcon", function () {
      return _react["default"].createElement(_Icon["default"], {
        icon: _ICONS["default"].x,
        color: _tokens["default"].datetimepicker.input.clearIcon.color["default"],
        activeColor: _tokens["default"].datetimepicker.input.clearIcon.color.active,
        size: 10
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calendarIcon", function () {
      return _react["default"].createElement(_Icon["default"], {
        icon: _ICONS["default"].calendar,
        color: _tokens["default"].datetimepicker.input.calendarIcon.color,
        size: 14
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderCalendar", function () {
      var _this$props2 = _this.props,
          overlay = _this$props2.overlay,
          fromDate = _this$props2.fromDate,
          toDate = _this$props2.toDate;
      var calendarType = _this.state.calendarType;
      var selectedDate = calendarType === 'from' ? fromDate : calendarType === 'to' ? toDate : null;
      return _react["default"].createElement(_DateTimeStyles["default"].CalendarWrapper, {
        overlay: overlay,
        calendarType: calendarType,
        ref: _this.setCalendarWrapperRef
      }, _react["default"].createElement(_Calendar["default"], {
        date: selectedDate,
        onChange: _this.handleDateChange(calendarType)
      }));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderDateTextField", function (type) {
      var _this$props3 = _this.props,
          fromDate = _this$props3.fromDate,
          toDate = _this$props3.toDate,
          fromLabel = _this$props3.fromLabel,
          toLabel = _this$props3.toLabel;
      var selectedDate = type === 'from' ? fromDate : type === 'to' ? toDate : null;
      return _react["default"].createElement(_DateTimeStyles["default"].Input, null, type === 'from' && fromLabel && fromLabel, type === 'to' && toLabel && toLabel, _react["default"].createElement(_entry["default"], {
        locale: "en-GB",
        minDetail: "month",
        showLeadingZeros: true,
        returnValue: "start",
        selectRange: false,
        onChange: _this.handleDateChange(type),
        value: selectedDate,
        calendarIcon: _this.calendarIcon(),
        clearIcon: _this.clearIcon(),
        disableClock: true
      }));
    });
    _this.el = document.createElement('div');
    _this.state = {
      show: false,
      calendarType: null
    };
    return _this;
  }

  (0, _createClass2["default"])(DateTimeRangePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var buttons = _reactDom["default"].findDOMNode(this).getElementsByClassName('react-datetime-picker__calendar-button');

      Array.from(buttons)[0].addEventListener('click', this.handleCalendarClick.bind(this)('from'));
      Array.from(buttons)[1].addEventListener('click', this.handleCalendarClick.bind(this)('to'));
      this.setCalendarButtonRef('from')(Array.from(buttons)[0]);
      this.setCalendarButtonRef('to')(Array.from(buttons)[1]);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var buttons = _reactDom["default"].findDOMNode(this).getElementsByClassName('react-datetime-picker__calendar-button');

      Array.from(buttons)[0].removeEventListener('click', this.handleCalendarClick.bind(this)('from'));
      Array.from(buttons)[1].removeEventListener('click', this.handleCalendarClick.bind(this)('to'));
    }
  }, {
    key: "render",
    value: function render() {
      var overlay = this.props.overlay;
      var show = this.state.show;
      return _react["default"].createElement(_DateTimeStyles["default"].Container, {
        ref: this.setContainerRef
      }, _react["default"].createElement(_DateTimeStyles["default"].InputRange, null, this.renderDateTextField('from'), _react["default"].createElement(_DateTimeStyles["default"].RangeDivider, null), this.renderDateTextField('to')), show && (overlay ? _reactDom["default"].createPortal(_react["default"].createElement(_DateTimeStyles["default"].OverlayWrapper, {
        top: this.containerRef.getBoundingClientRect().top,
        left: this.containerRef.getBoundingClientRect().left,
        right: this.containerRef.getBoundingClientRect().right
      }, this.renderCalendar()), this.el) : this.renderCalendar()));
    }
  }]);
  return DateTimeRangePicker;
}(_react["default"].Component);

exports["default"] = DateTimeRangePicker;