"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _DateTimePicker = _interopRequireDefault(require("../../styles/DateTimePicker"));

var _MIXINS = _interopRequireDefault(require("../../constants/MIXINS"));

var Container = _styledComponents["default"].div.withConfig({
  displayName: "DateTimeStyles__Container",
  componentId: "sc-1a4tq35-0"
})(["display:flex;flex-direction:column;align-items:flex-start;", ""], _DateTimePicker["default"]);

var OverlayWrapper = _styledComponents["default"].div.withConfig({
  displayName: "DateTimeStyles__OverlayWrapper",
  componentId: "sc-1a4tq35-1"
})(["position:fixed;top:", "px;left:", "px;z-index:999999999;"], function (_ref) {
  var top = _ref.top;
  return top + 32;
}, function (_ref2) {
  var left = _ref2.left;
  return left;
});

var CalendarWrapper = _styledComponents["default"].div.withConfig({
  displayName: "DateTimeStyles__CalendarWrapper",
  componentId: "sc-1a4tq35-2"
})(["margin-top:20px;", " ", ""], function (_ref3) {
  var calendarType = _ref3.calendarType,
      dateOnly = _ref3.dateOnly;
  return calendarType === 'to' ? "\n    display: flex;\n    justify-content: flex-end;\n    width: ".concat(dateOnly ? 305 : 405, "px;\n  ") : '';
}, function (_ref4) {
  var overlay = _ref4.overlay;
  return overlay ? _MIXINS["default"].defaultBoxShadow : '';
});

var InputRange = _styledComponents["default"].div.withConfig({
  displayName: "DateTimeStyles__InputRange",
  componentId: "sc-1a4tq35-3"
})(["display:flex;align-items:center;& .react-calendar{display:none;}"]);

var Input = _styledComponents["default"].div.withConfig({
  displayName: "DateTimeStyles__Input",
  componentId: "sc-1a4tq35-4"
})(["display:flex;flex-direction:column;align-items:flex-start;& .react-calendar{display:none;}", " & .react-datetime-picker__calendar-button{margin-right:7px;padding:2px;}", " & .react-datetime-picker__clear-button{padding:5px;}", " & .react-datetime-picker__wrapper{height:35px;background-color:", ";box-shadow:0 2px 4px 0 ", ";border:1px solid ", ";}", " & .react-datetime-picker__inputGroup{margin-left:7px;& .react-datetime-picker__inputGroup__input,.react-datetime-picker__inputGroup__leadingZero,.react-datetime-picker__inputGroup__divider{font-family:", ";font-size:", ";color:", ";}}", ""], ''
/* calendar button */
, ''
/* clear button */
, ''
/* Entire input wrapper */
, _tokens["default"].datetimepicker.input.background.color, _tokens["default"].datetimepicker.input.boxShadow.color, _tokens["default"].datetimepicker.input.border.color, ''
/* Text input */
, _tokens["default"].datetimepicker.input.text.family, _tokens["default"].datetimepicker.input.text.size, _tokens["default"].datetimepicker.input.text.color, function (_ref5) {
  var right = _ref5.right;
  return right ? "\n    & .react-datetime-picker__calendar {\n      left: auto;\n      right: -85px;\n    }\n  " : '';
});

var RangeDivider = _styledComponents["default"].div.withConfig({
  displayName: "DateTimeStyles__RangeDivider",
  componentId: "sc-1a4tq35-5"
})(["width:5px;margin:0 10px;margin-top:25px;border-bottom:1px solid ", ";"], _tokens["default"].datetimepicker.rangeDivider.color);

var _default = {
  Container: Container,
  InputRange: InputRange,
  Input: Input,
  RangeDivider: RangeDivider,
  OverlayWrapper: OverlayWrapper,
  CalendarWrapper: CalendarWrapper
};
exports["default"] = _default;