"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _utils = require("../../utils");

var _DropdownMenu = _interopRequireDefault(require("./DropdownMenu"));

var dropdownRoot = document.body;

var Dropdown =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(Dropdown, _React$Component);

  function Dropdown(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Dropdown);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(Dropdown).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      x: 0,
      y: 0,
      dropdown: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setDropdownRef", function (node) {
      _this.dropdownRef = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setToggleRef", function (node) {
      _this.toggleRef = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickOutside", function (event) {
      if (_this.state.dropdown && _this.dropdownRef && !_this.dropdownRef.contains(event.target) && _this.toggleRef && !_this.toggleRef.contains(event.target)) {
        _this.closeMenu();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleMenu", function (event) {
      event.stopPropagation();
      event.preventDefault();

      if (_this.state.dropdown) {
        _this.closeMenu();
      } else {
        var _this$calculateDropdo = _this.calculateDropdownPosition(event),
            _this$calculateDropdo2 = (0, _slicedToArray2["default"])(_this$calculateDropdo, 2),
            x = _this$calculateDropdo2[0],
            y = _this$calculateDropdo2[1];

        _this.openMenu(x, y);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calculateDropdownPosition", function (event) {
      var position = _this.props.position; // Calculate where the menu should open

      var x = 0,
          y = 0;

      if (position === 'event') {
        var clientX = event.clientX,
            clientY = event.clientY;
        x = clientX;
        y = clientY;
      } else if (position === 'toggle' && _this.toggleRef) {
        var _this$toggleRef$getBo = _this.toggleRef.getBoundingClientRect(),
            left = _this$toggleRef$getBo.left,
            bottom = _this$toggleRef$getBo.bottom;

        x = left;
        y = bottom;
      }

      return [x, y];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openMenu", function (x, y) {
      var _this$props = _this.props,
          header = _this$props.header,
          children = _this$props.children,
          mixins = _this$props.mixins;
      dropdownRoot && dropdownRoot.appendChild(_this.el);

      var dropdown = _reactDom["default"].createPortal(_react["default"].createElement("div", {
        key: "dropdown",
        ref: _this.setDropdownRef
      }, _react["default"].createElement(_DropdownMenu["default"], {
        open: open,
        x: x,
        y: y,
        header: header,
        closeMenu: _this.closeMenu,
        mixins: mixins
      }, open ? children : null)), _this.el);

      _this.setState({
        x: x,
        y: y,
        dropdown: dropdown
      }, _utils.scrollUtils.disableScroll);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closeMenu", function () {
      _this.setState({
        x: 0,
        y: 0,
        dropdown: null
      }, _utils.scrollUtils.enableScroll);
    });
    _this.el = document.createElement('div');
    return _this;
  }

  (0, _createClass2["default"])(Dropdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.addEventListener('mousedown', this.handleClickOutside);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _utils.scrollUtils.enableScroll();

      document.removeEventListener('mousedown', this.handleClickOutside);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          toggle = _this$props2.toggle,
          disabled = _this$props2.disabled,
          position = _this$props2.position,
          children = _this$props2.children,
          header = _this$props2.header,
          mixins = _this$props2.mixins,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["toggle", "disabled", "position", "children", "header", "mixins"]);
      var dropdown = this.state.dropdown;
      return [_react["default"].createElement("div", {
        key: "toggle",
        onClick: disabled ? null : this.toggleMenu,
        ref: this.setToggleRef
      }, _react["default"].cloneElement(toggle, (0, _objectSpread2["default"])({
        dropdownOpen: Boolean(dropdown)
      }, otherProps))), dropdown];
    }
  }]);
  return Dropdown;
}(_react["default"].Component);

exports["default"] = Dropdown;
(0, _defineProperty2["default"])(Dropdown, "defaultProps", {
  position: 'event'
});