"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _DropdownMenuStyles = _interopRequireDefault(require("./DropdownMenuStyles"));

var MENU_ITEM_HEIGHT = 22;

var DropdownMenu =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(DropdownMenu, _React$Component);

  function DropdownMenu() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DropdownMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DropdownMenu)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setDropdownRef", function (node) {
      _this.dropdownRef = node;

      _this.forceUpdate();
    });
    return _this;
  }

  (0, _createClass2["default"])(DropdownMenu, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          header = _this$props.header,
          mixins = _this$props.mixins,
          open = _this$props.open,
          x = _this$props.x,
          y = _this$props.y,
          closeMenu = _this$props.closeMenu,
          _nested = _this$props._nested,
          _estimatedHeight = _this$props._estimatedHeight,
          children = _this$props.children;
      var position = {
        left: null,
        top: null,
        bottom: null,
        right: null
      };
      var heightEstimate = _estimatedHeight || MENU_ITEM_HEIGHT * (children ? _react["default"].Children.count(children) : 0) + (header ? MENU_ITEM_HEIGHT : 0);

      if (y + heightEstimate + 20 > window.innerHeight) {
        position.bottom = window.innerHeight - y - (_nested ? MENU_ITEM_HEIGHT : 0);
      } else {
        position.top = y;
      }

      var characterCount = 0;

      _react["default"].Children.forEach(children, function (child) {
        if (child && child.props && child.props.text && child.props.text.length > characterCount) {
          characterCount = child.props.text.length;
        }
      });

      var widthEstimate = 60 + 7.5 * characterCount;

      if (x + widthEstimate > window.innerWidth) {
        position.right = window.innerWidth - x;
      } else {
        position.left = x;
      }

      return _react["default"].createElement(_DropdownMenuStyles["default"].Container, {
        "data-qa-id": "DropdownMenu__Container",
        ref: this.setDropdownRef,
        position: position,
        hidden: !open,
        mixins: mixins
      }, header && (typeof header === 'string' ? _react["default"].createElement(_DropdownMenuStyles["default"].Header, null, header) : header), _react["default"].Children.map(children, function (child) {
        return child ? _react["default"].cloneElement(child, {
          closeMenu: closeMenu
        }) : null;
      }));
    }
  }]);
  return DropdownMenu;
}(_react["default"].Component);

exports["default"] = DropdownMenu;