"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _DropdownMenu = _interopRequireDefault(require("../DropdownMenu"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _MenuItemText = _interopRequireDefault(require("./MenuItemText"));

var _MenuItemStyles = _interopRequireDefault(require("./MenuItemStyles"));

var Link = function Link(_ref) {
  var href = _ref.href,
      target = _ref.target,
      children = _ref.children;
  return href.startsWith('http') ? _react["default"].createElement(_MenuItemStyles["default"].ExternalLink, {
    href: href,
    target: target
  }, children) : _react["default"].createElement(_MenuItemStyles["default"].InternalLink, {
    to: href,
    target: target
  }, children);
};

var MenuItem =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(MenuItem, _React$Component);

  function MenuItem() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, MenuItem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MenuItem)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      open: false,
      x: 0,
      y: 0
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setWrapperRef", function (node) {
      _this.wrapperRef = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickOutside", function (event) {
      if (_this.props.children && _this.state.open && _this.wrapperRef && !_this.wrapperRef.contains(event.target)) {
        _this.closeSubMenu();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnClick", function (event) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          closeMenu = _this$props.closeMenu,
          disabled = _this$props.disabled,
          iconRight = _this$props.iconRight,
          children = _this$props.children;

      if (children && !disabled && (!onClick || !iconRight)) {
        _this.openSubMenu();
      } else {
        event.stopPropagation();
        closeMenu && closeMenu();

        if (!disabled && onClick) {
          onClick(event);
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRightIconClick", function (event) {
      var _this$props2 = _this.props,
          onClick = _this$props2.onClick,
          disabled = _this$props2.disabled,
          iconRight = _this$props2.iconRight,
          children = _this$props2.children;

      if (children && !disabled && iconRight && onClick) {
        event.stopPropagation();

        _this.openSubMenu();
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(MenuItem, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.children) {
        document.addEventListener('mousedown', this.handleClickOutside);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.children) {
        document.removeEventListener('mousedown', this.handleClickOutside);
      }
    }
  }, {
    key: "openSubMenu",
    value: function openSubMenu() {
      if (this.wrapperRef) {
        var _this$wrapperRef$getB = this.wrapperRef.getBoundingClientRect(),
            top = _this$wrapperRef$getB.top,
            left = _this$wrapperRef$getB.left,
            width = _this$wrapperRef$getB.width;

        this.setState({
          open: true,
          x: left + width,
          y: top
        });
      }
    }
  }, {
    key: "closeSubMenu",
    value: function closeSubMenu() {
      this.setState({
        open: false,
        x: 0,
        y: 0
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          children = _this$props3.children,
          text = _this$props3.text,
          iconLeft = _this$props3.iconLeft,
          iconLeftProps = _this$props3.iconLeftProps,
          iconRight = _this$props3.iconRight,
          iconSize = _this$props3.iconSize,
          href = _this$props3.href,
          target = _this$props3.target,
          closeMenu = _this$props3.closeMenu,
          disabled = _this$props3.disabled,
          active = _this$props3.active,
          estimatedChildHeight = _this$props3.estimatedChildHeight,
          mixins = _this$props3.mixins;
      var _this$state = this.state,
          open = _this$state.open,
          x = _this$state.x,
          y = _this$state.y;

      var menuItemText = _react["default"].createElement(_MenuItemText["default"], {
        "data-qa-id": "MenuItem__Text",
        disabled: disabled
      }, text);

      return _react["default"].createElement("div", {
        ref: this.setWrapperRef
      }, _react["default"].createElement(_MenuItemStyles["default"].Container, {
        disabled: disabled,
        active: open || active,
        mixins: mixins,
        onClick: this.handleOnClick,
        onDoubleClick: function onDoubleClick(e) {
          return e.stopPropagation();
        }
      }, _react["default"].createElement(_MenuItemStyles["default"].Left, null, iconLeft && _react["default"].createElement(_Icon["default"], (0, _extends2["default"])({
        icon: iconLeft,
        size: iconSize,
        color: _tokens["default"].dropdown.item.icon.color[disabled ? 'disabled' : 'enabled']
      }, iconLeftProps)), href ? _react["default"].createElement(Link, {
        href: href,
        target: target,
        disabled: disabled
      }, menuItemText) : menuItemText), _react["default"].createElement(_MenuItemStyles["default"].Right, {
        onClick: this.handleRightIconClick
      }, iconRight && _react["default"].createElement(_Icon["default"], {
        icon: iconRight,
        size: iconSize,
        color: _tokens["default"].dropdown.item.icon.color[disabled ? 'disabled' : 'enabled']
      }))), children && _react["default"].createElement(_DropdownMenu["default"], {
        open: open,
        x: x,
        y: y,
        closeMenu: closeMenu,
        _nested: true,
        _estimatedHeight: estimatedChildHeight
      }, open ? children : null));
    }
  }]);
  return MenuItem;
}(_react["default"].Component);

exports["default"] = MenuItem;
(0, _defineProperty2["default"])(MenuItem, "defaultProps", {
  iconSize: 14,
  className: ''
});