"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _Placeholder = _interopRequireDefault(require("../Typography/Placeholder"));

var _Spinner = _interopRequireDefault(require("../Spinner"));

var _ICONS = _interopRequireDefault(require("../../constants/ICONS"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var Styles = _interopRequireWildcard(require("./EditableText.styles"));

var ESCAPE = 27;
var ENTER = 13;

var EditableText =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2["default"])(EditableText, _React$PureComponent);

  function EditableText() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, EditableText);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(EditableText)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      currentValue: _this.props.value,
      backupValue: _this.props.value,
      isEditingMode: false,
      showIcon: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnClick", function () {
      var _this$props = _this.props,
          isLoading = _this$props.isLoading,
          value = _this$props.value;
      var isEditingMode = _this.state.isEditingMode;

      if (!isEditingMode && !isLoading) {
        _this.setState(function (prevState) {
          return {
            isEditingMode: !prevState.isEditingMode,
            currentValue: value
          };
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnBlur", function () {
      var onChange = _this.props.onChange;

      _this.setState(function (prevState) {
        return {
          isEditingMode: !prevState.isEditingMode,
          backupValue: _this.state.currentValue
        };
      }, function () {
        return onChange(_this.state.currentValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputChange", function (event) {
      _this.setState({
        currentValue: event.target.value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnKeyDown", function (event) {
      var isEditingMode = _this.state.isEditingMode;

      if (isEditingMode) {
        if (event.keyCode === ESCAPE) {
          _this.setState(function (prevState) {
            return {
              currentValue: prevState.backupValue,
              isEditingMode: false
            };
          });
        } else if (event.keyCode === ENTER) {
          _this.handleOnBlur();
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setShowIcon", function (show) {
      return function () {
        _this.setState(function (prevState) {
          if (!prevState.isEditingMode) {
            return (0, _objectSpread2["default"])({}, prevState, {
              showIcon: show
            });
          }
        });
      };
    });
    return _this;
  }

  (0, _createClass2["default"])(EditableText, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          textComponent = _this$props2.textComponent,
          placeholderText = _this$props2.placeholderText,
          _ = _this$props2.onChange,
          value = _this$props2.value,
          isLoading = _this$props2.isLoading,
          inverse = _this$props2.inverse,
          otherInputProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["textComponent", "placeholderText", "onChange", "value", "isLoading", "inverse"]);
      var _this$state = this.state,
          currentValue = _this$state.currentValue,
          isEditingMode = _this$state.isEditingMode,
          showIcon = _this$state.showIcon;
      var TextComponent = textComponent;
      var activeValue = isLoading ? currentValue : value;
      var renderedValue = !activeValue || activeValue.length === 0 ? _react["default"].createElement(_Placeholder["default"], {
        secondary: true
      }, placeholderText) : activeValue;
      return _react["default"].createElement(Styles.Container, {
        onClick: this.handleOnClick,
        onBlur: this.handleOnBlur,
        onKeyDown: this.handleOnKeyDown,
        isEditingMode: isEditingMode,
        isLoading: isLoading,
        onMouseOver: this.setShowIcon(true),
        onMouseLeave: this.setShowIcon(false),
        inverse: inverse
      }, _react["default"].createElement(TextComponent, null, isEditingMode ? _react["default"].createElement(Styles.Input, (0, _extends2["default"])({
        autoFocus: true,
        value: currentValue,
        onChange: this.handleInputChange,
        inverse: inverse
      }, otherInputProps)) : _react["default"].createElement(Styles.ValueWrapper, null, _react["default"].createElement(Styles.InnerValueWrapper, {
        "data-qa-id": "EditableText__innerValue-wrapper"
      }, renderedValue), isLoading ? _react["default"].createElement(_Spinner["default"], {
        show: true
      }) : showIcon && _react["default"].createElement(_Icon["default"], {
        icon: _ICONS["default"].edit,
        color: _tokens["default"].colors.secondary200
      }))));
    }
  }]);
  return EditableText;
}(_react["default"].PureComponent);

exports["default"] = EditableText;
(0, _defineProperty2["default"])(EditableText, "defaultProps", {
  isLoading: false,
  inverse: false
});