"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InnerValueWrapper = exports.ValueWrapper = exports.Input = exports.Container = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var Container = _styledComponents["default"].div.withConfig({
  displayName: "EditableTextstyles__Container",
  componentId: "eksobx-0"
})(["width:fit-content;padding:5px;border:1px solid;border-color:", ";cursor:", ";&:hover{border-color:", ";}"], function (props) {
  return props.isEditingMode ? props.inverse ? _tokens["default"].colors.white : _tokens["default"].input.border.color.active : props.inverse ? _tokens["default"].colors.secondary900 : _tokens["default"].colors.white;
}, function (props) {
  return props.isLoading ? 'not-allowed' : 'text';
}, function (props) {
  return props.isEditingMode ? 'default' : !props.isLoading ? _tokens["default"].input.border.color["default"] : 'default';
});

exports.Container = Container;
Container.displayName = 'EditableText__Container';

var Input = _styledComponents["default"].input.withConfig({
  displayName: "EditableTextstyles__Input",
  componentId: "eksobx-1"
})(["width:fit-content;border:0px;color:inherit;background-color:", ";text-transform:inherit;outline-width:0px;font-family:inherit;font-size:inherit;font-weight:inherit;"], function (props) {
  return props.inverse ? _tokens["default"].colors.background.dark : _tokens["default"].colors.background.light;
});

exports.Input = Input;

var ValueWrapper = _styledComponents["default"].div.withConfig({
  displayName: "EditableTextstyles__ValueWrapper",
  componentId: "eksobx-2"
})(["padding:1px;display:flex;justify-content:space-between;"]);

exports.ValueWrapper = ValueWrapper;

var InnerValueWrapper = _styledComponents["default"].div.withConfig({
  displayName: "EditableTextstyles__InnerValueWrapper",
  componentId: "eksobx-3"
})(["margin-right:10px;"]);

exports.InnerValueWrapper = InnerValueWrapper;