"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _Placeholder = _interopRequireDefault(require("../Typography/Placeholder"));

var Styles = _interopRequireWildcard(require("./EditableTextArea.styles.js"));

var ESCAPE = 27;
var ENTER = 13;

var EditableTextArea =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2["default"])(EditableTextArea, _React$PureComponent);

  function EditableTextArea() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, EditableTextArea);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(EditableTextArea)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      currentValue: _this.props.value,
      backupValue: _this.props.value,
      isEditingMode: _this.props.handleEditStateExternally ? _this.props.isEditingMode : false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setEditingMode", function (isEditingMode) {
      if (_this.state.isEditingMode !== isEditingMode) {
        _this.props.handleEditStateExternally ? _this.props.isEditingModeCallback(isEditingMode) : _this.setState({
          isEditingMode: isEditingMode
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnClick", function () {
      _this.setEditingMode(true);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSubmit", function () {
      var onChange = _this.props.onChange;
      var _this$state = _this.state,
          currentValue = _this$state.currentValue,
          backupValue = _this$state.backupValue;
      var shouldUpdate = currentValue !== backupValue;

      _this.setState(function (prevState) {
        return (0, _objectSpread2["default"])({}, prevState, {
          backupValue: prevState.currentValue
        });
      }, function () {
        _this.setEditingMode(false);

        onChange(currentValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnKeyDown", function (event) {
      var isEditingMode = _this.state.isEditingMode;

      if (isEditingMode) {
        var keyCode = event.keyCode,
            shiftKey = event.shiftKey,
            altKey = event.altKey;

        if (keyCode === ESCAPE) {
          _this.setState(function (prevState) {
            return (0, _objectSpread2["default"])({}, prevState, {
              currentValue: prevState.backupValue
            });
          }, function () {
            return _this.setEditingMode(false);
          });
        }

        if (keyCode === ENTER && !shiftKey && !altKey) {
          _this.handleSubmit();
        }
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(EditableTextArea, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props = this.props,
          value = _this$props.value,
          isEditingMode = _this$props.isEditingMode;

      if (prevProps.value !== value) {
        this.setState(function (prevState) {
          return (0, _objectSpread2["default"])({}, prevState, {
            currentValue: value,
            backupValue: value
          });
        });
      }

      if (isEditingMode !== prevProps.isEditingMode) {
        this.setState({
          isEditingMode: isEditingMode
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          textComponent = _this$props2.textComponent,
          name = _this$props2.name,
          value = _this$props2.value,
          _ = _this$props2.onChange,
          placeholderText = _this$props2.placeholderText,
          otherTextAreaProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["textComponent", "name", "value", "onChange", "placeholderText"]);
      var _this$state2 = this.state,
          isEditingMode = _this$state2.isEditingMode,
          currentValue = _this$state2.currentValue;
      var TextComponent = textComponent;
      var renderedValue = !currentValue || currentValue.length === 0 ? _react["default"].createElement(_Placeholder["default"], {
        secondary: true
      }, placeholderText) : currentValue;
      return _react["default"].createElement(Styles.Container, {
        onClick: this.handleOnClick,
        onBlur: this.handleSubmit,
        onKeyDown: this.handleOnKeyDown,
        isEditingMode: isEditingMode
      }, _react["default"].createElement(TextComponent, null, isEditingMode ? _react["default"].createElement(Styles.TextArea, (0, _extends2["default"])({
        autoFocus: true,
        id: name,
        value: currentValue,
        onChange: function onChange(event) {
          return _this2.setState({
            currentValue: event.target.value
          });
        }
      }, otherTextAreaProps)) : _react["default"].createElement(Styles.InnerValueWrapper, null, renderedValue)));
    }
  }]);
  return EditableTextArea;
}(_react["default"].PureComponent);

var _default = EditableTextArea;
exports["default"] = _default;