"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _HelpText = _interopRequireDefault(require("../../Form/HelpText"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _Button = _interopRequireDefault(require("../../Button"));

var _ICONS = _interopRequireDefault(require("../../../constants/ICONS"));

var _BUTTON = _interopRequireDefault(require("../../../constants/BUTTON"));

var Styles = _interopRequireWildcard(require("./Field.styles"));

var makeField = function makeField(Context) {
  var FilterField =
  /*#__PURE__*/
  function (_React$Component) {
    (0, _inherits2["default"])(FilterField, _React$Component);

    function FilterField(props, context) {
      var _this;

      (0, _classCallCheck2["default"])(this, FilterField);
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FilterField).call(this, props, context));
      var keyPath = props.keyPath,
          comparator = props.comparator,
          name = props.name;
      var _context$filterAdminF = context.filterAdminFunctions,
          registerFilterField = _context$filterAdminF.registerFilterField,
          handleAddFilter = _context$filterAdminF.handleAddFilter,
          handleRemoveFilter = _context$filterAdminF.handleRemoveFilter,
          isFilterApplied = _context$filterAdminF.isFilterApplied;
      _this.id = registerFilterField();
      _this.handleRemoveFilter = handleRemoveFilter(_this.id);
      _this.isFilterApplied = isFilterApplied(_this.id);
      _this.handleAddFilter = handleAddFilter(_this.id, comparator, keyPath, name);
      return _this;
    }

    (0, _createClass2["default"])(FilterField, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            helpText = _this$props.helpText,
            label = _this$props.label,
            icon = _this$props.icon,
            isCancelable = _this$props.isCancelable,
            disabled = _this$props.disabled;
        return _react["default"].createElement(Styles.Container, {
          disabled: disabled
        }, _react["default"].createElement(Styles.LabelWrapper, null, _react["default"].createElement(Styles.Label, null, label), helpText && _react["default"].createElement(_HelpText["default"], {
          helpText: helpText
        }), icon && _react["default"].createElement(_Icon["default"], {
          icon: icon
        })), _react["default"].createElement(Styles.FieldWrapper, null, this.props.children({
          handleRemoveFilter: this.handleRemoveFilter,
          handleAddFilter: this.handleAddFilter,
          isFilterApplied: this.isFilterApplied()
        })), isCancelable && this.isFilterApplied() && _react["default"].createElement(_Button["default"], {
          icon: _ICONS["default"].x,
          onClick: this.handleRemoveFilter,
          style: _BUTTON["default"].buttonStyles.naked
        }));
      }
    }]);
    return FilterField;
  }(_react["default"].Component);

  (0, _defineProperty2["default"])(FilterField, "contextType", Context);
  return FilterField;
};

var _default = makeField;
exports["default"] = _default;