"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _buildFilterFunction = require("./buildFilterFunction");

var _clearableConditions = require("./clearableConditions");

var _invalidValues = require("./invalidValues");

var _sanityCheck = require("./sanityCheck");

var _applyFilters = require("./applyFilters");

var makeFilter = function makeFilter(Context) {
  var _temp;

  return _temp =
  /*#__PURE__*/
  function (_React$Component) {
    (0, _inherits2["default"])(Filter, _React$Component);

    function Filter() {
      var _getPrototypeOf2;

      var _this;

      (0, _classCallCheck2["default"])(this, Filter);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Filter)).call.apply(_getPrototypeOf2, [this].concat(args)));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
        filters: [],
        filteredCollection: _this.props.collection
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getAppliedFiltersMeta", function () {
        return _this.state.filters.map(function (_ref) {
          var filterArgument = _ref.filterArgument,
              filterName = _ref.filterName,
              filterComparatorName = _ref.filterComparatorName;
          return {
            filterArgument: filterArgument,
            filterName: filterName,
            filterComparatorName: filterComparatorName
          };
        });
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterFields", []);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleApplyFilters", function (filters) {
        var collection = _this.props.collection;
        var filteredCollection = (0, _applyFilters.applyFilters)(collection, filters);

        _this.setState({
          filteredCollection: filteredCollection,
          filters: filters
        });
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleAddFilter", function (filterFieldId, filterComparator, filterKeyPathConfig, filterName) {
        return function (filterArgument) {
          if ((0, _invalidValues.isInvalidValue)(filterArgument, filterComparator)) {
            return;
          }

          if ((0, _sanityCheck.doesArgumentFailSanityCheck)(filterArgument, filterComparator)) {
            return;
          }

          if ((0, _clearableConditions.isClearableValue)(filterArgument)) {
            return _this.handleRemoveFilter(filterFieldId)();
          }

          var filters = _this.state.filters;
          var filterFn = (0, _buildFilterFunction.getFilterFn)(filterComparator, filterKeyPathConfig, filterArgument);
          var currentFilterIndex = filters.findIndex(function (_ref2) {
            var id = _ref2.filterFieldId;
            return id === filterFieldId;
          });

          if (currentFilterIndex !== -1) {
            var newFilters = [].concat((0, _toConsumableArray2["default"])(filters.slice(0, currentFilterIndex)), [{
              filterFn: filterFn,
              filterFieldId: filterFieldId,
              filterArgument: filterArgument,
              filterName: filterName,
              filterComparatorName: filterComparator.name
            }], (0, _toConsumableArray2["default"])(filters.slice(currentFilterIndex + 1)));

            _this.handleApplyFilters(newFilters);
          } else {
            _this.handleApplyFilters([].concat((0, _toConsumableArray2["default"])(filters), [{
              filterFn: filterFn,
              filterFieldId: filterFieldId,
              filterArgument: filterArgument,
              filterName: filterName,
              filterComparatorName: filterComparator.name
            }]));
          }
        };
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRemoveFilter", function (filterFieldId) {
        return function () {
          var filters = _this.state.filters;
          var newFilters = filters.filter(function (_ref3) {
            var id = _ref3.filterFieldId;
            return filterFieldId !== id;
          });

          _this.handleApplyFilters(newFilters);
        };
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRemoveAllFilters", function () {
        return _this.handleApplyFilters([]);
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "registerFilterField", function () {
        var filterFieldId = _this.filterFields.length + 1;
        _this.filterFields = [].concat((0, _toConsumableArray2["default"])(_this.filterFields), [filterFieldId]);
        return filterFieldId;
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isFilterApplied", function (candidateFilterId) {
        return function () {
          return _this.state.filters.some(function (_ref4) {
            var filterFieldId = _ref4.filterFieldId;
            return filterFieldId === candidateFilterId;
          });
        };
      });
      return _this;
    }

    (0, _createClass2["default"])(Filter, [{
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var collection = this.props.collection;

        if (collection !== prevProps.collection) {
          var filters = this.state.filters;
          this.handleApplyFilters(filters);
        }
      }
    }, {
      key: "render",
      value: function render() {
        var filteredCollection = this.state.filteredCollection;
        var filterAdminFunctions = {
          handleAddFilter: this.handleAddFilter,
          handleRemoveFilter: this.handleRemoveFilter,
          handleRemoveAllFilters: this.handleRemoveAllFilters,
          registerFilterField: this.registerFilterField,
          isFilterApplied: this.isFilterApplied,
          getAppliedFiltersMeta: this.getAppliedFiltersMeta
        };
        return _react["default"].createElement(Context.Provider, {
          value: {
            filteredCollection: filteredCollection,
            filterAdminFunctions: filterAdminFunctions
          }
        }, this.props.children);
      }
    }]);
    return Filter;
  }(_react["default"].Component), _temp;
};

var _default = makeFilter;
exports["default"] = _default;