"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isInvalidValue = void 0;

var _comparators = require("../comparators");

var _argumentTypeChecking = require("../argumentTypeChecking");

var isInvalidValue = function isInvalidValue(argument, comparator) {
  if (_comparators.stringComparators.includes(comparator)) {
    return !(0, _argumentTypeChecking.isString)(argument);
  }

  if (_comparators.numberComparators.includes(comparator)) {
    return !(0, _argumentTypeChecking.isNumber)(argument);
  }

  if (_comparators.dateComparators.includes(comparator)) {
    return !(0, _argumentTypeChecking.isDateObject)(argument);
  }

  if (_comparators.numberRangeComparators.includes(comparator) || _comparators.dateRangeComparators.includes(comparator)) {
    return !(0, _argumentTypeChecking.isArray)(argument) || (0, _argumentTypeChecking.isArray)(argument) && argument.length !== 2;
  }

  if (_comparators.arrayComparators.includes(comparator)) {
    if (!(0, _argumentTypeChecking.isArray)(argument)) {
      return true;
    }
  }

  return false;
};

exports.isInvalidValue = isInvalidValue;