"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sanityChecks = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _argumentTypeChecking = require("./argumentTypeChecking");

var _comparators = require("./comparators");

var _sanityChecks;

var sanityChecks = (_sanityChecks = {}, (0, _defineProperty2["default"])(_sanityChecks, _comparators.comparatorKeys.rangeInclusive, function (_ref) {
  var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      min = _ref2[0],
      max = _ref2[1];

  return (0, _argumentTypeChecking.areType)([min, max], _argumentTypeChecking.isNumber) && min > max;
}), (0, _defineProperty2["default"])(_sanityChecks, _comparators.comparatorKeys.rangeExclusive, function (_ref3) {
  var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
      min = _ref4[0],
      max = _ref4[1];

  return (0, _argumentTypeChecking.areType)([min, max], _argumentTypeChecking.isNumber) && min >= max;
}), (0, _defineProperty2["default"])(_sanityChecks, _comparators.comparatorKeys.dateRangeInclusive, function (_ref5) {
  var _ref6 = (0, _slicedToArray2["default"])(_ref5, 2),
      startDate = _ref6[0],
      endDate = _ref6[1];

  return (0, _argumentTypeChecking.areType)([startDate, endDate], _argumentTypeChecking.isDateObject) && startDate.getTime() > endDate.getTime();
}), (0, _defineProperty2["default"])(_sanityChecks, _comparators.comparatorKeys.dateRangeExclusive, function (_ref7) {
  var _ref8 = (0, _slicedToArray2["default"])(_ref7, 2),
      startDate = _ref8[0],
      endDate = _ref8[1];

  return (0, _argumentTypeChecking.areType)([startDate, endDate], _argumentTypeChecking.isDateObject) && startDate.getTime() >= endDate.getTime();
}), _sanityChecks);
exports.sanityChecks = sanityChecks;