"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stringToNumber = exports.getUniqueValues = exports.findValueFromPath = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var findValueFromPath = function findValueFromPath(_ref, candidate) {
  var _ref2 = (0, _toArray2["default"])(_ref),
      key = _ref2[0],
      path = _ref2.slice(1);

  if (key) {
    if (candidate[key] || candidate[key] === 0) {
      return findValueFromPath(path, candidate[key]);
    }

    return null;
  }

  return candidate;
};

exports.findValueFromPath = findValueFromPath;

var getUniqueValues = function getUniqueValues(collection, keyPath) {
  return (0, _toConsumableArray2["default"])(new Set(collection.map(function (candidate) {
    return findValueFromPath(keyPath, candidate);
  })));
};

exports.getUniqueValues = getUniqueValues;
var unwantedValidNumberStrings = [''];

var stringToNumber = function stringToNumber(candidateString) {
  if (unwantedValidNumberStrings.includes(candidateString)) {
    return null;
  }

  var candidateAsNumber = Number(candidateString);

  if (Number.isNaN(candidateAsNumber)) {
    return null;
  }

  return candidateAsNumber;
};

exports.stringToNumber = stringToNumber;