"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("../../Button"));

var _tokens = require("../../../tokens");

var FormButton = function FormButton(_ref) {
  var _ref$formState = _ref.formState,
      invalid = _ref$formState.invalid,
      submitting = _ref$formState.submitting,
      dirty = _ref$formState.dirty,
      submitOnClick = _ref.submitOnClick,
      submittingText = _ref.submittingText,
      defaultText = _ref.defaultText,
      buttonProps = (0, _objectWithoutProperties2["default"])(_ref, ["formState", "submitOnClick", "submittingText", "defaultText"]);
  return _react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    "data-qa-id": "Form__Button" // Default button props
    ,
    size: _tokens.ButtonConstants.sizes.medium,
    style: _tokens.ButtonConstants.styles.filled,
    color: _tokens.ButtonConstants.colors.primary // Override defaults

  }, buttonProps, {
    // Set required button props
    disabled: invalid || submitting || !submitOnClick && dirty,
    type: submitOnClick ? 'submit' : 'button',
    text: submitting && submittingText ? submittingText : defaultText,
    mixins: ['margin: 0 5px;']
  }));
};

var _default = FormButton;
exports["default"] = _default;