"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Tooltip = require("../Tooltip");

var _Icon = _interopRequireDefault(require("../Icon"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _ICONS = _interopRequireDefault(require("../../constants/ICONS"));

var IconWithTooltip = (0, _Tooltip.withTooltip)(_Icon["default"]);

var Wrapper = _styledComponents["default"].div.withConfig({
  displayName: "HelpText__Wrapper",
  componentId: "sc-3xxryy-0"
})(["border-radius:50%;background-color:", ";height:14px;width:14px;display:flex;align-items:center;& .SML-TooltipWrapper{height:14px;width:14px;display:flex;align-items:center;}"], _tokens["default"].form.help.color);

var HelperIconWithToolTip = function HelperIconWithToolTip(_ref) {
  var helpText = _ref.helpText,
      interactive = _ref.interactive;
  return _react["default"].createElement(Wrapper, null, _react["default"].createElement(IconWithTooltip, {
    color: _tokens["default"].form.help.backgroundColor,
    size: 14,
    icon: _ICONS["default"].help,
    tooltipText: helpText,
    mixins: ['cursor: pointer;'],
    interactive: interactive
  }));
};

var HelpText = function HelpText(_ref2) {
  var helpText = _ref2.helpText,
      helpTextLink = _ref2.helpTextLink,
      _ref2$interactive = _ref2.interactive,
      interactive = _ref2$interactive === void 0 ? false : _ref2$interactive;
  return helpTextLink ? _react["default"].createElement(_reactRouterDom.Link, {
    to: helpTextLink,
    target: "_blank"
  }, _react["default"].createElement(HelperIconWithToolTip, {
    helpText: helpText,
    interactive: interactive
  })) : _react["default"].createElement(HelperIconWithToolTip, {
    helpText: helpText,
    interactive: interactive
  });
};

var _default = HelpText;
exports["default"] = _default;