"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

var asField = function asField(WrappedComponent) {
  var AsField = function AsField(_ref) {
    var _ref$input = _ref.input,
        name = _ref$input.name,
        value = _ref$input.value,
        onBlur = _ref$input.onBlur,
        onFocus = _ref$input.onFocus,
        onChange = _ref$input.onChange,
        _ref$meta = _ref.meta,
        error = _ref$meta.error,
        touched = _ref$meta.touched,
        otherProps = (0, _objectWithoutProperties2["default"])(_ref, ["input", "meta"]);

    var handleOnChange = function handleOnChange() {
      otherProps.onChange && typeof otherProps.onChange === 'function' && otherProps.onChange.apply(otherProps, arguments);
      onChange.apply(void 0, arguments);
    };

    return _react["default"].createElement(WrappedComponent, (0, _extends2["default"])({
      name: name,
      value: value,
      onBlur: onBlur,
      onFocus: onFocus,
      onChange: handleOnChange,
      error: touched && error,
      touched: touched
    }, otherProps));
  };

  AsField.displayName = "AsField(".concat(getDisplayName(WrappedComponent), ")");
  return AsField;
};

var _default = asField;
exports["default"] = _default;