"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyledSVG = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _ButtonWrapper = _interopRequireDefault(require("../Button/ButtonWrapper"));

var _MenuItemStyles = _interopRequireDefault(require("../Dropdown/MenuItem/MenuItemStyles"));

var StyledSVG = _styledComponents["default"].svg.withConfig({
  displayName: "Icon__StyledSVG",
  componentId: "i1qv1f-0"
})(["display:inline-block;vertical-align:middle;", " ", " fill:", ";&:hover{", "}}}", " &{margin-right:5px;}", " &:not(:only-child),", " &:not(:only-child){margin-right:10px;}", ":hover &,", ":hover &{fill:", ";}", ""], function (props) {
  return "\n    width: ".concat(props.size, "px;\n    min-width: ").concat(props.size, "px;\n    max-width: ").concat(props.size, "px;\n  ");
}, function (props) {
  return "\n    height: ".concat(props.size, "px;\n    min-height: ").concat(props.size, "px;\n    max-height: ").concat(props.size, "px;\n  ");
}, function (props) {
  var active = props.active,
      activeColor = props.activeColor,
      color = props.color;
  return active && activeColor ? activeColor : color;
}, function (_ref) {
  var noHover = _ref.noHover,
      activeColor = _ref.activeColor,
      color = _ref.color;
  return noHover ? '' : "fill: ".concat(activeColor ? activeColor : color);
}, _MenuItemStyles["default"].Left, _ButtonWrapper["default"].link, _ButtonWrapper["default"].button, _ButtonWrapper["default"].link, _ButtonWrapper["default"].button, function (props) {
  var activeColor = props.activeColor,
      color = props.color;
  return activeColor ? activeColor : color;
}, function (props) {
  return props.mixins;
});

exports.StyledSVG = StyledSVG;

var Icon = function Icon(_ref2) {
  var _ref2$icon = _ref2.icon,
      paths = _ref2$icon.paths,
      rects = _ref2$icon.rects,
      viewBox = _ref2$icon.viewBox,
      gs = _ref2$icon.gs,
      size = _ref2.size,
      color = _ref2.color,
      active = _ref2.active,
      activeColor = _ref2.activeColor,
      mixins = _ref2.mixins,
      noHover = _ref2.noHover,
      otherProps = (0, _objectWithoutProperties2["default"])(_ref2, ["icon", "size", "color", "active", "activeColor", "mixins", "noHover"]);
  return _react["default"].createElement(StyledSVG, (0, _extends2["default"])({
    className: "SML-Icon",
    size: size,
    color: color,
    active: active,
    activeColor: activeColor,
    viewBox: viewBox,
    mixins: mixins,
    noHover: noHover
  }, otherProps), paths.map(function (pathAttributes, idx) {
    return _react["default"].createElement("path", (0, _extends2["default"])({
      key: "icon-path-".concat(idx)
    }, pathAttributes));
  }), rects.map(function (rectAttributes, idx) {
    return _react["default"].createElement("rect", (0, _extends2["default"])({
      key: "icon-rect-".concat(idx)
    }, rectAttributes));
  }), gs.map(function (_ref3, gIdx) {
    var gPaths = _ref3.paths,
        gRects = _ref3.rects,
        attributes = _ref3.attributes;
    return _react["default"].createElement("g", (0, _extends2["default"])({
      key: "icon-g-".concat(gIdx)
    }, attributes), gPaths.map(function (pathAttributes, pathIdx) {
      return _react["default"].createElement("path", (0, _extends2["default"])({
        key: "icon-g-path-".concat(gIdx, "-").concat(pathIdx)
      }, pathAttributes));
    }), gRects.map(function (rectAttributes, rectIdx) {
      return _react["default"].createElement("rect", (0, _extends2["default"])({
        key: "icon-g-path-".concat(gIdx, "-").concat(rectIdx)
      }, rectAttributes));
    }));
  }));
};

Icon.defaultProps = {
  size: 16,
  color: _tokens["default"].colors.secondary900,
  active: false,
  mixins: []
};
var _default = Icon;
exports["default"] = _default;