"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _ErrorText = _interopRequireDefault(require("../Typography/ErrorText"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _InputStyles = _interopRequireDefault(require("./InputStyles"));

var Input =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(Input, _React$Component);

  function Input() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Input);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Input)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      hasFocus: false,
      selected: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRef", function (ref) {
      var shouldSelect = _this.props.shouldSelect;
      var selected = _this.state.selected;
      _this.input = ref;

      if (_this.input && !selected && shouldSelect) {
        _this.input.select();

        _this.setState({
          selected: true
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focus", function () {
      _this.input && _this.input.focus();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setSelectionRange", function (start, end) {
      _this.input && _this.input.setSelectionRange(start, end);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnFocus", function (event) {
      _this.props.onFocus(event);

      _this.setState({
        hasFocus: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnBlur", function (event) {
      _this.props.onBlur(event);

      _this.setState({
        hasFocus: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyPress", function (event) {
      _this.props.onKeyPress(event);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (event) {
      var _this$props = _this.props,
          type = _this$props.type,
          onChange = _this$props.onChange;

      if (type === 'file') {
        onChange(event);
      } else {
        onChange(event.target.value);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isValidErrorString", function () {
      var error = _this.props.error;
      return typeof error === 'string' && error.length > 0;
    });
    return _this;
  }

  (0, _createClass2["default"])(Input, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          type = _this$props2.type,
          icon = _this$props2.icon,
          small = _this$props2.small,
          autoFocus = _this$props2.autoFocus,
          placeholder = _this$props2.placeholder,
          autoComplete = _this$props2.autoComplete,
          name = _this$props2.name,
          value = _this$props2.value,
          touched = _this$props2.touched,
          error = _this$props2.error,
          disabled = _this$props2.disabled,
          multiple = _this$props2.multiple,
          isCodeInput = _this$props2.isCodeInput;
      var hasFocus = this.state.hasFocus;
      var hasIcon = Boolean(icon);
      var touchedAndError = touched && Boolean(error);
      return _react["default"].createElement(_InputStyles["default"].Container, null, _react["default"].createElement(_InputStyles["default"].InputWrapper, {
        small: small
      }, hasIcon && _react["default"].createElement(_InputStyles["default"].Icon, {
        hasError: touchedAndError,
        hasFocus: hasFocus
      }, _react["default"].createElement(_Icon["default"], {
        icon: icon,
        color: _tokens["default"].input.icon.color,
        size: 16
      })), _react["default"].createElement(_InputStyles["default"].Input, {
        ref: this.handleRef,
        small: small,
        hasIcon: hasIcon,
        hasFocus: hasFocus,
        hasError: touchedAndError,
        value: type === 'file' ? undefined : value,
        autoComplete: autoComplete,
        autoFocus: autoFocus,
        placeholder: placeholder,
        onFocus: this.handleOnFocus,
        onBlur: this.handleOnBlur,
        onChange: this.handleChange,
        onKeyPress: this.handleKeyPress,
        type: type,
        name: name,
        id: name,
        disabled: disabled,
        multiple: multiple,
        isCodeInput: isCodeInput
      })), touchedAndError && this.isValidErrorString() && _react["default"].createElement(_InputStyles["default"].Error, null, _react["default"].createElement(_ErrorText["default"], null, error)));
    }
  }]);
  return Input;
}(_react["default"].Component);

exports["default"] = Input;
(0, _defineProperty2["default"])(Input, "defaultProps", {
  small: false,
  onChange: function onChange() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {},
  onKeyPress: function onKeyPress() {}
});