"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var getHeight = function getHeight(_ref) {
  var small = _ref.small;
  return small ? '25px' : '35px';
};

var getFontSize = function getFontSize(_ref2) {
  var small = _ref2.small;
  return small ? _tokens["default"].input.text.size.small : _tokens["default"].input.text.size["default"];
};

var getFontFamily = function getFontFamily(_ref3) {
  var isCodeInput = _ref3.isCodeInput;
  return isCodeInput ? _tokens["default"].fonts.family.code : _tokens["default"].fonts.family["default"];
};

var getBorderColor = function getBorderColor(props) {
  if (props.hasError) {
    return _tokens["default"].input.border.color.error;
  } else if (props.hasFocus) {
    return _tokens["default"].input.border.color.active;
  }

  return _tokens["default"].input.border.color["default"];
};

var Container = _styledComponents["default"].div.withConfig({
  displayName: "InputStyles__Container",
  componentId: "sc-166gwdj-0"
})(["display:flex;flex-direction:column;"]);

var InputWrapper = _styledComponents["default"].div.withConfig({
  displayName: "InputStyles__InputWrapper",
  componentId: "sc-166gwdj-1"
})(["display:flex;flex-direction:row;height:", ";background-color:", ";box-shadow:0 2px 4px 0 ", ";"], getHeight, _tokens["default"].input.background.color, _tokens["default"].input.boxShadow.color);

var Icon = _styledComponents["default"].div.withConfig({
  displayName: "InputStyles__Icon",
  componentId: "sc-166gwdj-2"
})(["display:flex;align-items:center;justify-content:center;height:100%;padding:0 10px;border:1px solid ", ";border-right:none;box-sizing:border-box;"], getBorderColor);

var Input = _styledComponents["default"].input.withConfig({
  displayName: "InputStyles__Input",
  componentId: "sc-166gwdj-3"
})(["box-sizing:border-box;font-family:", ";font-size:", ";color:", ";border:1px solid ", ";border-color:", ";height:100%;width:100%;flex-grow:1;padding:0;", " &:focus{outline:none;}&::placeholder{color:", ";}"], getFontFamily, getFontSize, _tokens["default"].input.text.color, _tokens["default"].input.border.color["default"], getBorderColor, function (props) {
  return props.hasIcon ? 'border-left: none;' : 'padding-left: 10px;';
}, _tokens["default"].input.placeholder.color);

var Error = _styledComponents["default"].div.withConfig({
  displayName: "InputStyles__Error",
  componentId: "sc-166gwdj-4"
})(["width:100%;margin-top:5px;box-sizing:border-box;"]);

Error.displayName = 'Input__Error';
var _default = {
  Container: Container,
  InputWrapper: InputWrapper,
  Icon: Icon,
  Input: Input,
  Error: Error
};
exports["default"] = _default;