"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _color = _interopRequireDefault(require("color"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _ANIMATIONS = _interopRequireDefault(require("../../constants/ANIMATIONS"));

var _LabelText = _interopRequireDefault(require("./LabelText"));

var getColor = function getColor(props) {
  if (props.danger || props.error) {
    return _tokens["default"].label.color.danger;
  } else if (props.warning) {
    return _tokens["default"].label.color.warning;
  } else if (props.success) {
    return _tokens["default"].label.color.success;
  } else if (props.secondary) {
    return _tokens["default"].label.color.secondary;
  } else if (props.brand || props.primary) {
    return _tokens["default"].label.color.brand;
  } else if (props.color) {
    return props.color;
  }

  return _tokens["default"].label.color.secondary;
};

var FlexWrapper = _styledComponents["default"].div.withConfig({
  displayName: "Label__FlexWrapper",
  componentId: "sc-1ch96jj-0"
})(["", ""], function (_ref) {
  var fitWidth = _ref.fitWidth;
  return fitWidth ? '' : 'display: flex;';
});

var StyledDiv = _styledComponents["default"].div.withConfig({
  displayName: "Label__StyledDiv",
  componentId: "sc-1ch96jj-1"
})(["align-items:center;border-radius:13.5px;display:flex;justify-content:center;vertical-align:baseline;white-space:nowrap;box-sizing:border-box;height:", ";border:", ";padding:", ";background-color:", ";", " ", ""], function (_ref2) {
  var multiLine = _ref2.multiLine;
  return multiLine ? 'fit-content' : '20px';
}, function (props) {
  return props.inverse ? "1px solid ".concat(getColor(props)) : 'none';
}, function (_ref3) {
  var multiLine = _ref3.multiLine;
  return multiLine ? '5px 10px' : '0 10px';
}, function (props) {
  return props.inverse ? 'none' : (0, _color["default"])(getColor(props)).alpha(0.2).hsl().string();
}, function (props) {
  return props.flashing && _ANIMATIONS["default"].blinker((0, _objectSpread2["default"])({
    color: getColor(props)
  }, props.flashingConfig));
}, function (props) {
  return props.mixins;
});

var Label = function Label(props) {
  if (props.naked) {
    return _react["default"].createElement(_LabelText["default"], {
      naked: true,
      inverse: true,
      color: getColor((0, _objectSpread2["default"])({}, props)),
      capitalise: props.capitalise,
      multiLine: props.multiLine,
      "data-qa-id": props['data-qa-id']
    }, props.multiLine && typeof props.children === 'string' ? props.children.split(' ').map(function (c) {
      return _react["default"].createElement("span", null, c);
    }) : props.children);
  } // eslint-disable-next-line no-unused-vars


  var onClick = props.onClick,
      propsOnClickRemoved = (0, _objectWithoutProperties2["default"])(props, ["onClick"]);
  return _react["default"].createElement(FlexWrapper, {
    fitWidth: props.fitWidth
  }, _react["default"].createElement(StyledDiv, props, _react["default"].createElement(_LabelText["default"], propsOnClickRemoved, props.multiLine && typeof props.children === 'string' ? props.children.split(' ').map(function (c) {
    return _react["default"].createElement("span", null, c);
  }) : props.children)));
};

Label.defaultProps = {
  flashingConfig: {},
  mixins: []
};
var _default = Label;
exports["default"] = _default;