"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var getColor = function getColor(props) {
  if (props.danger || props.error) {
    return _tokens["default"].label.text.color.danger;
  } else if (props.warning) {
    return _tokens["default"].label.text.color.warning;
  } else if (props.success) {
    return _tokens["default"].label.text.color.success;
  } else if (props.secondary) {
    return _tokens["default"].label.text.color.secondary;
  } else if (props.brand || props.primary) {
    return _tokens["default"].label.text.color.brand;
  } else if (props.color) {
    return props.color;
  }

  return _tokens["default"].label.text.color.secondary;
};

var StyledSpan = _styledComponents["default"].span.withConfig({
  displayName: "LabelText__StyledSpan",
  componentId: "m5zenf-0"
})(["font-family:", ";font-size:", ";font-weight:", ";color:", ";", " ", " ", ""], _tokens["default"].label.text.family, _tokens["default"].label.text.size, _tokens["default"].label.text.weight, function (props) {
  return getColor(props);
}, function (_ref) {
  var naked = _ref.naked;
  return naked ? '' : 'text-align: center;';
}, function (props) {
  return props.multiLine ? "\n    display: flex;\n    flex-direction: column;\n  " : '';
}, function (props) {
  return props.capitalise ? "\n    text-transform: uppercase;\n  " : '';
});

var LabelText = function LabelText(props) {
  return _react["default"].createElement(StyledSpan, props);
};

var _default = LabelText;
exports["default"] = _default;