"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactRouter = require("react-router");

var _NavbarItem = _interopRequireDefault(require("../NavbarItem"));

var Styles = _interopRequireWildcard(require("./NavbarGroup.styles"));

var NavbarGroup =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(NavbarGroup, _React$Component);

  function NavbarGroup(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, NavbarGroup);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(NavbarGroup).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnClick", function () {
      var pathname = _this.props.location.pathname;

      if (!pathname.startsWith(_this.path)) {
        _this.setState({
          showNestedItems: true
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleNestedItems", function () {
      _this.setState(function (prevState) {
        return {
          showNestedItems: !prevState.showNestedItems
        };
      });
    });
    _this.state = {
      showNestedItems: props.location.pathname.startsWith(_this.path)
    };
    return _this;
  }

  (0, _createClass2["default"])(NavbarGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          icon = _this$props.icon,
          iconSize = _this$props.iconSize,
          iconColor = _this$props.iconColor,
          label = _this$props.label,
          expanded = _this$props.expanded,
          closeNavbar = _this$props.closeNavbar,
          hightlightOnHover = _this$props.hightlightOnHover,
          children = _this$props.children,
          pathname = _this$props.location.pathname;
      var showNestedItems = this.state.showNestedItems;
      return _react["default"].createElement(Styles.NavbarGroup, {
        "data-qa-id": "NavbarGroup"
      }, _react["default"].createElement(_NavbarItem["default"], {
        groupHeader: true,
        inContentBlock: true,
        icon: icon,
        iconSize: iconSize,
        iconColor: iconColor,
        label: label,
        path: this.path,
        expanded: expanded,
        closeNavbar: this.handleOnClick,
        showNestedItems: showNestedItems,
        toggleNestedItems: this.toggleNestedItems
      }), showNestedItems && _react["default"].Children.map(children, function (child) {
        return _react["default"].cloneElement(child, {
          inContentBlock: true,
          hightlightOnHover: hightlightOnHover,
          expanded: expanded,
          closeNavbar: closeNavbar,
          nested: true
        });
      }));
    }
  }, {
    key: "path",
    get: function get() {
      var children = this.props.children;

      var pathArray = _react["default"].Children.map(children, function (child) {
        return child.props.path;
      });

      var A = pathArray.concat().sort();
      var a1 = A[0];
      var a2 = A[A.length - 1];
      var L = a1.length;
      var i = 0;

      while (i < L && a1.charAt(i) === a2.charAt(i)) {
        i++;
      }

      var commonPath = a1.substring(0, i);
      return commonPath.split('/').slice(0, -1).join('/');
    }
  }]);
  return NavbarGroup;
}(_react["default"].Component);

var _default = (0, _reactRouter.withRouter)(NavbarGroup);

exports["default"] = _default;