"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToggleChevron = exports.Expanded = exports.Collapsed = exports.NavbarItemExternalLink = exports.NavbarItemLink = exports.NavbarItemDiv = exports.ActiveItem = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactRouterDom = require("react-router-dom");

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _navbar = require("../../../tokens/navbar");

var _constants = require("../constants.styles");

var navbarItemMargin = 10;
var activeBorderWidth = 4;

var navbarItemRadius = function navbarItemRadius(nested, expanded, iconSize) {
  return (_constants.collapsedWidth - navbarItemMargin * 2 - iconSize) / 2 + (nested && expanded ? 25 : 0);
};

var ActiveItem = _styledComponents["default"].span.withConfig({
  displayName: "NavbarItemstyles__ActiveItem",
  componentId: "sc-1wh43gj-0"
})(["height:23px;width:", "px;min-width:", "px;margin-right:", "px;box-sizing:border-box;", ""], activeBorderWidth, activeBorderWidth, navbarItemMargin, function (_ref) {
  var activePath = _ref.activePath,
      groupHeader = _ref.groupHeader,
      showNestedItems = _ref.showNestedItems,
      hightlightOnHover = _ref.hightlightOnHover;
  return (!groupHeader || !showNestedItems) && hightlightOnHover && activePath ? "\n    border-left: ".concat(activeBorderWidth, "px solid ").concat(_tokens["default"].colors.brand500, ";\n  ") : '';
});

exports.ActiveItem = ActiveItem;
var NavbarItemBase = (0, _styledComponents.css)(["display:flex;align-items:center;text-decoration:none;position:relative;cursor:pointer;padding:", "px 0;margin-right:", "px;", ""], function (_ref2) {
  var nested = _ref2.nested,
      iconSize = _ref2.iconSize;
  return (40 - iconSize) / 2 - (nested ? 5 : 0) - 4;
}, navbarItemMargin, function (_ref3) {
  var hightlightOnHover = _ref3.hightlightOnHover;
  return !hightlightOnHover ? '' : "\n    &:hover {\n      & svg {\n        fill: ".concat(_tokens["default"].navbar.item.color.active, ";\n      }\n    }\n  ");
});

var NavbarItemDiv = _styledComponents["default"].div.withConfig({
  displayName: "NavbarItemstyles__NavbarItemDiv",
  componentId: "sc-1wh43gj-1"
})(["", ""], NavbarItemBase);

exports.NavbarItemDiv = NavbarItemDiv;
var NavbarItemLink = (0, _styledComponents["default"])(_reactRouterDom.NavLink).withConfig({
  displayName: "NavbarItemstyles__NavbarItemLink",
  componentId: "sc-1wh43gj-2"
})(["", ""], NavbarItemBase);
exports.NavbarItemLink = NavbarItemLink;

var NavbarItemExternalLink = _styledComponents["default"].a.withConfig({
  displayName: "NavbarItemstyles__NavbarItemExternalLink",
  componentId: "sc-1wh43gj-3"
})(["", ""], NavbarItemBase);

exports.NavbarItemExternalLink = NavbarItemExternalLink;

var Collapsed = _styledComponents["default"].div.withConfig({
  displayName: "NavbarItemstyles__Collapsed",
  componentId: "sc-1wh43gj-4"
})(["margin-left:", "px;width:", "px;", ""], function (_ref4) {
  var nested = _ref4.nested,
      expanded = _ref4.expanded,
      iconSize = _ref4.iconSize;
  return navbarItemRadius(nested, expanded, iconSize) - 4;
}, function (_ref5) {
  var nested = _ref5.nested,
      expanded = _ref5.expanded,
      iconSize = _ref5.iconSize;
  return (nested ? 20 : 40) - navbarItemRadius(nested, expanded, iconSize);
}, _constants.marginAnimation);

exports.Collapsed = Collapsed;

var Expanded = _styledComponents["default"].div.withConfig({
  displayName: "NavbarItemstyles__Expanded",
  componentId: "sc-1wh43gj-5"
})(["display:flex;align-items:center;overflow:hidden;white-space:nowrap;margin-left:5px;width:", ";font-size:", "px;font-weight:", ";font-family:", ";color:", ";", ":hover &{color:", ";}", ":hover &{color:", ";}", ":hover &{color:", ";}", ""], function (_ref6) {
  var expanded = _ref6.expanded;
  return expanded ? 'auto' : '0%';
}, function (_ref7) {
  var nested = _ref7.nested;
  return nested ? 10 : 12;
}, _tokens["default"].navbar.item.text.weight, _tokens["default"].navbar.item.text.family, function (_ref8) {
  var inContentBlock = _ref8.inContentBlock,
      activePath = _ref8.activePath;
  return (0, _navbar.getItemColor)(inContentBlock, activePath);
}, NavbarItemDiv, _tokens["default"].navbar.item.color.active, NavbarItemLink, _tokens["default"].navbar.item.color.active, NavbarItemExternalLink, _tokens["default"].navbar.item.color.active, _constants.widthAnimation);

exports.Expanded = Expanded;

var ToggleChevron = function ToggleChevron(showNestedItems) {
  return (0, _styledComponents.css)(["cursor:pointer;margin-left:10px;transition:transform 0.2s ease-out;", ""], showNestedItems ? 'transform: rotate(90deg);' : '');
};

exports.ToggleChevron = ToggleChevron;