"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var overlayRoot = document.body;

var OverlayTrigger =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(OverlayTrigger, _React$Component);

  function OverlayTrigger(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, OverlayTrigger);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(OverlayTrigger).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      overlay: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOutside", function (event) {
      var targetRect = _this.state.targetRect;

      if (targetRect) {
        var x = event.clientX;
        var y = event.clientY;

        var tooltipRect = _this.el.childNodes[0].getBoundingClientRect();

        var top = Math.min(targetRect.top, tooltipRect.top);
        var left = Math.min(targetRect.left, tooltipRect.left);
        var bottom = Math.max(targetRect.bottom, tooltipRect.bottom);
        var right = Math.max(targetRect.right, tooltipRect.right);

        if (y < top || y > bottom || x < left || x > right) {
          _this.hideOverlay();
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "showOverlay", function (targetRect) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          interactive = _this$props.interactive;

      if (!disabled) {
        interactive && document.addEventListener('mousemove', _this.handleMouseOutside);
        overlayRoot && overlayRoot.appendChild(_this.el);

        _this.setState({
          targetRect: targetRect
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hideOverlay", function () {
      var interactive = _this.props.interactive;
      interactive && document.removeEventListener('mousemove', _this.handleMouseOutside);

      _this.setState({
        targetRect: null
      }, function () {
        overlayRoot && overlayRoot.contains(_this.el) && overlayRoot.removeChild(_this.el);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerProps", function () {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          interactive = _this$props2.interactive;

      if (!disabled) {
        var baseProps = {
          onMouseEnter: function onMouseEnter(event) {
            var targetRect = event.currentTarget.getBoundingClientRect();

            _this.showOverlay(targetRect);
          }
        };
        return interactive ? baseProps : (0, _objectSpread2["default"])({}, baseProps, {
          onMouseLeave: function onMouseLeave() {
            return _this.hideOverlay();
          }
        });
      }

      return {};
    });
    _this.el = document.createElement('div');
    return _this;
  }

  (0, _createClass2["default"])(OverlayTrigger, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.hideOverlay();
    }
  }, {
    key: "render",
    value: function render() {
      var disabled = this.props.disabled;

      if (this.state.targetRect && !disabled) {
        return [this.props.render(this.triggerProps()), _reactDom["default"].createPortal(this.props.renderOverlay(this.state.targetRect), this.el)];
      }

      return this.props.render(this.triggerProps());
    }
  }]);
  return OverlayTrigger;
}(_react["default"].Component);

exports["default"] = OverlayTrigger;