"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Prompt;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _Button = _interopRequireDefault(require("../../components/Button"));

var _Checkbox = _interopRequireDefault(require("../../components/Checkbox"));

var _Icon = _interopRequireDefault(require("../../components/Icon"));

var _Text = _interopRequireDefault(require("../../components/Typography/Text"));

var _ICONS = _interopRequireDefault(require("../../constants/ICONS"));

var _tokens = _interopRequireWildcard(require("../../tokens"));

var _PromptStyles = _interopRequireDefault(require("./PromptStyles"));

var ESCAPE = 27;
var promptRoot = document.body;

var createBodyChildren = function createBodyChildren(content) {
  if (Array.isArray(content)) {
    return content.map(function (line, idx, _ref) {
      var length = _ref.length;
      return _react["default"].createElement(_PromptStyles["default"].ContentLine, {
        key: idx,
        initial: idx === 0,
        "final": idx === length - 1
      }, typeof line === 'string' ? _react["default"].createElement(_Text["default"], {
        secondary: true,
        big: true
      }, line) : line);
    });
  }

  return typeof content === 'string' ? _react["default"].createElement(_Text["default"], {
    secondary: true,
    big: true
  }, content) : content;
};

var PromptBody =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(PromptBody, _React$Component);

  function PromptBody(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, PromptBody);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(PromptBody).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePerseverance", function () {
      _this.setState(function (_ref2) {
        var perseveranceToggleValue = _ref2.perseveranceToggleValue;
        return {
          perseveranceToggleValue: !perseveranceToggleValue
        };
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setPromptRef", function (node) {
      _this.promptRef = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickOutside", function (event) {
      var _this$props = _this.props,
          show = _this$props.show,
          onHide = _this$props.onHide;

      if (show && _this.promptRef && !_this.promptRef.contains(event.target)) {
        onHide();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyPress", function (event) {
      var onHide = _this.props.onHide;

      if (event.keyCode === ESCAPE) {
        onHide();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleConfirmation", function () {
      var _this$props2 = _this.props,
          onHide = _this$props2.onHide,
          confirmationFunction = _this$props2.confirmationFunction,
          setPerseverance = _this$props2.setPerseverance,
          allowPerseverance = _this$props2.allowPerseverance;
      var perseveranceToggleValue = _this.state.perseveranceToggleValue;
      onHide();
      confirmationFunction();
      allowPerseverance && setPerseverance && setPerseverance(perseveranceToggleValue);
    });
    _this.el = document.createElement('div');
    promptRoot && promptRoot.appendChild(_this.el);
    _this.state = {
      perseveranceToggleValue: Boolean(props.perseverance)
    };
    return _this;
  }

  (0, _createClass2["default"])(PromptBody, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var perseverance = this.props.perseverance;

      if (perseverance) {
        this.handleConfirmation();
      } else {
        document.addEventListener('mousedown', this.handleClickOutside);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('mousedown', this.handleClickOutside);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          show = _this$props3.show,
          onHide = _this$props3.onHide,
          header = _this$props3.header,
          content = _this$props3.content,
          extraContent = _this$props3.extraContent,
          confirmationButtonText = _this$props3.confirmationButtonText,
          confirmationButtonIcon = _this$props3.confirmationButtonIcon,
          customConfirmationButtonColor = _this$props3.customConfirmationButtonColor,
          perseverance = _this$props3.perseverance,
          allowPerseverance = _this$props3.allowPerseverance,
          warning = _this$props3.warning;
      var perseveranceToggleValue = this.state.perseveranceToggleValue;
      var bodyChildren = createBodyChildren(content);

      if (show && !perseverance) {
        return _reactDom["default"].createPortal(_react["default"].createElement(_PromptStyles["default"].Container, {
          onKeyPress: this.handleKeyPress
        }, _react["default"].createElement(_PromptStyles["default"].Wrapper, {
          ref: this.setPromptRef
        }, _react["default"].createElement(_PromptStyles["default"].Header, {
          "data-qa-id": "Prompt__Header"
        }, _react["default"].createElement(_PromptStyles["default"].HeaderText, null, header), _react["default"].createElement(_PromptStyles["default"].HeaderCancel, null, _react["default"].createElement(_Button["default"], {
          icon: _ICONS["default"].x,
          onClick: onHide,
          style: _tokens.ButtonConstants.styles.naked,
          color: _tokens.ButtonConstants.colors.danger
        }))), _react["default"].createElement(_PromptStyles["default"].Body, {
          "data-qa-id": "Prompt__Body"
        }, _react["default"].createElement(_PromptStyles["default"].DefaultRow, null, warning && _react["default"].createElement(_PromptStyles["default"].Icon, null, _react["default"].createElement(_Icon["default"], {
          icon: _ICONS["default"].alert,
          size: 60,
          color: _tokens["default"].prompt.body.alert.color
        })), _react["default"].createElement(_PromptStyles["default"].BodyContent, {
          "data-qa-id": "Prompt__Body-Content"
        }, bodyChildren)), !!extraContent && _react["default"].createElement(_PromptStyles["default"].ExtraContent, {
          "data-qa-id": "Prompt__Body-ExtraContent"
        }, extraContent)), _react["default"].createElement(_PromptStyles["default"].Footer, {
          "data-qa-id": "Prompt__Footer"
        }, _react["default"].createElement(_Button["default"], {
          text: confirmationButtonText,
          onClick: this.handleConfirmation,
          icon: confirmationButtonIcon,
          color: customConfirmationButtonColor || _tokens.ButtonConstants.colors[warning ? 'danger' : 'primary']
        }), allowPerseverance && _react["default"].createElement(_PromptStyles["default"].CheckboxContainer, {
          onClick: this.togglePerseverance
        }, _react["default"].createElement(_Checkbox["default"], {
          checked: perseveranceToggleValue,
          handleStateExternally: true,
          onChange: this.togglePerseverance
        }), _react["default"].createElement(_PromptStyles["default"].CheckboxText, null, "Do not show this message again"))))), this.el);
      }

      return null;
    }
  }]);
  return PromptBody;
}(_react["default"].Component);

(0, _defineProperty2["default"])(PromptBody, "defaultProps", {
  warning: true
});

function Prompt(props) {
  return _react["default"].createElement(PromptBody, (0, _extends2["default"])({
    key: props.id
  }, props));
}