"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var Container = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__Container",
  componentId: "sc-1x201y6-0"
})(["position:fixed;top:0;left:0;height:100%;width:100vw;background-color:", ";overflow:hidden;z-index:99999999;display:flex;justify-content:center;"], _tokens["default"].prompt.mask.color);

var Wrapper = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__Wrapper",
  componentId: "sc-1x201y6-1"
})(["min-height:225px;display:flex;flex-direction:column;width:660px;margin-top:30px;"]);

var Header = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__Header",
  componentId: "sc-1x201y6-2"
})(["background-color:", ";display:flex;justify-content:space-between;align-items:center;padding:15px;"], _tokens["default"].prompt.header.background.color);

var HeaderText = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__HeaderText",
  componentId: "sc-1x201y6-3"
})(["color:", ";font-family:", ";font-size:", ";font-weight:", ";letter-spacing:0.5px;word-break:break-all;"], _tokens["default"].prompt.header.text.color, _tokens["default"].prompt.header.text.family, _tokens["default"].prompt.header.text.size, _tokens["default"].prompt.header.text.weight);

var HeaderCancel = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__HeaderCancel",
  componentId: "sc-1x201y6-4"
})([""]);

var Body = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__Body",
  componentId: "sc-1x201y6-5"
})(["min-height:115px;background-color:", ";display:flex;flex-direction:column;justify-content:center;padding:0 30px;"], _tokens["default"].prompt.body.background.color);

var DefaultRow = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__DefaultRow",
  componentId: "sc-1x201y6-6"
})(["display:flex;flex-direction:row;padding:10px 0;"]);

var Icon = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__Icon",
  componentId: "sc-1x201y6-7"
})(["display:flex;flex-direction:column;align-items:center;justify-content:center;margin-right:30px;"]);

var BodyContent = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__BodyContent",
  componentId: "sc-1x201y6-8"
})(["width:100%;align-self:center;"]);

var Footer = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__Footer",
  componentId: "sc-1x201y6-9"
})(["height:60px;background-color:", ";display:flex;justify-content:space-between;flex-direction:row-reverse;align-items:center;padding:0 15px;"], _tokens["default"].prompt.footer.background.color);

var CheckboxContainer = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__CheckboxContainer",
  componentId: "sc-1x201y6-10"
})(["display:flex;"]);

var CheckboxText = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__CheckboxText",
  componentId: "sc-1x201y6-11"
})(["position:relative;top:-1px;cursor:pointer;"]);

var ExtraContent = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__ExtraContent",
  componentId: "sc-1x201y6-12"
})(["border-top:1px solid ", ";display:flex;height:80px;padding:15px 0;"], _tokens["default"].prompt.body.extraContent.border.color);

var ContentLine = _styledComponents["default"].div.withConfig({
  displayName: "PromptStyles__ContentLine",
  componentId: "sc-1x201y6-13"
})(["margin-top:", ";margin-bottom:", ";"], function (_ref) {
  var initial = _ref.initial;
  return initial ? 0 : '5px';
}, function (_ref2) {
  var _final = _ref2["final"];
  return _final ? 0 : '5px';
});

var _default = {
  CheckboxContainer: CheckboxContainer,
  CheckboxText: CheckboxText,
  Container: Container,
  ContentLine: ContentLine,
  ExtraContent: ExtraContent,
  Wrapper: Wrapper,
  Header: Header,
  HeaderText: HeaderText,
  HeaderCancel: HeaderCancel,
  Body: Body,
  BodyContent: BodyContent,
  Icon: Icon,
  Footer: Footer,
  DefaultRow: DefaultRow
};
exports["default"] = _default;