"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _radioButton = require("../../../tokens/radioButton");

var _ANIMATIONS = _interopRequireDefault(require("../../../constants/ANIMATIONS"));

var getMarginRight = function getMarginRight(_ref) {
  var last = _ref.last,
      horizontal = _ref.horizontal;
  return horizontal && !last ? 10 : 0;
};

var Label = _styledComponents["default"].label.withConfig({
  displayName: "RadioButtonStyles__Label",
  componentId: "aeyfjd-0"
})(["display:block;position:relative;padding-left:12px;margin-bottom:7px;cursor:pointer;font-size:", ";font-family:", ";font-weight:", ";color:", ";-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;margin-right:", "px;"], _tokens["default"].radioButton.text.size, _tokens["default"].radioButton.text.family, function (_ref2) {
  var checked = _ref2.checked;
  return _tokens["default"].radioButton.text.weight[(0, _radioButton.getRadioButtonState)(checked)];
}, _tokens["default"].radioButton.text.color, getMarginRight);

var Input = _styledComponents["default"].input.withConfig({
  displayName: "RadioButtonStyles__Input",
  componentId: "aeyfjd-1"
})(["position:absolute;opacity:0;cursor:pointer;"]);

var RadioButton = _styledComponents["default"].span.withConfig({
  displayName: "RadioButtonStyles__RadioButton",
  componentId: "aeyfjd-2"
})(["position:absolute;top:3px;left:-5px;height:14px;width:14px;background-color:transparent;border:2px solid ", ";box-sizing:border-box;border-radius:50%;&:after{content:\" \";position:absolute;display:", ";top:2px;left:2px;width:6px;height:6px;border-radius:50%;background-color:", ";}"], _tokens["default"].radioButton.color, function (_ref3) {
  var checked = _ref3.checked;
  return checked ? 'block' : 'none';
}, _tokens["default"].radioButton.color);

var Children = _styledComponents["default"].div.withConfig({
  displayName: "RadioButtonStyles__Children",
  componentId: "aeyfjd-3"
})(["", ""], function (_ref4) {
  var hide = _ref4.hide;
  return hide ? (0, _styledComponents.css)(["max-height:0;overflow:hidden;transition:max-height 0.8s cubic-bezier(0,1,0,1);"]) : (0, _styledComponents.css)(["max-height:1000px;transition:max-height 1s ease-in;", ""], _ANIMATIONS["default"].delay({
    property: 'overflow',
    startValue: 'hidden',
    endValue: 'visible',
    time: 1
  }));
});

var _default = {
  Label: Label,
  Input: Input,
  RadioButton: RadioButton,
  Children: Children
};
exports["default"] = _default;