"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _Async = _interopRequireDefault(require("react-select/lib/Async"));

var _Creatable = _interopRequireDefault(require("react-select/lib/Creatable"));

var _AsyncCreatable = _interopRequireDefault(require("react-select/lib/AsyncCreatable"));

var _SelectComponents = require("../SelectComponents");

var _SelectStyles = _interopRequireDefault(require("./SelectStyles"));

var Select =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(Select, _React$Component);

  function Select() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Select)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      selectedOption: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearInput", function () {
      _this.handleOnChange(null);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRef", function (ref) {
      if (ref && !_this.selectRef) {
        _this.selectRef = ref;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnChange", function (option) {
      var onChange = _this.props.onChange;

      _this.setState({
        selectedOption: option
      });

      onChange && onChange(option);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getComponent", function () {
      var _this$props = _this.props,
          async = _this$props.async,
          creatable = _this$props.creatable,
          loadOptions = _this$props.loadOptions;

      if (async && creatable) {
        if (!loadOptions) {
          throw new Error('AsyncCreatable Select must define loadOptions');
        }

        return _AsyncCreatable["default"];
      } else if (async) {
        if (!loadOptions) {
          throw new Error('Async Select must define loadOptions');
        }

        return _Async["default"];
      } else if (creatable) {
        return _Creatable["default"];
      }

      return _reactSelect["default"];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getProps", function () {
      var _this$props2 = _this.props,
          options = _this$props2.options,
          disabled = _this$props2.disabled,
          multi = _this$props2.multi,
          isLoading = _this$props2.isLoading,
          async = _this$props2.async,
          loadOptions = _this$props2.loadOptions,
          value = _this$props2.value,
          clearable = _this$props2.clearable,
          searchable = _this$props2.searchable,
          placeholder = _this$props2.placeholder,
          isValidNewOption = _this$props2.isValidNewOption,
          actionButton = _this$props2.actionButton;
      var selectedOption = _this.state.selectedOption;
      var baseProps = {
        isValidNewOption: isValidNewOption,
        value: value || selectedOption,
        blurInputOnSelect: !multi,
        closeMenuOnSelect: !multi,
        isMulti: multi,
        isSearchable: searchable,
        isDisabled: disabled,
        isClearable: clearable,
        backspaceRemovesValue: clearable,
        deleteRemoves: clearable,
        placeholder: placeholder,
        onChange: _this.handleOnChange,
        menuPortalTarget: document.body,
        createOptionPosition: 'first',
        options: actionButton ? options.concat((0, _objectSpread2["default"])({}, actionButton, {
          __isActionButton__: true
        })) : options,
        noOptionsMessage: function noOptionsMessage() {
          return searchable ? 'Type to search' : 'No options available';
        }
      };

      if (async) {
        return (0, _objectSpread2["default"])({}, baseProps, {
          loadOptions: loadOptions
        });
      }

      return (0, _objectSpread2["default"])({}, baseProps, {
        isLoading: isLoading
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(Select, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          name = _this$props3.name,
          small = _this$props3.small,
          large = _this$props3.large,
          selectOverrides = _this$props3.selectOverrides;
      var SelectComponent = this.getComponent();
      return _react["default"].createElement("div", {
        "data-qa-id": "Select",
        className: "Select",
        name: name
      }, _react["default"].createElement(SelectComponent, (0, _extends2["default"])({
        ref: this.handleRef,
        components: {
          Option: (0, _SelectComponents.Option)(this.props),
          SingleValue: (0, _SelectComponents.SingleValue)(this.props),
          MultiValueLabel: (0, _SelectComponents.MultiValueLabel)(this.props),
          GroupHeading: (0, _SelectComponents.GroupHeading)(this.props),
          Input: (0, _SelectComponents.Input)(this.props)
        },
        styles: (0, _SelectStyles["default"])({
          small: small,
          large: large
        })
      }, this.getProps(), selectOverrides)));
    }
  }]);
  return Select;
}(_react["default"].Component);

exports["default"] = Select;
(0, _defineProperty2["default"])(Select, "defaultProps", {
  disabled: false,
  clearable: false,
  searchable: false
});