"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var height = function height(small, large) {
  if (small) {
    return '24px'; // actually 25px but this fixes some padding weirdness
  }

  if (large) {
    return '44px'; // actually 46px but this fixes some padding weirdness
  }

  return '33px'; // actually 35px but this fixes some padding weirdness
};

var dropdownIndicatorPadding = function dropdownIndicatorPadding(small, large) {
  if (small) {
    return '4px';
  }

  if (large) {
    return '8px';
  }

  return '6px';
};

var dropdownIndicatorSize = function dropdownIndicatorSize(small, large) {
  if (small) {
    return '15px';
  }

  if (large) {
    return '20px';
  }

  return '18px';
};

var styles = function styles(_ref) {
  var small = _ref.small,
      large = _ref.large;
  return {
    control: function control(provided, state) {
      return (0, _objectSpread2["default"])({}, provided, {
        borderRadius: 0,
        boxShadow: "0 2px 4px 0 ".concat(_tokens["default"].select.input.boxShadow.color),
        borderColor: _tokens["default"].select.input.border.color[state.isFocused ? 'active' : 'default'],
        minHeight: height(small, large),
        '&:hover': {
          borderColor: _tokens["default"].select.input.border.color[state.isFocused ? 'active' : 'default']
        }
      });
    },
    input: function input(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        display: 'flex',
        alignItems: 'center',
        color: _tokens["default"].select.input.text.color,
        fontSize: _tokens["default"].select.input.text.size[small ? 'small' : 'default'],
        fontFamily: _tokens["default"].select.input.text.family,
        fontWeight: _tokens["default"].select.input.text.weight
      });
    },
    valueContainer: function valueContainer(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        padding: "".concat(small ? 0 : 2, "px 8px"),
        minHeight: height(small, large)
      });
    },
    menu: function menu(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        borderRadius: 0,
        borderColor: _tokens["default"].select.input.border.color["default"]
      });
    },
    menuPortal: function menuPortal(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        zIndex: 99999999
      });
    },
    indicatorSeparator: function indicatorSeparator(provided, state) {
      return (0, _objectSpread2["default"])({}, provided, {
        backgroundColor: _tokens["default"].select.input.border.color[state.isFocused ? 'active' : 'default']
      });
    },
    loadingIndicator: function loadingIndicator(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        color: _tokens["default"].select.loading.color,
        '& > span': {
          backgroundColor: _tokens["default"].select.loading.color
        }
      });
    },
    clearIndicator: function clearIndicator(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        padding: dropdownIndicatorPadding(small, large),
        '& svg': {
          width: dropdownIndicatorSize(small, large),
          height: dropdownIndicatorSize(small, large)
        }
      });
    },
    dropdownIndicator: function dropdownIndicator(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        padding: dropdownIndicatorPadding(small, large),
        '& svg': {
          width: dropdownIndicatorSize(small, large),
          height: dropdownIndicatorSize(small, large),
          fill: _tokens["default"].select.dropdownIndicator.color,
          '&:hover': {
            fill: _tokens["default"].select.dropdownIndicator.colorHover
          }
        }
      });
    },
    multiValue: function multiValue(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        borderRadius: 0,
        backgroundColor: _tokens["default"].select.value.pill.background.color
      });
    },
    multiValueRemove: function multiValueRemove(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        borderRadius: 0,
        color: _tokens["default"].select.value.pill.clear.color.iconDefault,
        '&:hover': {
          color: _tokens["default"].select.value.pill.clear.color.iconHover,
          backgroundColor: _tokens["default"].select.value.pill.background.color
        }
      });
    },
    multiValueLabel: function multiValueLabel(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        padding: '2px',
        color: _tokens["default"].select.value.pill.text.color,
        fontSize: _tokens["default"].select.value.pill.text.size[small ? 'small' : 'default'],
        fontFamily: _tokens["default"].select.value.pill.text.family,
        fontWeight: _tokens["default"].select.value.pill.text.weight
      });
    },
    placeholder: function placeholder(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        color: _tokens["default"].select.placeholder.text.color,
        fontSize: _tokens["default"].select.placeholder.text.size[small ? 'small' : 'default'],
        fontFamily: _tokens["default"].select.placeholder.text.family,
        fontWeight: _tokens["default"].select.placeholder.text.weight
      });
    },
    option: function option(provided, state) {
      return (0, _objectSpread2["default"])({}, provided, {
        color: _tokens["default"].select.option.text.color[state.isDisabled ? 'disabled' : 'default'],
        fontSize: _tokens["default"].select.option.text.size[small ? 'small' : 'default'],
        fontFamily: _tokens["default"].select.option.text.family,
        fontWeight: _tokens["default"].select.option.text.weight,
        backgroundColor: _tokens["default"].select.option.background.color[state.isFocused ? 'hover' : 'default'],
        '&:hover': {
          backgroundColor: _tokens["default"].select.option.background.color.hover
        }
      });
    },
    singleValue: function singleValue(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        color: _tokens["default"].select.value.single.text.color,
        fontSize: _tokens["default"].select.value.single.text.size[small ? 'small' : 'default'],
        fontFamily: _tokens["default"].select.value.single.text.family,
        fontWeight: _tokens["default"].select.value.single.text.weight,
        width: '100%',
        maxWidth: 'calc(100% - 20px)'
      });
    },
    groupHeading: function groupHeading(provided) {
      return (0, _objectSpread2["default"])({}, provided, {
        color: _tokens["default"].select.groupHeader.text.color,
        fontSize: _tokens["default"].select.groupHeader.text.size[small ? 'small' : 'default'],
        fontFamily: _tokens["default"].select.groupHeader.text.family,
        fontWeight: _tokens["default"].select.groupHeader.text.weight,
        textTransform: 'none',
        marginBottom: 0
      });
    }
  };
};

var _default = styles;
exports["default"] = _default;