"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSelect = require("react-select");

var _Icon = _interopRequireDefault(require("../../../Icon"));

var _withTooltip = _interopRequireDefault(require("../../../Tooltip/withTooltip"));

var _ICONS = _interopRequireDefault(require("../../../../constants/ICONS"));

var _tokens = _interopRequireDefault(require("../../../../tokens"));

var Styles = _interopRequireWildcard(require("./GroupHeadingStyles"));

var IconWithTooltip = (0, _withTooltip["default"])(_Icon["default"]);

var GroupHeading = function GroupHeading(props) {
  return function (selectProps) {
    var option = selectProps.selectProps.options.find(function (o) {
      return o.hasOwnProperty('options') && o.label === selectProps.children;
    });

    if (option && option.tooltipText) {
      return _react["default"].createElement(Styles.GroupHeadingWrapper, null, _react["default"].createElement(_reactSelect.components.GroupHeading, selectProps), _react["default"].createElement(Styles.IconWrapper, null, _react["default"].createElement(IconWithTooltip, {
        tooltipText: option.tooltipText,
        icon: _ICONS["default"].info,
        tooltipPlacement: "right",
        size: 16,
        color: _tokens["default"].select.groupHeader.icon.color
      })));
    }

    return _react["default"].createElement(Styles.GroupHeadingWrapper, null, _react["default"].createElement(_reactSelect.components.GroupHeading, selectProps));
  };
};

var _default = GroupHeading;
exports["default"] = _default;