"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _reactSelect = require("react-select");

var _lodash = _interopRequireDefault(require("lodash.uniq"));

var handleOnPaste = function handleOnPaste(creatable, async, loadOptions, onChange, currentValues, getNewOptionData, isValidNewOption, existingOptions) {
  return (
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(event) {
        var clipboard, values, options;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                event.preventDefault();
                clipboard = event.clipboardData.getData('Text');

                if (clipboard) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return");

              case 4:
                values = (0, _lodash["default"])(clipboard.split(/[\s,]+/), function (value) {
                  return value.trim();
                });
                _context2.next = 7;
                return Promise.all(values.map(
                /*#__PURE__*/
                function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])(
                  /*#__PURE__*/
                  _regenerator["default"].mark(function _callee(value) {
                    var _maybeOption, maybeOption;

                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            if (!(async && loadOptions)) {
                              _context.next = 6;
                              break;
                            }

                            _context.next = 3;
                            return loadOptions(value);

                          case 3:
                            _maybeOption = _context.sent;

                            if (!(_maybeOption && _maybeOption.length === 1)) {
                              _context.next = 6;
                              break;
                            }

                            return _context.abrupt("return", _maybeOption[0]);

                          case 6:
                            maybeOption = existingOptions.find(function (o) {
                              return o.label.toLowerCase() === value.toLowerCase() || o.value.toLowerCase() === value.toLowerCase();
                            });

                            if (!maybeOption) {
                              _context.next = 9;
                              break;
                            }

                            return _context.abrupt("return", maybeOption);

                          case 9:
                            if (!(creatable && isValidNewOption(value, currentValues || [], existingOptions))) {
                              _context.next = 11;
                              break;
                            }

                            return _context.abrupt("return", getNewOptionData(value, value));

                          case 11:
                            return _context.abrupt("return", null);

                          case 12:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x2) {
                    return _ref2.apply(this, arguments);
                  };
                }()));

              case 7:
                options = _context2.sent;
                onChange(options.filter(function (o) {
                  return o !== null;
                }), {
                  action: 'select-option'
                });

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }()
  );
};

var Input = function Input(props) {
  return function (selectProps) {
    if (selectProps.selectProps.isMulti) {
      var creatable = props.creatable,
          async = props.async,
          loadOptions = props.loadOptions;
      var _selectProps$selectPr = selectProps.selectProps,
          onChange = _selectProps$selectPr.onChange,
          value = _selectProps$selectPr.value,
          getNewOptionData = _selectProps$selectPr.getNewOptionData,
          isValidNewOption = _selectProps$selectPr.isValidNewOption,
          options = _selectProps$selectPr.options;
      return _react["default"].createElement(_reactSelect.components.Input, (0, _extends2["default"])({}, selectProps, {
        onPaste: handleOnPaste(creatable, async, loadOptions, onChange, value, getNewOptionData, isValidNewOption, options)
      }));
    }

    return _react["default"].createElement(_reactSelect.components.Input, selectProps);
  };
};

var _default = Input;
exports["default"] = _default;