"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _reactSelect = require("react-select");

var _withTooltip = _interopRequireDefault(require("../../../Tooltip/withTooltip"));

var Styles = _interopRequireWildcard(require("./MultiValueLabelStyles"));

var MultiValueLabel = function MultiValueLabel(props) {
  return function (selectProps) {
    var optionRenderer = props.optionRenderer,
        optionDecorationRenderer = props.optionDecorationRenderer,
        small = props.small,
        large = props.large;

    if (optionRenderer) {
      return null;
    }

    var MultiValueLabel = _reactSelect.components.MultiValueLabel;

    if (optionDecorationRenderer) {
      MultiValueLabel = function MultiValueLabel(p) {
        return _react["default"].createElement(_reactSelect.components.MultiValueLabel, p, _react["default"].createElement(Styles.MultiValueLabelWrapper, null, _react["default"].createElement(Styles.DecoractionWrapper, null, optionDecorationRenderer && optionDecorationRenderer(p, small, large, false)), p.children));
      };
    }

    if (selectProps.data.error) {
      var MultiValueLabelWithTooltip = (0, _withTooltip["default"])(MultiValueLabel);
      return _react["default"].createElement("div", {
        "data-qa-id": "Select__multi-value-label"
      }, _react["default"].createElement(MultiValueLabelWithTooltip, (0, _extends2["default"])({}, selectProps, {
        tooltipText: selectProps.data.errorText || 'Invalid Format'
      })));
    }

    return _react["default"].createElement("div", {
      "data-qa-id": "Select__multi-value-label"
    }, _react["default"].createElement(MultiValueLabel, selectProps));
  };
};

var _default = MultiValueLabel;
exports["default"] = _default;