"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSelect = require("react-select");

var _Button = _interopRequireDefault(require("../../../Button"));

var _button = require("../../../../tokens/button");

var Styles = _interopRequireWildcard(require("./OptionStyles"));

var Option = function Option(props) {
  return function (selectProps) {
    var optionRenderer = props.optionRenderer,
        optionDecorationRenderer = props.optionDecorationRenderer,
        small = props.small,
        large = props.large;

    if (selectProps.data.__isActionButton__) {
      return _react["default"].createElement(_Button["default"], {
        text: selectProps.data.text,
        icon: selectProps.data.icon,
        onClick: selectProps.data.onClick,
        size: _button.ButtonConstants.sizes.medium,
        style: _button.ButtonConstants.styles.naked,
        mixins: ['width: calc(100% - 10px);', 'margin: 5px']
      });
    }

    var optionComponent = _react["default"].createElement(_reactSelect.components.Option, selectProps);

    if (!selectProps.data.__isNew__) {
      if (optionRenderer) {
        var option = optionRenderer(selectProps, small, large, true);

        if (option) {
          optionComponent = _react["default"].createElement(_reactSelect.components.Option, selectProps, option);
        }
      } else if (optionDecorationRenderer) {
        optionComponent = _react["default"].createElement(_reactSelect.components.Option, selectProps, _react["default"].createElement(Styles.OptionWrapper, null, _react["default"].createElement(Styles.DecoractionWrapper, null, optionDecorationRenderer && optionDecorationRenderer(selectProps, small, large, true)), selectProps.children));
      }
    }

    return _react["default"].createElement("div", {
      "data-qa-id": "Select__option"
    }, optionComponent);
  };
};

var _default = Option;
exports["default"] = _default;