"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSelect = require("react-select");

var Styles = _interopRequireWildcard(require("./SingleValueStyles"));

var SingleValue = function SingleValue(props) {
  return function (selectProps) {
    var optionRenderer = props.optionRenderer,
        optionDecorationRenderer = props.optionDecorationRenderer,
        small = props.small,
        large = props.large;

    var valueComponent = _react["default"].createElement(_reactSelect.components.SingleValue, selectProps);

    if (optionRenderer) {
      var option = optionRenderer(selectProps, small, large, false);

      if (option) {
        valueComponent = _react["default"].createElement(_reactSelect.components.SingleValue, selectProps, option);
      }
    }

    if (optionDecorationRenderer) {
      valueComponent = _react["default"].createElement(_reactSelect.components.SingleValue, selectProps, _react["default"].createElement(Styles.SingleValueWrapper, null, _react["default"].createElement(Styles.DecoractionWrapper, null, optionDecorationRenderer && optionDecorationRenderer(selectProps, small, large, false)), selectProps.children));
    }

    return _react["default"].createElement("div", {
      "data-qa-id": "Select__single-value"
    }, valueComponent);
  };
};

var _default = SingleValue;
exports["default"] = _default;