"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread4 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var valueTransformer = _interopRequireWildcard(require("../value-transformer"));

var _Track = _interopRequireDefault(require("../Track"));

var _Train = _interopRequireDefault(require("../Train"));

var _SliderStyles = _interopRequireDefault(require("./SliderStyles"));

var MultiSlider =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(MultiSlider, _React$Component);

  function MultiSlider() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, MultiSlider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MultiSlider)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isDragging", {
      min: false,
      max: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dragValue", {
      min: null,
      max: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRef", function (node) {
      return _this.node = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackRef", function (node) {
      return _this.trackNode = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrainDrag", function (type) {
      return function (event) {
        var _this$props = _this.props,
            disabled = _this$props.disabled,
            maxValue = _this$props.maxValue,
            minValue = _this$props.minValue,
            step = _this$props.step;

        if (disabled) {
          return;
        }

        var position = valueTransformer.getPositionFromEvent(event, _this.getTrackClientRect());
        var value = valueTransformer.getValueFromPosition(position, minValue, maxValue, _this.getTrackClientRect());
        var stepValue = valueTransformer.getStepValueFromValue(value, step);
        requestAnimationFrame(function () {
          _this.isDragging[type] = true;
          _this.dragValue[type] = value;

          _this.props.onChange((0, _objectSpread4["default"])({}, _this.props.value, (0, _defineProperty2["default"])({}, type, stepValue)));
        });
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrainRelease", function (type) {
      return function () {
        var _this$props2 = _this.props,
            disabled = _this$props2.disabled,
            maxValue = _this$props2.maxValue,
            minValue = _this$props2.minValue,
            step = _this$props2.step;

        if (disabled) {
          return;
        }

        var position = valueTransformer.getPositionFromEvent(event, _this.getTrackClientRect());
        var value = valueTransformer.getValueFromPosition(position, minValue, maxValue, _this.getTrackClientRect());
        var stepValue = valueTransformer.getStepValueFromValue(value, step);
        requestAnimationFrame(function () {
          _this.isDragging[type] = false;
          _this.dragValue[type] = value;

          _this.props.onChange((0, _objectSpread4["default"])({}, _this.props.value, (0, _defineProperty2["default"])({}, type, stepValue)));

          if (_this.props.onChangeComplete) {
            _this.props.onChangeComplete((0, _objectSpread4["default"])({}, _this.props.value));
          }
        });
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputFocus", function (event) {
      event.target.select();
    });
    return _this;
  }

  (0, _createClass2["default"])(MultiSlider, [{
    key: "getTrackClientRect",
    value: function getTrackClientRect() {
      return this.trackNode.getClientRect();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          value = _this$props3.value,
          maxValue = _this$props3.maxValue,
          minValue = _this$props3.minValue,
          step = _this$props3.step,
          minLabel = _this$props3.minLabel,
          maxLabel = _this$props3.maxLabel,
          disabled = _this$props3.disabled,
          decimalPlaces = _this$props3.decimalPlaces;
      var valueMinFixed = value.min.toFixed(decimalPlaces);
      var valueMaxFixed = value.max.toFixed(decimalPlaces);
      var minPercentage = valueTransformer.getPercentageFromValue(this.isDragging.min ? this.dragValue.min : valueMinFixed, minValue, maxValue);
      var maxPercentage = valueTransformer.getPercentageFromValue(this.isDragging.max ? this.dragValue.max : valueMaxFixed, minValue, maxValue);
      return _react["default"].createElement(_SliderStyles["default"].Slider, {
        ref: this.handleRef
      }, _react["default"].createElement(_SliderStyles["default"].Label, {
        min: true,
        isDragging: this.isDragging.min
      }, minLabel ? minLabel({
        value: valueMinFixed,
        isDragging: this.isDragging.min
      }) : this.isDragging.min ? this.dragValue.min.toFixed(decimalPlaces) : valueMinFixed), _react["default"].createElement(_Track["default"], {
        ref: this.handleTrackRef,
        minPercentage: minPercentage,
        maxPercentage: maxPercentage,
        onTrackMouseDown: function onTrackMouseDown() {},
        disabled: disabled
      }, _react["default"].createElement(_Train["default"], {
        key: "min",
        maxValue: valueMaxFixed - step,
        minValue: minValue,
        onTrainDrag: this.handleTrainDrag('min'),
        onTrainRelease: this.handleTrainRelease('min'),
        percentage: minPercentage,
        value: value,
        disabled: disabled
      }), _react["default"].createElement(_Train["default"], {
        maxValue: maxValue,
        minValue: valueMinFixed,
        onTrainDrag: this.handleTrainDrag('max'),
        onTrainRelease: this.handleTrainRelease('max'),
        percentage: maxPercentage,
        value: value,
        disabled: disabled
      })), _react["default"].createElement(_SliderStyles["default"].Label, {
        max: true,
        isDragging: this.isDragging.max
      }, maxLabel ? maxLabel({
        value: valueMaxFixed,
        isDragging: this.isDragging.max
      }) : this.isDragging.max ? this.dragValue.max.toFixed(decimalPlaces) : valueMaxFixed));
    }
  }]);
  return MultiSlider;
}(_react["default"].Component);

exports["default"] = MultiSlider;
(0, _defineProperty2["default"])(MultiSlider, "defaultProps", {
  step: 1,
  decimalPlaces: 0
});