"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var valueTransformer = _interopRequireWildcard(require("../value-transformer"));

var _Track = _interopRequireDefault(require("../Track"));

var _Train = _interopRequireDefault(require("../Train"));

var _SliderStyles = _interopRequireDefault(require("./SliderStyles"));

var Slider =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(Slider, _React$Component);

  function Slider() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Slider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Slider)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isDragging", false);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRef", function (node) {
      return _this.node = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackRef", function (node) {
      return _this.trackNode = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputRef", function (node) {
      return _this.inputNode = node;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrackMouseDown", function (event, position) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          maxValue = _this$props.maxValue,
          minValue = _this$props.minValue,
          step = _this$props.step,
          currentValue = _this$props.value;

      if (disabled) {
        return;
      }

      event.preventDefault();
      var value = valueTransformer.getValueFromPosition(position, minValue, maxValue, _this.getTrackClientRect());
      var stepValue = valueTransformer.getStepValueFromValue(value, step, currentValue);
      _this.dragValue = stepValue;

      _this.props.onChange(stepValue);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrainDrag", function (event) {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          maxValue = _this$props2.maxValue,
          minValue = _this$props2.minValue,
          step = _this$props2.step;

      if (disabled) {
        return;
      }

      var position = valueTransformer.getPositionFromEvent(event, _this.getTrackClientRect());
      var value = valueTransformer.getValueFromPosition(position, minValue, maxValue, _this.getTrackClientRect());
      var stepValue = valueTransformer.getStepValueFromValue(value, step);
      requestAnimationFrame(function () {
        _this.isDragging = true;
        _this.dragValue = value;

        _this.props.onChange(stepValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrainRelease", function () {
      var _this$props3 = _this.props,
          disabled = _this$props3.disabled,
          maxValue = _this$props3.maxValue,
          minValue = _this$props3.minValue,
          step = _this$props3.step;

      if (disabled) {
        return;
      }

      var position = valueTransformer.getPositionFromEvent(event, _this.getTrackClientRect());
      var value = valueTransformer.getValueFromPosition(position, minValue, maxValue, _this.getTrackClientRect());
      var stepValue = valueTransformer.getStepValueFromValue(value, step);
      requestAnimationFrame(function () {
        _this.isDragging = false;
        _this.dragValue = stepValue;

        _this.props.onChange(stepValue);

        if (_this.props.onChangeComplete) {
          _this.props.onChangeComplete((0, _objectSpread2["default"])({}, _this.props.value));
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputFocus", function (event) {
      event.target.select();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputChange", function (event) {
      var _this$props4 = _this.props,
          minValue = _this$props4.minValue,
          maxValue = _this$props4.maxValue;
      var valueString = event.target.value;

      if (valueString === '') {
        _this.dragValue = minValue;

        _this.props.onChange(minValue);
      } else if (!isNaN(valueString)) {
        var value = Math.floor(parseInt(valueString, 10));

        if (value >= minValue && value <= maxValue) {
          _this.dragValue = value;

          _this.props.onChange(value);
        }
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(Slider, [{
    key: "getTrackClientRect",
    value: function getTrackClientRect() {
      return this.trackNode.getClientRect();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          value = _this$props5.value,
          maxValue = _this$props5.maxValue,
          minValue = _this$props5.minValue,
          disabled = _this$props5.disabled,
          decimalPlaces = _this$props5.decimalPlaces;
      var percentage = valueTransformer.getPercentageFromValue(this.isDragging ? this.dragValue : value.toFixed(decimalPlaces), minValue, maxValue);
      return _react["default"].createElement(_SliderStyles["default"].Slider, {
        ref: this.handleRef
      }, _react["default"].createElement(_SliderStyles["default"].Label, {
        min: true
      }, minValue.toFixed(decimalPlaces)), _react["default"].createElement(_SliderStyles["default"].Input, {
        type: "text",
        ref: this.handleInputRef,
        percentage: percentage,
        onFocus: this.handleInputFocus,
        onChange: this.handleInputChange,
        value: value
      }), _react["default"].createElement(_Track["default"], {
        ref: this.handleTrackRef,
        minPercentage: 0,
        maxPercentage: percentage,
        onTrackMouseDown: this.handleTrackMouseDown,
        disabled: disabled
      }, _react["default"].createElement(_Train["default"], {
        maxValue: maxValue,
        minValue: minValue,
        onTrainDrag: this.handleTrainDrag,
        onTrainRelease: this.handleTrainRelease,
        percentage: percentage,
        value: value,
        disabled: disabled
      })), _react["default"].createElement(_SliderStyles["default"].Label, {
        max: true
      }, maxValue.toFixed(decimalPlaces)));
    }
  }]);
  return Slider;
}(_react["default"].Component);

exports["default"] = Slider;
(0, _defineProperty2["default"])(Slider, "defaultProps", {
  step: 1,
  decimalPlaces: 0
});