"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var height = 18;

var Slider = _styledComponents["default"].div.withConfig({
  displayName: "SliderStyles__Slider",
  componentId: "sc-3xq22l-0"
})(["margin:25px 0;height:", "px;position:relative;width:100%;"], height);

var Input = _styledComponents["default"].input.withConfig({
  displayName: "SliderStyles__Input",
  componentId: "sc-3xq22l-1"
})(["font-family:", ";width:25px;box-sizing:border-box;position:absolute;bottom:25px;color:", ";font-size:", ";border:1px solid ", ";transition:left 0.3s ease-out;padding:5px;text-align:center;", ""], _tokens["default"].slider.input.family, _tokens["default"].slider.input.color, _tokens["default"].slider.input.size, _tokens["default"].slider.color["default"], function (_ref) {
  var percentage = _ref.percentage;
  return "\n    left: calc(".concat((percentage || 0) * 100, "% - 14px);\n  ");
});

var Label = _styledComponents["default"].span.withConfig({
  displayName: "SliderStyles__Label",
  componentId: "sc-3xq22l-2"
})(["font-family:", ";font-size:", ";font-weight:", ";color:", ";user-select:none;position:absolute;bottom:-20px;", " ", ""], _tokens["default"].slider.label.family, _tokens["default"].slider.label.size, _tokens["default"].slider.label.weight, function (_ref2) {
  var isDragging = _ref2.isDragging;
  return _tokens["default"].slider.label.color[isDragging ? 'active' : 'default'];
}, function (_ref3) {
  var max = _ref3.max;
  return max ? 'right: 0;' : '';
}, function (_ref4) {
  var min = _ref4.min;
  return min ? 'left: 0;' : '';
});

var _default = {
  Slider: Slider,
  Input: Input,
  Label: Label
};
exports["default"] = _default;