"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Spinner = exports.Wrapper = exports.Container = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _hexToRgba = _interopRequireDefault(require("hex-to-rgba"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var rotateKeyframe = (0, _styledComponents.keyframes)(["0%{-webkit-transform:rotate(0deg);transform:rotate(0deg);}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg);}"]);

var Container = _styledComponents["default"].div.withConfig({
  displayName: "Spinnerstyles__Container",
  componentId: "sc-186lll0-0"
})(["display:flex;flex-direction:column;align-items:center;justify-content:cetner;", ""], function (_ref) {
  var show = _ref.show;
  return show ? '' : '  visibility: hidden;';
});

exports.Container = Container;

var Wrapper = _styledComponents["default"].div.withConfig({
  displayName: "Spinnerstyles__Wrapper",
  componentId: "sc-186lll0-1"
})(["position:relative;"]);

exports.Wrapper = Wrapper;

var getBorder = function getBorder(thick, danger, opaque) {
  var baseColor = danger ? _tokens["default"].colors.danger500 : _tokens["default"].colors.brand500;
  var color = opaque ? (0, _hexToRgba["default"])(baseColor, 0.35) : baseColor;
  var thickness = thick ? 5 : 1;
  return "".concat(thickness, "px solid ").concat(color);
};

var Spinner = _styledComponents["default"].div.withConfig({
  displayName: "Spinnerstyles__Spinner",
  componentId: "sc-186lll0-2"
})(["display:flex;flex-direction:column;align-items:center;justify-content:cetner;position:relative;text-indent:-9999em;border-top:", ";border-right:", ";border-bottom:", ";border-left:", ";transform:translateZ(0);animation:", " 0.5s infinite linear;&,&::after{border-radius:50%;width:", "px;height:", "px;}"], function (_ref2) {
  var thick = _ref2.thick,
      danger = _ref2.danger;
  return getBorder(thick, danger, true);
}, function (_ref3) {
  var thick = _ref3.thick,
      danger = _ref3.danger;
  return getBorder(thick, danger, true);
}, function (_ref4) {
  var thick = _ref4.thick,
      danger = _ref4.danger;
  return getBorder(thick, danger, true);
}, function (_ref5) {
  var thick = _ref5.thick,
      danger = _ref5.danger;
  return getBorder(thick, danger, false);
}, rotateKeyframe, function (_ref6) {
  var size = _ref6.size;
  return size;
}, function (_ref7) {
  var size = _ref7.size;
  return size;
});

exports.Spinner = Spinner;