"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StatusIndicatorIcon = exports.Label = exports.Container = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireWildcard(require("../../tokens"));

var getStatusColor = function getStatusColor(_ref) {
  var success = _ref.success,
      warning = _ref.warning,
      danger = _ref.danger,
      inverse = _ref.inverse;

  if (success) {
    if (inverse) {
      return _tokens["default"].colors.success400;
    }

    return _tokens["default"].colors.success500;
  }

  if (warning) {
    if (inverse) {
      return _tokens["default"].colors.warning400;
    }

    return _tokens["default"].colors.warning500;
  }

  if (danger) {
    if (inverse) {
      return _tokens["default"].colors.danger400;
    }

    return _tokens["default"].colors.danger500;
  }

  return _tokens["default"].colors.white;
};

var Container = _styledComponents["default"].div.withConfig({
  displayName: "StatusIndicatorstyles__Container",
  componentId: "t7gxuw-0"
})(["display:flex;align-items:center;"]);

exports.Container = Container;

var Label = _styledComponents["default"].span.withConfig({
  displayName: "StatusIndicatorstyles__Label",
  componentId: "t7gxuw-1"
})(["margin-left:10px;color:", ";text-transform:", ";font-size:", ";font-weight:", ";"], getStatusColor, _tokens.FontConstants.textTransform.upperCase, _tokens["default"].fonts.size[_tokens.FontConstants.size.small], _tokens["default"].fonts.weight[_tokens.FontConstants.weight.medium]);

exports.Label = Label;

var StatusIndicatorIcon = _styledComponents["default"].div.withConfig({
  displayName: "StatusIndicatorstyles__StatusIndicatorIcon",
  componentId: "t7gxuw-2"
})(["height:8px;width:8px;border-radius:50%;background-color:", ";"], getStatusColor);

exports.StatusIndicatorIcon = StatusIndicatorIcon;