"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var _switch = require("../../tokens/switch");

var border = function border(active) {
  return "1px solid ".concat(_tokens["default"]["switch"].color[(0, _switch.getSwitchState)(active)]);
};

var removeVerticalBorders = function removeVerticalBorders(_ref) {
  var left = _ref.left,
      active = _ref.active,
      activeIdx = _ref.activeIdx,
      currentIdx = _ref.currentIdx;

  if (left || active) {
    if (left && activeIdx === currentIdx + 1) {
      return 'border-right: none;';
    }

    return '';
  }

  if (activeIdx === currentIdx + 1) {
    return "\n      border-right: none;\n      border-left: none;\n    ";
  }

  if (activeIdx === currentIdx - 1) {
    return 'border-left: none;';
  }

  return 'border-left: none;';
};

var Container = _styledComponents["default"].div.withConfig({
  displayName: "SwitchStyles__Container",
  componentId: "sc-1iv8aa-0"
})(["display:flex;flex-direction:row;align-items:center;opacity:", ";"], function (_ref2) {
  var disabled = _ref2.disabled;
  return disabled ? '0.3' : '1';
});

var SwitchItem = function () {
  var getChildrenLength = function getChildrenLength(_ref3) {
    var children = _ref3.children;
    return children.filter(function (child) {
      return Boolean(child);
    }).length;
  };

  var setColumnGap = function setColumnGap(children) {
    return children.filter(function (child) {
      return Boolean(child);
    }).length > 1 ? 'grid-column-gap: 10px;' : null;
  };

  return _styledComponents["default"].div.withConfig({
    displayName: "SwitchStyles",
    componentId: "sc-1iv8aa-1"
  })(["box-sizing:content-box;display:grid;grid-template-columns:repeat(", ",auto);", ";align-items:center;justify-content:center;cursor:", ";padding:5px 10px;width:70px;border:", ";", ";"], getChildrenLength, function (_ref4) {
    var children = _ref4.children;
    return setColumnGap(children);
  }, function (_ref5) {
    var disabled = _ref5.disabled;
    return disabled ? 'not-allowed' : 'pointer';
  }, function (_ref6) {
    var active = _ref6.active;
    return border(active);
  }, function (props) {
    return removeVerticalBorders(props);
  });
}();

var Text = _styledComponents["default"].span.withConfig({
  displayName: "SwitchStyles__Text",
  componentId: "sc-1iv8aa-2"
})(["font-family:", ";font-size:", ";font-weight:", ";letter-spacing:1px;color:", ";user-select:none;text-transform:uppercase;"], _tokens["default"]["switch"].text.family, _tokens["default"]["switch"].text.size, _tokens["default"]["switch"].text.weight, function (_ref7) {
  var active = _ref7.active;
  return _tokens["default"]["switch"].color[(0, _switch.getSwitchState)(active)];
});

var _default = {
  Container: Container,
  SwitchItem: SwitchItem,
  Text: Text
};
exports["default"] = _default;