"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _HelpText = _interopRequireDefault(require("../../Form/HelpText"));

var _Tooltip = require("../../Tooltip");

var _ICONS = _interopRequireDefault(require("../../../constants/ICONS"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var Styles = _interopRequireWildcard(require("./Table.styles"));

var HelpAdornment = function HelpAdornment(_ref) {
  var tooltipText = _ref.tooltipText,
      interactive = _ref.interactive;
  return _react["default"].createElement(Styles.Tooltip, null, _react["default"].createElement(_HelpText["default"], {
    helpText: tooltipText,
    interactive: interactive
  }));
};

var IconWithTooltip = (0, _Tooltip.withTooltip)(_Icon["default"]);

var Adornment = function Adornment(_ref2) {
  var icon = _ref2.icon,
      color = _ref2.color,
      tooltipText = _ref2.tooltipText,
      interactive = _ref2.interactive;
  return _react["default"].createElement(Styles.Tooltip, null, _react["default"].createElement(IconWithTooltip, {
    icon: icon,
    color: color,
    tooltipText: tooltipText,
    interactive: interactive,
    size: 10
  }));
};

var HeaderCell =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(HeaderCell, _React$Component);

  function HeaderCell() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, HeaderCell);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(HeaderCell)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSortChange", function () {
      var _this$props = _this.props,
          isSortable = _this$props.isSortable,
          sortDirection = _this$props.sortDirection,
          onSortChange = _this$props.onSortChange;

      if (isSortable && onSortChange) {
        !sortDirection ? onSortChange('asc') : sortDirection === 'asc' ? onSortChange('desc') : onSortChange('asc');
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(HeaderCell, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          alignment = _this$props2.alignment,
          displayName = _this$props2.displayName,
          hasSuperHeader = _this$props2.hasSuperHeader,
          isEndOfSuperHeader = _this$props2.isEndOfSuperHeader,
          isLastCol = _this$props2.isLastCol,
          isStartOfSuperHeader = _this$props2.isStartOfSuperHeader,
          isSuperHeader = _this$props2.isSuperHeader,
          isSortable = _this$props2.isSortable,
          onSortChange = _this$props2.onSortChange,
          sortDirection = _this$props2.sortDirection,
          fitContainer = _this$props2.fitContainer,
          style = _this$props2.style,
          tooltipConfig = _this$props2.tooltipConfig;
      var sortingCaretColor = sortDirection ? _tokens["default"].colors.black : _tokens["default"].colors.secondary300;
      var sortingCaretIcon = sortDirection && sortDirection === 'desc' ? _ICONS["default"]['caret-down'] : _ICONS["default"]['caret-up'];
      return _react["default"].createElement(Styles.SuperHeaderPadding, {
        borderType: isSuperHeader ? null : 'header',
        isStartOfSuperHeader: isStartOfSuperHeader,
        isEndOfSuperHeader: isEndOfSuperHeader,
        style: style,
        isLastCol: isLastCol,
        fitContainer: fitContainer,
        isSuperHeader: isSuperHeader,
        hasSuperHeader: hasSuperHeader
      }, _react["default"].createElement(Styles.HeaderCell, {
        "data-qa-id": "Table__".concat(isSuperHeader ? 'Super' : '', "HeaderCell"),
        alignment: alignment,
        fitContainer: fitContainer,
        hasSuperHeader: hasSuperHeader,
        isSuperHeader: isSuperHeader,
        isSuperHeaderBoundary: isEndOfSuperHeader || isStartOfSuperHeader
      }, _react["default"].createElement(Styles.DisplayNameWrapper, {
        onClick: this.handleSortChange,
        isSortable: isSortable
      }, _react["default"].createElement("span", null, displayName), isSortable && _react["default"].createElement(Styles.SortingCaret, {
        visible: sortDirection !== undefined
      }, _react["default"].createElement(_Icon["default"], {
        size: 10,
        icon: sortingCaretIcon,
        color: sortingCaretColor
      }))), Boolean(tooltipConfig) && (tooltipConfig.icon === _ICONS["default"].help ? _react["default"].createElement(HelpAdornment, tooltipConfig) : _react["default"].createElement(Adornment, tooltipConfig))));
    }
  }]);
  return HeaderCell;
}(_react["default"].Component);

exports["default"] = HeaderCell;