"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactVirtualized = require("react-virtualized");

var _memoizeOne = _interopRequireDefault(require("memoize-one"));

var _lodash = _interopRequireDefault(require("lodash.orderby"));

var _lodash2 = _interopRequireDefault(require("lodash.isequal"));

var _TableGrid = _interopRequireDefault(require("./TableGrid"));

var Styles = _interopRequireWildcard(require("./Table.styles.js"));

var updateMap = function updateMap(rowsMap, startIndex, rows) {
  rows.forEach(function (row, index) {
    return rowsMap.set(index + startIndex, row);
  });
  return rowsMap;
};

var Table =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(Table, _React$Component);

  function Table() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Table);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Table)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      loading: Boolean(_this.props.rowFetcher),
      fitContainer: _this.props.HACK__forceRefreshOnMount ? !_this.props.fitContainer : _this.props.fitContainer,
      sortBy: null,
      sortDirection: 'ASC',
      isFetchingRows: false,
      pagination: {
        startIndex: 0,
        stopIndex: 0,
        rowsMap: new Map()
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextFetchRowIndices", {
      startIndex: 0,
      stopIndex: _this.props.minimumBatchSize
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "shouldFetchRows", true);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "forceRefreshTable", false);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "forceRefresh", function () {
      _this.shouldFetchRows = true;

      _this.refreshRows();

      _this.forceRefreshTable = true;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_buildRowMap", function (rowsMap, rows, sortBy, sortDirection) {
      var startIndex = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
      var sortedRows = (0, _lodash["default"])(rows, [sortBy], [sortDirection.toLowerCase()]);
      return updateMap(rowsMap, startIndex, sortedRows);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "buildRowMap", (0, _memoizeOne["default"])(function (rowsMap, rows, sortBy, sortDirection, startIndex) {
      return _this._buildRowMap(rowsMap, rows, sortBy, sortDirection, startIndex);
    }));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "refreshRows",
    /*#__PURE__*/
    (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var rowFetcher, isFetchingRows, minimumBatchSize, startIndex, _this$state, sortBy, sortDirection, pagination, rows, newRowsMap;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              rowFetcher = _this.props.rowFetcher;
              isFetchingRows = _this.state.isFetchingRows;

              if (!(rowFetcher && _this.shouldFetchRows && !isFetchingRows)) {
                _context.next = 17;
                break;
              }

              _this.setState({
                isFetchingRows: true
              });

              minimumBatchSize = _this.props.minimumBatchSize;
              startIndex = _this.nextFetchRowIndices.startIndex;
              _this$state = _this.state, sortBy = _this$state.sortBy, sortDirection = _this$state.sortDirection, pagination = _this$state.pagination;
              _context.next = 9;
              return rowFetcher({
                startIndex: 0,
                stopIndex: startIndex < minimumBatchSize ? minimumBatchSize : startIndex
              });

            case 9:
              rows = _context.sent;

              _this.rowsMap.clear();

              if (!(rows.length === 0)) {
                _context.next = 15;
                break;
              }

              _this.setState({
                isFetchingRows: false
              });

              _this.shouldFetchRows = false;
              return _context.abrupt("return");

            case 15:
              newRowsMap = _this.buildRowMap(_this.rowsMap, rows, sortBy, sortDirection, 0);

              _this.setState({
                isFetchingRows: false,
                pagination: (0, _objectSpread2["default"])({}, pagination, {
                  rowsMap: newRowsMap
                })
              });

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "fetchRows",
    /*#__PURE__*/
    (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2() {
      var rowFetcher, isFetchingRows, _this$nextFetchRowInd, startIndex, stopIndex, minimumBatchSize, _this$state2, sortBy, sortDirection, rows, newRowsMap;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              rowFetcher = _this.props.rowFetcher;
              isFetchingRows = _this.state.isFetchingRows;

              if (!(rowFetcher && _this.shouldFetchRows && !isFetchingRows)) {
                _context2.next = 17;
                break;
              }

              _this.setState({
                isFetchingRows: true
              });

              _this$nextFetchRowInd = _this.nextFetchRowIndices, startIndex = _this$nextFetchRowInd.startIndex, stopIndex = _this$nextFetchRowInd.stopIndex;
              minimumBatchSize = _this.props.minimumBatchSize;
              _this$state2 = _this.state, sortBy = _this$state2.sortBy, sortDirection = _this$state2.sortDirection;
              _context2.next = 9;
              return rowFetcher({
                startIndex: startIndex,
                stopIndex: stopIndex
              });

            case 9:
              rows = _context2.sent;

              if (!(rows.length === 0)) {
                _context2.next = 14;
                break;
              }

              _this.setState({
                isFetchingRows: false
              });

              _this.shouldFetchRows = false;
              return _context2.abrupt("return");

            case 14:
              newRowsMap = _this.buildRowMap(_this.rowsMap, rows, sortBy, sortDirection, startIndex);
              _this.nextFetchRowIndices = {
                startIndex: stopIndex,
                stopIndex: stopIndex + minimumBatchSize
              };

              _this.setState({
                isFetchingRows: false,
                pagination: {
                  startIndex: startIndex,
                  stopIndex: stopIndex,
                  rowsMap: newRowsMap
                }
              });

            case 17:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isRowLoaded", function (_ref3) {
      var index = _ref3.index;
      return !!_this.rowsMap.has(index);
    });
    return _this;
  }

  (0, _createClass2["default"])(Table, [{
    key: "componentDidMount",
    value: function () {
      var _componentDidMount = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee3() {
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (this.props.HACK__forceRefreshOnMount) {
                  this.setState(function (prevState) {
                    return {
                      fitContainer: !prevState.fitContainer
                    };
                  });
                }

                _context3.next = 3;
                return this.fetchRows();

              case 3:
                this.setState({
                  loading: false
                });

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function componentDidMount() {
        return _componentDidMount.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (this.forceRefreshTable) {
        this.forceRefreshTable = false;
        return true;
      }

      return !(0, _lodash2["default"])(nextProps, this.props) || !(0, _lodash2["default"])(nextState, this.state);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          rows = _this$props.rows,
          totalRowCount = _this$props.totalRowCount,
          columns = _this$props.columns,
          superHeaders = _this$props.superHeaders,
          onRowClick = _this$props.onRowClick,
          rowHeight = _this$props.rowHeight,
          rowRenderer = _this$props.rowRenderer,
          noHeader = _this$props.noHeader,
          allowCellsRecycling = _this$props.allowCellsRecycling,
          rowFetcherRowOffset = _this$props.rowFetcherRowOffset,
          NoContent = _this$props.noContentRenderer,
          onSortChange = _this$props.onSortChange,
          sortOrder = _this$props.sortOrder;
      var loading = this.state.loading;
      var commonProps = {
        totalRowCount: totalRowCount,
        columns: columns,
        superHeaders: superHeaders,
        onRowClick: onRowClick,
        rowHeight: rowHeight,
        rowRenderer: rowRenderer,
        fitContainer: this.state.fitContainer,
        rowsMap: this.rowsMap,
        noHeader: noHeader,
        allowCellsRecycling: allowCellsRecycling,
        onSortChange: onSortChange,
        sortOrder: sortOrder
      };
      var tableProps = rows ? commonProps : (0, _objectSpread2["default"])({}, commonProps, {
        rowFetcherRowOffset: rowFetcherRowOffset,
        fetchRows: this.fetchRows
      });

      if (loading) {
        return null;
      }

      if (this.rowsMap.size === 0 && NoContent) {
        return _react["default"].createElement(NoContent, null);
      }

      return _react["default"].createElement(_reactVirtualized.AutoSizer, null, function (_ref4) {
        var width = _ref4.width,
            height = _ref4.height;

        if (width && height) {
          return _react["default"].createElement(Styles.Container, {
            "data-qa-id": "Table"
          }, _react["default"].createElement(_TableGrid["default"], (0, _extends2["default"])({}, tableProps, {
            width: width,
            height: height
          })));
        }

        return null;
      });
    }
  }, {
    key: "rowsMap",
    get: function get() {
      var rows = this.props.rows;
      var _this$state3 = this.state,
          sortBy = _this$state3.sortBy,
          sortDirection = _this$state3.sortDirection,
          pagination = _this$state3.pagination;

      if (rows) {
        return this.buildRowMap(new Map(), rows, sortBy, sortDirection, 0);
      }

      return pagination.rowsMap;
    }
  }]);
  return Table;
}(_react["default"].Component);

exports["default"] = Table;
(0, _defineProperty2["default"])(Table, "defaultProps", {
  HACK__forceRefreshOnMount: true,
  fitContainer: true,
  rowHeight: 40,
  superHeaders: [],
  noContentRenderer: function noContentRenderer() {
    return null;
  },
  rowSupplements: {},
  allowCellsRecycling: true,
  minimumBatchSize: 30,
  rowFetcherRowOffset: 25
});