"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableWrapper = exports.SuperHeaderPadding = exports.Tooltip = exports.SortingCaret = exports.DisplayNameWrapper = exports.HeaderCell = exports.BodyCell = exports.Container = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _fixedDataTable = _interopRequireDefault(require("../../../styles/fixed-data-table"));

var alignmentMap = {
  left: 'flex-start',
  right: 'flex-end',
  center: 'center'
};

var horizontalPadding = function horizontalPadding(fitContainer) {
  return fitContainer ? 5 : 15;
};

var Container = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__Container",
  componentId: "sc-1lpkd1l-0"
})([""]);

exports.Container = Container;

var BodyCell = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__BodyCell",
  componentId: "sc-1lpkd1l-1"
})(["height:100%;display:flex;white-space:nowrap;align-items:center;justify-content:", ";padding:2px ", "px;box-sizing:border-box;color:", ";font-family:", ";font-weight:", ";font-size:", ";background-color:", ";", ";"], function (_ref) {
  var alignment = _ref.alignment;
  return alignment ? alignmentMap[alignment] : 'flex-start';
}, function (_ref2) {
  var fitContainer = _ref2.fitContainer;
  return horizontalPadding(fitContainer);
}, _tokens["default"].table.row.text.color, _tokens["default"].table.row.text.family, _tokens["default"].table.row.text.weight, _tokens["default"].table.row.text.size, function (_ref3) {
  var hasSuperHeader = _ref3.hasSuperHeader;
  return hasSuperHeader ? _tokens["default"].colors.secondary100 : 'none';
}, function (_ref4) {
  var hasOnClick = _ref4.hasOnClick;
  return hasOnClick ? 'cursor: pointer;' : '';
});

exports.BodyCell = BodyCell;

var HeaderCell = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__HeaderCell",
  componentId: "sc-1lpkd1l-2"
})(["height:100%;white-space:nowrap;display:flex;align-items:flex-end;justify-content:", ";padding:", ";box-sizing:border-box;", " color:", ";font-family:", ";font-weight:", ";font-size:", ";background-color:", ";"], function (_ref5) {
  var alignment = _ref5.alignment,
      isSuperHeader = _ref5.isSuperHeader;
  return isSuperHeader ? 'center' : alignment ? alignmentMap[alignment] : 'flex-start';
}, function (_ref6) {
  var hasSuperHeader = _ref6.hasSuperHeader,
      fitContainer = _ref6.fitContainer;
  return "".concat(hasSuperHeader ? 0 : 14, "px ").concat(horizontalPadding(fitContainer), "px 5px ").concat(horizontalPadding(fitContainer), "px");
}, function (_ref7) {
  var hasSuperHeader = _ref7.hasSuperHeader,
      isSuperHeader = _ref7.isSuperHeader;
  return !hasSuperHeader || isSuperHeader ? 'text-transform: uppercase;' : '';
}, _tokens["default"].table.header.text.color, _tokens["default"].table.header.text.family, _tokens["default"].table.header.text.weight, _tokens["default"].table.header.text.size, function (_ref8) {
  var isSuperHeader = _ref8.isSuperHeader,
      hasSuperHeader = _ref8.hasSuperHeader;
  return isSuperHeader || hasSuperHeader ? _tokens["default"].colors.secondary100 : 'none';
});

exports.HeaderCell = HeaderCell;

var DisplayNameWrapper = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__DisplayNameWrapper",
  componentId: "sc-1lpkd1l-3"
})(["display:flex;cursor:", ";"], function (_ref9) {
  var isSortable = _ref9.isSortable;
  return isSortable ? 'pointer' : 'default';
});

exports.DisplayNameWrapper = DisplayNameWrapper;

var SortingCaret = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__SortingCaret",
  componentId: "sc-1lpkd1l-4"
})(["margin-left:4px;visibility:", ";display:flex;flex-direction:column;justify-content:center;", ":hover &{visibility:visible;}"], function (_ref10) {
  var visible = _ref10.visible;
  return visible ? 'visible' : 'hidden';
}, DisplayNameWrapper);

exports.SortingCaret = SortingCaret;

var Tooltip = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__Tooltip",
  componentId: "sc-1lpkd1l-5"
})(["margin-left:5px;position:relative;top:-1px;"]);

exports.Tooltip = Tooltip;

var SuperHeaderPadding = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__SuperHeaderPadding",
  componentId: "sc-1lpkd1l-6"
})(["padding-left:", ";padding-right:", ";box-sizing:border-box;border-bottom:", "px solid ", ";"], function (_ref11) {
  var isStartOfSuperHeader = _ref11.isStartOfSuperHeader,
      fitContainer = _ref11.fitContainer;
  return isStartOfSuperHeader ? "".concat(horizontalPadding(fitContainer), "px") : '0';
}, function (_ref12) {
  var isEndOfSuperHeader = _ref12.isEndOfSuperHeader,
      isLastCol = _ref12.isLastCol,
      fitContainer = _ref12.fitContainer;
  return isEndOfSuperHeader && !isLastCol ? "".concat(horizontalPadding(fitContainer), "px") : '0';
}, function (_ref13) {
  var isSuperHeader = _ref13.isSuperHeader;
  return isSuperHeader ? 0 : 1;
}, _tokens["default"].table.header.border.color);

exports.SuperHeaderPadding = SuperHeaderPadding;

var TableWrapper = _styledComponents["default"].div.withConfig({
  displayName: "Tablestyles__TableWrapper",
  componentId: "sc-1lpkd1l-7"
})(["", " & .public_fixedDataTable_main{border:none;}& .public_fixedDataTable_scrollbarSpacer,.public_Scrollbar_main,.public_fixedDataTableRow_columnsShadow{display:none;}& .public_fixedDataTableCell_cellContent{padding:0;}& .public_fixedDataTableCell_main{border-right:none;background-color:inherit;}& .public_fixedDataTableRow_highlighted .public_fixedDataTableCell_main{background-color:inherit;}& .public_fixedDataTable_header{background-color:", ";border-bottom:none;box-sizing:border-box;}& .public_fixedDataTable_bodyRow{background-color:", ";border-bottom:1px solid ", ";box-sizing:border-box;cursor:", ";&:hover{background-color:", ";& ", "{background-color:", " !important;}& ", "{background-color:", " !important;}}}.fixedDataTableRowLayout_rowWrapper:last-child .public_fixedDataTable_bodyRow{border-bottom-color:transparent;}& .public_fixedDataTable_header,.public_fixedDataTable_header .public_fixedDataTableCell_main{background-color:", ";background-image:none;}& .public_fixedDataTable_bottomShadow,.public_fixedDataTable_topShadow{display:none;}"], _fixedDataTable["default"], _tokens["default"].colors.background.light, _tokens["default"].colors.background.light, _tokens["default"].table.row.border.color, function (_ref14) {
  var hasOnClick = _ref14.hasOnClick;
  return hasOnClick ? 'pointer' : 'default';
}, function (_ref15) {
  var hasOnClick = _ref15.hasOnClick;
  return hasOnClick ? _tokens["default"].table.row.background.color.hover : _tokens["default"].table.row.background.color.readOnlyHover;
}, SuperHeaderPadding, function (_ref16) {
  var hasOnClick = _ref16.hasOnClick;
  return hasOnClick ? _tokens["default"].table.row.background.color.hover : _tokens["default"].table.row.background.color.readOnlyHover;
}, BodyCell, function (_ref17) {
  var hasOnClick = _ref17.hasOnClick;
  return hasOnClick ? _tokens["default"].table.row.background.color.hover : _tokens["default"].table.row.background.color.readOnlyHover;
}, _tokens["default"].colors.background.light);

exports.TableWrapper = TableWrapper;