"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactVirtualized = require("react-virtualized");

var _fixedDataTable = require("fixed-data-table-2");

var _BodyCell = _interopRequireDefault(require("./BodyCell"));

var _HeaderCell = _interopRequireDefault(require("./HeaderCell"));

var Styles = _interopRequireWildcard(require("./Table.styles"));

var placeholderRowCount = 0;

var TableGrid =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(TableGrid, _React$Component);

  function TableGrid() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TableGrid);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TableGrid)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      sorting: _this.props.sortOrder
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "headerHeight", 25);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "superHeaderHeight", 35);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "cache", new _reactVirtualized.CellMeasurerCache({
      defaultHeight: _this.props.rowHeight,
      fixedHeight: true
    }));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "defaultRowRenderer", function (row) {
      return _this.props.columns.map(function (c) {
        return (0, _defineProperty2["default"])({}, c.key, row[c.key]);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calculateWidth", function (requestedWidth, column) {
      var adjustment = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var fitContainer = _this.props.fitContainer;
      var width = column.width;

      if (width) {
        return width;
      }

      if (adjustment < 0) {
        if (fitContainer) {
          return requestedWidth + adjustment;
        }

        return requestedWidth;
      }

      return requestedWidth + Math.floor(adjustment);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColumnWidth", function (width) {
      return function (_ref2) {
        var index = _ref2.index;
        var columns = _this.props.columns;
        var excessWidth = width - _this.totalRequestedWidth;

        var requestedWidth = _this.cache.columnWidth({
          index: index
        });

        var setWidth = columns[index].width ? 0 : columns.reduce(function (acc, curr) {
          if (curr.width) {
            return acc + curr.width;
          }

          return acc;
        }, 0);

        var calculatedWidth = _this.calculateWidth(requestedWidth, columns[index], columns[index].width ? 0 : excessWidth * (requestedWidth / (_this.totalRequestedWidth - setWidth)));

        return calculatedWidth;
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "cellRenderer", function (cellArgs) {
      var _this$props = _this.props,
          rowsMap = _this$props.rowsMap,
          superHeaders = _this$props.superHeaders,
          columns = _this$props.columns,
          fitContainer = _this$props.fitContainer,
          customRowRenderer = _this$props.rowRenderer;
      var rowRenderer = customRowRenderer || _this.defaultRowRenderer;
      var rowIndex = cellArgs.rowIndex;
      var columnIndex = cellArgs.columnIndex;

      if (rowsMap && rowsMap.has(rowIndex)) {
        var columnKey = columns[columnIndex].key;
        var rowDatum = rowsMap.get(rowIndex);
        var cell = rowRenderer(rowDatum, columnKey);
        var isStartOfSuperHeader = Boolean(superHeaders.find(function (sh) {
          return sh.startIdx === columnIndex;
        }));
        var isEndOfSuperHeader = Boolean(superHeaders.find(function (sh) {
          return sh.endIdx === columnIndex;
        }));
        var hasSuperHeader = Boolean(superHeaders.find(function (sh) {
          return sh.startIdx <= columnIndex && sh.endIdx >= columnIndex;
        }));
        return _react["default"].createElement(_reactVirtualized.CellMeasurer, {
          cache: _this.cache,
          columnIndex: columnIndex,
          key: "cell-".concat(cellArgs.rowIndex, "-").concat(columnIndex),
          parent: cellArgs.parent,
          rowIndex: cellArgs.rowIndex + 1
        }, _react["default"].createElement(_fixedDataTable.Cell, null, _react["default"].createElement(_BodyCell["default"], {
          fitContainer: fitContainer,
          alignment: columns[columnIndex].alignment,
          hasSuperHeader: hasSuperHeader,
          isEndOfSuperHeader: isEndOfSuperHeader,
          isLastCol: cellArgs.columnIndex === _this.columnCount - 1,
          isStartOfSuperHeader: isStartOfSuperHeader,
          style: cellArgs.style
        }, cell)));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnSort", function (columnKey) {
      return function (sortDirection) {
        var onSortChange = _this.props.onSortChange;

        _this.setState({
          sorting: [{
            key: columnKey,
            order: sortDirection
          }]
        }, function () {
          return onSortChange && onSortChange([{
            key: columnKey,
            order: sortDirection
          }]);
        });
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getSortDirection", function (columnKey) {
      var sorting = _this.state.sorting;
      var sort = sorting.find(function (s) {
        return s.key === columnKey;
      });
      return sort && sort.order;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "headerCellRenderer", function (cellArgs) {
      var _this$props2 = _this.props,
          superHeaders = _this$props2.superHeaders,
          columns = _this$props2.columns,
          fitContainer = _this$props2.fitContainer;
      var _columns$cellArgs$col = columns[cellArgs.columnIndex],
          alignment = _columns$cellArgs$col.alignment,
          tooltipConfig = _columns$cellArgs$col.tooltipConfig,
          displayName = _columns$cellArgs$col.displayName,
          sortable = _columns$cellArgs$col.sortable,
          key = _columns$cellArgs$col.key;
      var isStartOfSuperHeader = Boolean(superHeaders.find(function (sh) {
        return sh.startIdx === cellArgs.columnIndex;
      }));
      var isEndOfSuperHeader = Boolean(superHeaders.find(function (sh) {
        return sh.endIdx === cellArgs.columnIndex;
      }));
      return _react["default"].createElement(_reactVirtualized.CellMeasurer, {
        cache: _this.cache,
        columnIndex: cellArgs.columnIndex,
        key: "cell-".concat(cellArgs.rowIndex, "-").concat(cellArgs.columnIndex),
        parent: cellArgs.parent,
        rowIndex: 0
      }, _react["default"].createElement(_fixedDataTable.Cell, null, _react["default"].createElement(_HeaderCell["default"], {
        fitContainer: fitContainer,
        alignment: alignment,
        displayName: displayName,
        hasSuperHeader: Boolean(superHeaders.find(function (sh) {
          return sh.startIdx <= cellArgs.columnIndex && sh.endIdx >= cellArgs.columnIndex;
        })),
        isEndOfSuperHeader: isEndOfSuperHeader,
        isLastCol: cellArgs.columnIndex === _this.columnCount - 1,
        isStartOfSuperHeader: isStartOfSuperHeader,
        isSortable: sortable,
        sortDirection: sortable && _this.getSortDirection(key),
        style: cellArgs.style,
        tooltipConfig: tooltipConfig,
        onSortChange: _this.handleOnSort(key)
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onTableScroll", function (scrollTop) {
      var _this$props3 = _this.props,
          height = _this$props3.height,
          rowHeight = _this$props3.rowHeight,
          rowFetcherRowOffset = _this$props3.rowFetcherRowOffset,
          fetchRows = _this$props3.fetchRows;

      if (fetchRows) {
        var tableRowHeight = _this.rowCount * rowHeight;
        var lastRowTriggerHeight = rowHeight * rowFetcherRowOffset;
        var scrollTopTrigger = tableRowHeight - height - lastRowTriggerHeight;

        if (scrollTop > scrollTopTrigger) {
          fetchRows();
        }
      }

      return true;
    });
    return _this;
  }

  (0, _createClass2["default"])(TableGrid, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          width = _this$props4.width,
          height = _this$props4.height,
          noHeader = _this$props4.noHeader,
          columns = _this$props4.columns,
          rowHeight = _this$props4.rowHeight,
          _onRowClick = _this$props4.onRowClick,
          rowsMap = _this$props4.rowsMap,
          superHeaders = _this$props4.superHeaders,
          fitContainer = _this$props4.fitContainer,
          allowCellsRecycling = _this$props4.allowCellsRecycling;
      var content = [];
      var superHeaderColumns = [];
      columns.forEach(function (col, columnIndex) {
        var column = _react["default"].createElement(_fixedDataTable.Column, {
          key: col.key,
          allowCellsRecycling: allowCellsRecycling,
          columnKey: col.key,
          width: _this2.getColumnWidth(width)({
            index: columnIndex
          }),
          header: noHeader ? null : function (_ref3) {
            var columnKey = _ref3.columnKey,
                h = _ref3.height,
                w = _ref3.width;
            return _this2.headerCellRenderer({
              columnKey: columnKey,
              columnIndex: columnIndex,
              style: {
                height: h,
                width: w
              }
            });
          },
          cell: function cell(_ref4) {
            var rowIndex = _ref4.rowIndex,
                columnKey = _ref4.columnKey,
                h = _ref4.height,
                w = _ref4.width;
            return _this2.cellRenderer({
              columnKey: columnKey,
              rowIndex: rowIndex,
              columnIndex: columnIndex,
              style: {
                height: h,
                width: w
              }
            });
          }
        });

        var superHeader = superHeaders.find(function (sh) {
          return columnIndex >= sh.startIdx && columnIndex <= sh.endIdx;
        });

        if (superHeader) {
          superHeaderColumns.push(column);

          if (columnIndex === superHeader.endIdx) {
            var w = 0;

            for (var i = superHeader.startIdx; i <= superHeader.endIdx; i++) {
              w += _this2.getColumnWidth(width)({
                index: i
              });
            }

            content.push(_react["default"].createElement(_fixedDataTable.ColumnGroup, {
              key: superHeader.displayName.replace(/ /g, '-'),
              header: function header(_ref5) {
                var h = _ref5.height;
                return noHeader ? null : _react["default"].createElement(_HeaderCell["default"], {
                  fitContainer: fitContainer,
                  displayName: superHeader.displayName,
                  isEndOfSuperHeader: true,
                  isStartOfSuperHeader: true,
                  isLastCol: superHeader.endIdx === _this2.columnCount - 1,
                  isSuperHeader: true,
                  style: {
                    height: h,
                    width: w
                  }
                });
              }
            }, superHeaderColumns));
            superHeaderColumns = [];
          }
        } else {
          content.push(_react["default"].createElement(_fixedDataTable.ColumnGroup, {
            key: col.key
          }, column));
        }
      });
      return _react["default"].createElement(Styles.TableWrapper, {
        hasOnClick: Boolean(_onRowClick)
      }, _react["default"].createElement(_fixedDataTable.Table, {
        width: width,
        height: height,
        rowsCount: this.rowCount,
        rowHeight: rowHeight,
        showScrollbarY: false,
        showScrollbarX: false,
        onVerticalScroll: this.onTableScroll,
        rowClassNameGetter: function rowClassNameGetter(index) {
          return "Table__row-".concat(index);
        } // subRowHeight={20}
        // subRowHeightGetter={this.getSubRowHeight}
        ,
        headerHeight: noHeader ? 0 : this.headerHeight,
        groupHeaderHeight: superHeaders.length === 0 || noHeader ? 0 : this.superHeaderHeight,
        onRowClick: function onRowClick(_, rowIndex) {
          return _onRowClick && _onRowClick(rowIndex, rowsMap.get(rowIndex));
        }
      }, content));
    }
  }, {
    key: "columnCount",
    get: function get() {
      var columns = this.props.columns;
      return columns.length;
    }
  }, {
    key: "rowCount",
    get: function get() {
      var _this$props5 = this.props,
          rowsMap = _this$props5.rowsMap,
          totalRowCount = _this$props5.totalRowCount;
      var bodyRowCount = rowsMap ? rowsMap.size : totalRowCount ? totalRowCount : placeholderRowCount;
      return bodyRowCount;
    }
  }, {
    key: "totalRequestedWidth",
    get: function get() {
      var _this3 = this;

      var width = 0;
      this.props.columns.forEach(function (c, index) {
        var requestedWidth = _this3.cache.columnWidth({
          index: index
        });

        width += _this3.calculateWidth(requestedWidth, c);
      });
      return width;
    }
  }, {
    key: "actualHeight",
    get: function get() {
      var _this$props6 = this.props,
          noHeader = _this$props6.noHeader,
          rowHeight = _this$props6.rowHeight,
          superHeaders = _this$props6.superHeaders;
      var actualHeight = 0;
      var bodyRowCount = noHeader ? this.rowCount : this.rowCount - 1;
      actualHeight += superHeaders.length > 0 ? this.superHeaderHeight : 0;
      actualHeight += noHeader ? 0 : this.headerHeight;
      actualHeight += bodyRowCount === 0 ? rowHeight : bodyRowCount * rowHeight;
      return actualHeight;
    }
  }, {
    key: "actualWidth",
    get: function get() {
      var _this4 = this;

      var _this$props7 = this.props,
          fitContainer = _this$props7.fitContainer,
          width = _this$props7.width,
          columns = _this$props7.columns;

      if (fitContainer) {
        return width;
      }

      return columns.reduce(function (acc, _, idx) {
        return acc + _this4.getColumnWidth(width)({
          index: idx
        });
      }, 0);
    }
  }]);
  return TableGrid;
}(_react["default"].Component);

exports["default"] = TableGrid;
(0, _defineProperty2["default"])(TableGrid, "defaultProps", {
  sortOrder: []
});