"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _toggle = require("../../../tokens/toggle");

var dimensions = {
  medium: {
    height: 20,
    width: 90,
    slider: 10,
    margin: 5
  },
  large: {
    height: 22,
    width: 110,
    slider: 12,
    margin: 10
  }
};

var Label = _styledComponents["default"].label.withConfig({
  displayName: "ToggleLargeStyles__Label",
  componentId: "sc-12zifqe-0"
})(["display:flex;align-items:center;justify-content:center;height:", "px;width:", "px;background-color:", ";", " max-width:unset !important;margin-bottom:0 !important;"], function (_ref) {
  var size = _ref.size;
  return dimensions[size].height;
}, function (_ref2) {
  var size = _ref2.size;
  return dimensions[size].width;
}, function (_ref3) {
  var checked = _ref3.checked,
      size = _ref3.size;
  return _tokens["default"].toggle[size].label.color[(0, _toggle.getToggleState)(checked)];
}, function (_ref4) {
  var disabled = _ref4.disabled;
  return disabled ? "\n    cursor: not-allowed;\n    opacity: 0.3;\n  " : 'cursor: pointer;';
});

var Slider = _styledComponents["default"].span.withConfig({
  displayName: "ToggleLargeStyles__Slider",
  componentId: "sc-12zifqe-1"
})(["position:absolute;cursor:pointer;top:0;left:0;right:0;bottom:0;background-color:", ";-webkit-transition:.4s;transition:.4s;&:before{position:absolute;content:\"\";height:", "px;width:", "px;left:0;bottom:0;background-color:", ";-webkit-transition:.4s;transition:.4s;", "}"], function (_ref5) {
  var size = _ref5.size,
      checked = _ref5.checked;
  return _tokens["default"].toggle[size].slider.color[(0, _toggle.getToggleState)(checked)];
}, function (_ref6) {
  var size = _ref6.size;
  return dimensions[size].slider;
}, function (_ref7) {
  var size = _ref7.size;
  return dimensions[size].slider;
}, function (_ref8) {
  var size = _ref8.size;
  return _tokens["default"].toggle[size].slider.color.before;
}, function (_ref9) {
  var checked = _ref9.checked,
      size = _ref9.size;
  return checked ? "\n      -webkit-transform: translateX(".concat(dimensions[size].slider, "px);\n      -ms-transform: translateX(").concat(dimensions[size].slider, "px);\n      transform: translateX(").concat(dimensions[size].slider, "px);\n    ") : '';
});

var Input = _styledComponents["default"].input.withConfig({
  displayName: "ToggleLargeStyles__Input",
  componentId: "sc-12zifqe-2"
})(["display:none;"]);

var Wrapper = _styledComponents["default"].div.withConfig({
  displayName: "ToggleLargeStyles__Wrapper",
  componentId: "sc-12zifqe-3"
})(["display:inline-block;position:relative;width:", "px;height:", "px;"], function (_ref10) {
  var size = _ref10.size;
  return dimensions[size].slider * 2;
}, function (_ref11) {
  var size = _ref11.size;
  return dimensions[size].slider;
});

var Text = _styledComponents["default"].span.withConfig({
  displayName: "ToggleLargeStyles__Text",
  componentId: "sc-12zifqe-4"
})(["color:", ";margin-left:", "px;text-transform:uppercase;font-family:", ";font-size:", ";user-select:none;letter-spacing:1px;"], function (_ref12) {
  var size = _ref12.size;
  return _tokens["default"].toggle[size].text.color;
}, function (_ref13) {
  var size = _ref13.size;
  return dimensions[size].margin;
}, function (_ref14) {
  var size = _ref14.size;
  return _tokens["default"].toggle[size].text.family;
}, function (_ref15) {
  var size = _ref15.size;
  return _tokens["default"].toggle[size].text.size;
});

var _default = {
  Label: Label,
  Slider: Slider,
  Input: Input,
  Wrapper: Wrapper,
  Text: Text
};
exports["default"] = _default;