"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../../tokens"));

var _toggle = require("../../../tokens/toggle");

var dimensions = {
  height: 14,
  width: 28,
  slider: 12,
  margin: 2
};

var Label = _styledComponents["default"].label.withConfig({
  displayName: "ToggleSmallStyles__Label",
  componentId: "sc-1w821kh-0"
})(["display:flex;align-items:center;justify-content:center;height:", "px;width:", "px;background-color:", ";", " max-width:unset !important;margin-bottom:0 !important;"], dimensions.height, dimensions.width, function (_ref) {
  var checked = _ref.checked;
  return _tokens["default"].toggle.small.label.color[(0, _toggle.getToggleState)(checked)];
}, function (_ref2) {
  var disabled = _ref2.disabled;
  return disabled ? "\n    cursor: not-allowed;\n    opacity: 0.3;\n  " : 'cursor: pointer;';
});

var Slider = _styledComponents["default"].span.withConfig({
  displayName: "ToggleSmallStyles__Slider",
  componentId: "sc-1w821kh-1"
})(["position:relative;content:\"\";height:", "px;width:", "px;left:-7px;bottom:0;background-color:", ";-webkit-transition:.4s;transition:.4s;", ""], dimensions.slider, dimensions.slider, _tokens["default"].toggle.small.slider.color, function (_ref3) {
  var checked = _ref3.checked;
  return checked ? "\n  -webkit-transform: translateX(".concat(dimensions.slider + dimensions.margin, "px);\n  -ms-transform: translateX(").concat(dimensions.slider + dimensions.margin, "px);\n  transform: translateX(").concat(dimensions.slider + dimensions.margin, "px);\n  ") : '';
});

var Input = _styledComponents["default"].input.withConfig({
  displayName: "ToggleSmallStyles__Input",
  componentId: "sc-1w821kh-2"
})(["display:none;"]);

var _default = {
  Label: Label,
  Slider: Slider,
  Input: Input
};
exports["default"] = _default;