"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TooltipWrapper = exports.Container = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _tokens = _interopRequireDefault(require("../../tokens"));

var tooltipColor = _tokens["default"].tooltip.background.color;
var arrowSize = 5;
var arrowPosition = {
  top: 'top: 100%; left: 50%;',
  right: 'right: 100%; top: 50%;',
  bottom: 'bottom: 100%; left: 50%;',
  left: 'left: 100%; top: 50%;'
};
var after = {
  top: "border-top-color: ".concat(tooltipColor, "; margin-left: -").concat(arrowSize, "px;"),
  right: "border-right-color: ".concat(tooltipColor, "; margin-top: -").concat(arrowSize, "px;"),
  bottom: "border-bottom-color: ".concat(tooltipColor, "; margin-left: -").concat(arrowSize, "px;"),
  left: "border-left-color: ".concat(tooltipColor, "; margin-top: -").concat(arrowSize, "px;")
};
var before = {
  top: "border-top-color: ".concat(tooltipColor, "; margin-left: -").concat(arrowSize + 1, "px;"),
  right: "border-right-color: ".concat(tooltipColor, "; margin-top: -").concat(arrowSize + 1, "px;"),
  bottom: "border-bottom-color: ".concat(tooltipColor, "; margin-left: -").concat(arrowSize + 1, "px;"),
  left: "border-left-color: ".concat(tooltipColor, "; margin-top: -").concat(arrowSize + 1, "px;")
};

var tooltipPosition = function tooltipPosition(_ref) {
  var width = _ref.width,
      height = _ref.height,
      _ref$targetRect = _ref.targetRect,
      top = _ref$targetRect.top,
      left = _ref$targetRect.left,
      tWidth = _ref$targetRect.width,
      tHeight = _ref$targetRect.height;
  return {
    top: "\n    top: ".concat(top - height - arrowSize, "px;\n    left: ").concat(left + tWidth / 2 - width / 2, "px;\n  "),
    right: "\n    top: ".concat(top + tHeight / 2 - height / 2, "px;\n    left: ").concat(left + tWidth + arrowSize, "px;\n  "),
    bottom: "\n    top: ".concat(top + tHeight + arrowSize, "px;\n    left: ").concat(left + tWidth / 2 - width / 2, "px;\n  "),
    left: "\n    top: ".concat(top + tHeight / 2 - height / 2, "px;\n    left: ").concat(left - width - arrowSize, "px;\n  ")
  };
};

var Container = _styledComponents["default"].div.withConfig({
  displayName: "Tooltipstyles__Container",
  componentId: "sc-1icnee5-0"
})(["font-family:", ";font-size:", ";color:", ";background-color:", ";padding:5px;text-align:center;border:1px solid ", ";max-width:200px;word-break:break-word;overflow-wrap:break-word;z-index:2147483647 !important;display:flex;position:fixed;", " &:after,&:before{border:solid transparent;content:' ';height:0;width:0;position:absolute;pointer-events:none;", ";}&:after{border-color:rgba(0,0,0,0);border-width:", "px;", ";}&:before{border-color:rgba(0,0,0,0);border-width:", "px;", ";}"], _tokens["default"].tooltip.text.family, _tokens["default"].tooltip.text.size, _tokens["default"].tooltip.text.color, tooltipColor, tooltipColor, function (props) {
  return tooltipPosition(props)[props.tooltipPlacement];
}, function (props) {
  return arrowPosition[props.tooltipPlacement];
}, arrowSize, function (props) {
  return after[props.tooltipPlacement];
}, arrowSize + 1, function (props) {
  return before[props.tooltipPlacement];
});

exports.Container = Container;

var getOverflow = function getOverflow(_ref2) {
  var showOnOverflow = _ref2.showOnOverflow;
  return showOnOverflow ? 'hidden' : 'initial';
};

var getTextOverflow = function getTextOverflow(_ref3) {
  var showOnOverflow = _ref3.showOnOverflow;
  return showOnOverflow ? 'ellipsis' : 'initial';
};

var TooltipWrapper = _styledComponents["default"].div.withConfig({
  displayName: "Tooltipstyles__TooltipWrapper",
  componentId: "sc-1icnee5-1"
})(["overflow:", ";text-overflow:", ";"], getOverflow, getTextOverflow);

exports.TooltipWrapper = TooltipWrapper;