"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _Tooltip = _interopRequireDefault(require("./Tooltip"));

var _OverlayTrigger = _interopRequireDefault(require("../OverlayTrigger"));

var Styles = _interopRequireWildcard(require("./Tooltip.styles.js"));

var id = 0;

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

var withTooltip = function withTooltip(WrappedComponent) {
  var WithTooltip =
  /*#__PURE__*/
  function (_React$Component) {
    (0, _inherits2["default"])(WithTooltip, _React$Component);

    function WithTooltip(props) {
      var _this;

      (0, _classCallCheck2["default"])(this, WithTooltip);
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(WithTooltip).call(this, props));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
        isTextHidden: false
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "checkOverflow", function () {
        var isTextHidden = _this.state.isTextHidden;

        if (_this.tooltipContainer && _this.tooltipContainer.current) {
          var node = _this.tooltipContainer.current;
          var isOverflowActive = node.clientWidth < node.scrollWidth;
          isTextHidden !== isOverflowActive && _this.setState({
            isTextHidden: isOverflowActive
          });
        }
      });
      _this.tooltipContainer = _react["default"].createRef();
      return _this;
    }

    (0, _createClass2["default"])(WithTooltip, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var showOnOverflow = this.props.showOnOverflow;

        if (showOnOverflow) {
          this.checkOverflow();
          window.addEventListener('resize', this.checkOverflow);
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        var showOnOverflow = this.props.showOnOverflow;

        if (showOnOverflow) {
          window.removeEventListener('resize', this.checkOverflow);
        }
      }
    }, {
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            tooltipText = _this$props.tooltipText,
            _this$props$tooltipPl = _this$props.tooltipPlacement,
            tooltipPlacement = _this$props$tooltipPl === void 0 ? 'top' : _this$props$tooltipPl,
            _this$props$tooltipWr = _this$props.tooltipWrapperClassName,
            tooltipWrapperClassName = _this$props$tooltipWr === void 0 ? '' : _this$props$tooltipWr,
            interactive = _this$props.interactive,
            showOnOverflow = _this$props.showOnOverflow,
            otherProps = (0, _objectWithoutProperties2["default"])(_this$props, ["tooltipText", "tooltipPlacement", "tooltipWrapperClassName", "interactive", "showOnOverflow"]);
        var isTextHidden = this.state.isTextHidden;

        if (!tooltipText) {
          return _react["default"].createElement(WrappedComponent, otherProps);
        }

        return _react["default"].createElement(_OverlayTrigger["default"], {
          interactive: interactive,
          disabled: showOnOverflow && !isTextHidden,
          renderOverlay: function renderOverlay(targetRect) {
            return _react["default"].createElement(_Tooltip["default"], {
              id: "tooltip-".concat(id++),
              tooltipPlacement: tooltipPlacement,
              targetRect: targetRect
            }, tooltipText);
          },
          render: function render(triggerProps) {
            return _react["default"].createElement(Styles.TooltipWrapper, (0, _extends2["default"])({
              showOnOverflow: showOnOverflow,
              className: "SML-TooltipWrapper ".concat(tooltipWrapperClassName),
              ref: _this2.tooltipContainer
            }, triggerProps), _react["default"].createElement(WrappedComponent, otherProps));
          }
        });
      }
    }]);
    return WithTooltip;
  }(_react["default"].Component);

  (0, _defineProperty2["default"])(WithTooltip, "displayName", "WithTooltip(".concat(getDisplayName(WrappedComponent), ")"));
  return WithTooltip;
};

var _default = withTooltip;
exports["default"] = _default;