"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _tokens = _interopRequireWildcard(require("../../../tokens"));

var getTextTransformCSS = function getTextTransformCSS(textTransform) {
  switch (textTransform) {
    case _tokens.FontConstants.textTransform.lowerCase:
      return 'text-transform: lowercase;';

    case _tokens.FontConstants.textTransform.upperCase:
      return 'text-transform: uppercase;';

    case _tokens.FontConstants.textTransform.sentenceCase:
      return 'text-transform: none;';

    default:
      return '';
  }
};

var baseStyles = function baseStyles(_ref) {
  var fontFamily = _ref.fontFamily,
      fontSize = _ref.fontSize,
      fontWeight = _ref.fontWeight,
      color = _ref.color,
      letterSpacing = _ref.letterSpacing,
      italic = _ref.italic,
      textTransform = _ref.textTransform,
      link = _ref.link,
      overflow = _ref.overflow,
      _ref$mixins = _ref.mixins,
      mixins = _ref$mixins === void 0 ? [] : _ref$mixins;
  return (0, _styledComponents.css)(["display:inline-block;font-family:", ";font-size:", ";font-weight:", ";color:", ";cursor:", ";", " ", " ", " ", " ", " ", ""], _tokens["default"].fonts.family[fontFamily] || _tokens["default"].fonts.family["default"], _tokens["default"].fonts.size[fontSize] || _tokens["default"].fonts.size["default"], _tokens["default"].fonts.weight[fontWeight] || _tokens["default"].fonts.weight["default"], link ? _tokens["default"].colors.text.link : color, link ? 'pointer' : 'inherit', link ? "\n    &:hover {\n      color: ".concat(_tokens["default"].colors.text.linkHover, ";\n    }\n  ") : '', letterSpacing ? "letter-spacing: ".concat(letterSpacing, "px;") : '', italic ? 'font-style: italic;' : '', getTextTransformCSS(textTransform), overflow ? "\n    overflow-x: hidden;\n    text-overflow: ellipsis;\n    white-space: nowrap;" : '', mixins);
};

var StyledSpan = _styledComponents["default"].span.withConfig({
  displayName: "BaseText__StyledSpan",
  componentId: "sc-436io2-0"
})(["", ""], function (props) {
  return baseStyles(props);
});

var InternalLink = (0, _styledComponents["default"])(_reactRouterDom.Link).withConfig({
  displayName: "BaseText__InternalLink",
  componentId: "sc-436io2-1"
})(["", ""], function (props) {
  return baseStyles(props);
});

var ExternalLink = _styledComponents["default"].a.withConfig({
  displayName: "BaseText__ExternalLink",
  componentId: "sc-436io2-2"
})(["", ""], function (props) {
  return baseStyles(props);
});

var BaseText =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2["default"])(BaseText, _React$PureComponent);

  function BaseText() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, BaseText);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(BaseText)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "textToSentenceCase", function (text) {
      return text.charAt(0).toUpperCase() + text.slice(1).toLowerCase();
    });
    return _this;
  }

  (0, _createClass2["default"])(BaseText, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          color = _this$props.color,
          fontFamily = _this$props.fontFamily,
          fontSize = _this$props.fontSize,
          fontWeight = _this$props.fontWeight,
          italic = _this$props.italic,
          letterSpacing = _this$props.letterSpacing,
          textTransform = _this$props.textTransform,
          link = _this$props.link,
          href = _this$props.href,
          target = _this$props.target,
          children = _this$props.children,
          mixins = _this$props.mixins,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props, ["color", "fontFamily", "fontSize", "fontWeight", "italic", "letterSpacing", "textTransform", "link", "href", "target", "children", "mixins"]);
      var text = textTransform === 'sentence-case' && typeof children === 'string' ? this.textToSentenceCase(children) : children;
      var spanProps = (0, _objectSpread2["default"])({
        color: color,
        fontFamily: fontFamily,
        fontSize: fontSize,
        fontWeight: fontWeight,
        italic: italic,
        letterSpacing: letterSpacing,
        textTransform: textTransform,
        link: link,
        mixins: mixins
      }, otherProps);

      if (link && href) {
        if (href.startsWith('http')) {
          return _react["default"].createElement(ExternalLink, (0, _extends2["default"])({}, spanProps, {
            href: href,
            target: target,
            rel: target === '_blank' && 'noopener noreferrer'
          }), text);
        }

        return _react["default"].createElement(InternalLink, (0, _extends2["default"])({}, spanProps, {
          to: href,
          target: target
        }), text);
      }

      return _react["default"].createElement(StyledSpan, spanProps, text);
    }
  }]);
  return BaseText;
}(_react["default"].PureComponent);

exports["default"] = BaseText;
(0, _defineProperty2["default"])(BaseText, "defaultProps", {
  fontFamily: 'default'
});