"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _BaseText = _interopRequireDefault(require("../BaseText"));

var _tokens = _interopRequireWildcard(require("../../../tokens"));

var Text =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2["default"])(Text, _React$PureComponent);

  function Text() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Text);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Text)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "checkProps", function () {
      var _this$props = _this.props,
          primary = _this$props.primary,
          secondary = _this$props.secondary,
          subtle = _this$props.subtle,
          big = _this$props.big,
          normal = _this$props.normal,
          small = _this$props.small;

      if (normal && big || normal && small || small && big) {
        throw new Error();
      }

      if (!small && !normal && !big) {
        throw new Error();
      }

      if (primary && secondary || primary && subtle && secondary && subtle) {
        throw new Error();
      }

      if (!primary && !secondary && !subtle) {
        throw new Error();
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(Text, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkProps();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.checkProps();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          link = _this$props2.link,
          href = _this$props2.href,
          target = _this$props2.target,
          children = _this$props2.children,
          mixins = _this$props2.mixins,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["link", "href", "target", "children", "mixins"]);
      return _react["default"].createElement(_BaseText["default"], (0, _extends2["default"])({
        fontFamily: this.fontFamily,
        fontSize: this.fontSize,
        fontWeight: this.fontWeight,
        textTransform: this.textTransform,
        color: this.color,
        italic: this.italic,
        link: link,
        href: href,
        target: target,
        mixins: mixins
      }, otherProps), children);
    }
  }, {
    key: "fontSize",
    get: function get() {
      var _this$props3 = this.props,
          big = _this$props3.big,
          normal = _this$props3.normal,
          small = _this$props3.small;

      if (big) {
        return _tokens.FontConstants.size.medium;
      }

      if (normal) {
        return _tokens.FontConstants.size.small;
      }

      if (small) {
        return _tokens.FontConstants.size.xsmall;
      }

      return _tokens.FontConstants.size.medium;
    }
  }, {
    key: "fontFamily",
    get: function get() {
      return _tokens.FontConstants.family["default"];
    }
  }, {
    key: "fontWeight",
    get: function get() {
      var bold = this.props.bold;

      if (bold) {
        return _tokens.FontConstants.weight.bold;
      }

      return _tokens.FontConstants.weight.regular;
    }
  }, {
    key: "textTransform",
    get: function get() {
      var _this$props4 = this.props,
          link = _this$props4.link,
          sentenceCase = _this$props4.sentenceCase;

      if (link) {
        return null;
      }

      if (sentenceCase) {
        return _tokens.FontConstants.textTransform.sentenceCase;
      }

      return null;
    }
  }, {
    key: "color",
    get: function get() {
      var _this$props5 = this.props,
          primary = _this$props5.primary,
          secondary = _this$props5.secondary,
          subtle = _this$props5.subtle,
          inverse = _this$props5.inverse,
          color = _this$props5.color;

      if (color) {
        return color;
      }

      if (inverse) {
        return _tokens["default"].colors.text.dark;
      }

      if (primary) {
        return _tokens["default"].colors.text.secondary;
      }

      if (secondary) {
        return _tokens["default"].colors.text.primary;
      }

      if (subtle) {
        return _tokens["default"].colors.text.subtle;
      }

      return _tokens["default"].colors.text.primary;
    }
  }, {
    key: "italic",
    get: function get() {
      var italic = this.props.italic;
      return Boolean(italic);
    }
  }]);
  return Text;
}(_react["default"].PureComponent);

exports["default"] = Text;