"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _styledComponents = require("styled-components");

var _hexToRgba = _interopRequireDefault(require("hex-to-rgba"));

var blinker = function blinker(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'background-color' : _ref$type,
      color = _ref.color,
      _ref$lowestAlpha = _ref.lowestAlpha,
      lowestAlpha = _ref$lowestAlpha === void 0 ? 0 : _ref$lowestAlpha,
      _ref$highestAlpha = _ref.highestAlpha,
      highestAlpha = _ref$highestAlpha === void 0 ? 0.5 : _ref$highestAlpha,
      _ref$time = _ref.time,
      time = _ref$time === void 0 ? 1 : _ref$time;
  var keyframe = (0, _styledComponents.keyframes)([""]);

  switch (type) {
    case 'background-color':
      {
        keyframe = (0, _styledComponents.keyframes)(["0%{background-color:", ";}50%{background-color:", ";}"], (0, _hexToRgba["default"])(color, lowestAlpha), (0, _hexToRgba["default"])(color, highestAlpha));
        break;
      }

    case 'opacity':
      {
        keyframe = (0, _styledComponents.keyframes)(["50%{opacity:", ";}"], lowestAlpha);
        break;
      }

    default:
      break;
  }

  return (0, _styledComponents.css)(["animation:", " ", "s linear infinite"], keyframe, time);
};

var _default = blinker;
exports["default"] = _default;