"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.avatar = exports.getAvatarBackgroundKey = exports.getAvatarTextKey = exports.getAvatarColor = exports.AvatarConstants = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var _size;

var sizes = {
  xsmall: 'xsmall',
  small: 'small',
  medium: 'medium',
  large: 'large'
};
var avatarColors = {
  brand: 'brand',
  secondary: 'secondary'
};
var AvatarConstants = {
  sizes: sizes,
  colors: avatarColors
};
exports.AvatarConstants = AvatarConstants;

var getAvatarColor = function getAvatarColor(brand, secondary) {
  return brand ? AvatarConstants.colors.brand : secondary ? AvatarConstants.colors.secondary : AvatarConstants.colors.secondary;
};

exports.getAvatarColor = getAvatarColor;

var getAvatarTextKey = function getAvatarTextKey(inverse) {
  return inverse ? 'dark' : 'light';
};

exports.getAvatarTextKey = getAvatarTextKey;

var getAvatarBackgroundKey = function getAvatarBackgroundKey(inverse) {
  return inverse ? 'light' : 'dark';
};

exports.getAvatarBackgroundKey = getAvatarBackgroundKey;
var avatar = {
  color: {
    brand: {
      light: _colors.colors.background.light,
      dark: _colors.colors.brand500
    },
    secondary: {
      light: _colors.colors.background.light,
      dark: _colors.colors.text.primaryLight
    }
  },
  text: {
    family: _fonts.fonts.family["default"],
    weight: _fonts.fonts.weight.regular,
    size: (_size = {}, (0, _defineProperty2["default"])(_size, sizes.xsmall, _fonts.fonts.size.xsmall), (0, _defineProperty2["default"])(_size, sizes.small, _fonts.fonts.size.small), (0, _defineProperty2["default"])(_size, sizes.medium, _fonts.fonts.size.medium), (0, _defineProperty2["default"])(_size, sizes.large, _fonts.fonts.size.large), _size)
  }
};
exports.avatar = avatar;