"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.button = exports.getButtonState = exports.ButtonConstants = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var _size;

var sizes = {
  xsmall: 'xsmall',
  small: 'small',
  medium: 'medium',
  large: 'large'
};
var styles = {
  filled: 'filled',
  outline: 'outline',
  naked: 'naked'
};
var buttonColors = {
  primary: 'primary',
  secondary: 'secondary',
  danger: 'danger',
  brand: 'brand',
  inverse: 'inverse'
};
var states = {
  "default": 'default',
  hover: 'hover',
  disabled: 'disabled'
};
var ButtonConstants = {
  sizes: sizes,
  styles: styles,
  states: states,
  colors: buttonColors
};
exports.ButtonConstants = ButtonConstants;

var getButtonState = function getButtonState(disabled, hover) {
  return disabled ? ButtonConstants.states.disabled : hover ? ButtonConstants.states.hover : ButtonConstants.states["default"];
};

exports.getButtonState = getButtonState;
var button = {
  sizes: sizes,
  styles: styles,
  colors: {
    filled: {
      primary: {
        "default": _colors.colors.secondary900,
        hover: _colors.colors.brand500,
        disabled: _colors.colors.secondary300
      },
      danger: {
        "default": _colors.colors.danger500,
        hover: _colors.colors.danger700,
        disabled: _colors.colors.danger200
      }
    },
    outline: {
      primary: {
        "default": _colors.colors.secondary900,
        hover: _colors.colors.brand500,
        disabled: _colors.colors.secondary300
      },
      danger: {
        "default": _colors.colors.danger500,
        hover: _colors.colors.danger600,
        disabled: _colors.colors.danger200
      }
    },
    naked: {
      primary: {
        "default": _colors.colors.secondary900,
        hover: _colors.colors.brand500,
        disabled: _colors.colors.secondary300
      },
      secondary: {
        "default": _colors.colors.secondary500,
        hover: _colors.colors.brand500,
        disabled: _colors.colors.secondary200
      },
      danger: {
        "default": _colors.colors.secondary500,
        hover: _colors.colors.danger500,
        disabled: _colors.colors.danger300
      },
      brand: {
        "default": _colors.colors.brand500,
        hover: _colors.colors.brand600,
        disabled: _colors.colors.brand200
      },
      inverse: {
        "default": _colors.colors.white,
        hover: _colors.colors.brand500,
        disabled: _colors.colors.brand200
      }
    }
  },
  text: {
    color: _colors.colors.white,
    family: _fonts.fonts.family["default"],
    size: (_size = {}, (0, _defineProperty2["default"])(_size, sizes.xsmall, _fonts.fonts.size.xsmall), (0, _defineProperty2["default"])(_size, sizes.small, _fonts.fonts.size.xsmall), (0, _defineProperty2["default"])(_size, sizes.medium, _fonts.fonts.size.small), (0, _defineProperty2["default"])(_size, sizes.large, _fonts.fonts.size.medium), _size),
    weight: _fonts.fonts.weight.bold
  },
  dimensions: {}
};
exports.button = button;