"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkbox = exports.getCheckboxState = exports.getCheckboxSize = exports.CheckboxConstants = void 0;

var _colors = require("./colors");

var _fonts = require("./fonts");

var styles = {
  small: 'small',
  big: 'big'
};
var states = {
  unchecked: 'unchecked',
  checked: 'checked'
};
var CheckboxConstants = {
  styles: styles,
  states: states
};
exports.CheckboxConstants = CheckboxConstants;

var getCheckboxSize = function getCheckboxSize(small) {
  return small ? CheckboxConstants.styles.small : CheckboxConstants.styles.big;
};

exports.getCheckboxSize = getCheckboxSize;

var getCheckboxState = function getCheckboxState(checked) {
  return checked ? CheckboxConstants.states.checked : CheckboxConstants.states.unchecked;
};

exports.getCheckboxState = getCheckboxState;
var checkbox = {
  styles: styles,
  size: {
    small: 12,
    big: 16
  },
  background: {
    color: {
      unchecked: _colors.colors.white,
      checked: _colors.colors.brand500,
      hover: _colors.colors.brand400
    }
  },
  icon: {
    color: _colors.colors.white
  },
  text: {
    color: _colors.colors.text.primary,
    family: _fonts.fonts.family["default"],
    weight: _fonts.fonts.weight.regular,
    size: {
      small: _fonts.fonts.size.small,
      big: _fonts.fonts.size.medium
    }
  },
  border: {
    color: {
      "default": _colors.colors.secondary200,
      hover: _colors.colors.brand500
    },
    width: {
      small: 1,
      big: 2
    }
  }
};
exports.checkbox = checkbox;