"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.colors = void 0;

var _color = _interopRequireDefault(require("color"));

var colors = {
  white: '#fff',
  black: '#000',
  brand100: '#feedec',
  brand200: '#fdcecb',
  brand300: '#fcafaa',
  brand400: '#fb9189',
  brand500: '#fa7268',
  brand600: '#f95347',
  brand700: '#f83526',
  brand800: '#f41808',
  brand900: '#d31507',
  secondary100: '#f9f9f9',
  secondary200: '#e8e8e8',
  secondary300: '#cfcfcf',
  secondary400: '#b5b5b5',
  secondary500: '#9c9c9c',
  secondary600: '#828282',
  secondary700: '#606060',
  secondary800: '#3e3e3e',
  secondary900: '#1c1c1c',
  success100: '#92F3C7',
  success200: '#64EEB0',
  success300: '#36EA98',
  success400: '#17D67F',
  success500: '#12A864',
  success600: '#0F8952',
  success700: '#0B6B3F',
  success800: '#084C2D',
  success900: '#052D1B',
  warning100: '#fdf7dc',
  warning200: '#fbecac',
  warning300: '#f9e17b',
  warning400: '#f6d54b',
  warning500: '#f4ca1a',
  warning600: '#e1b80b',
  warning700: '#c19d09',
  warning800: '#a08308',
  warning900: '#806906',
  danger100: '#fbd2d8',
  danger200: '#f6a4af',
  danger300: '#f17687',
  danger400: '#ed475e',
  danger500: '#e81936',
  danger600: '#cb142e',
  danger700: '#ac1127',
  danger800: '#7e0d1c',
  danger900: '#4f0812'
};
exports.colors = colors;
colors.hover = (0, _color["default"])(colors.brand100).alpha(0.4).hsl().string();
colors.mask = (0, _color["default"])(colors.secondary900).alpha(0.7).hsl().string();
colors.background = {
  "default": colors.secondary100,
  light: colors.white,
  lightAlt: colors.secondary100,
  dark: colors.secondary900
};
colors.text = {
  primary: colors.secondary700,
  primaryLight: colors.secondary500,
  secondary: colors.secondary900,
  subtle: colors.secondary500,
  disabled: colors.secondary300,
  dark: colors.white,
  link: colors.secondary900,
  linkHover: colors.brand500,
  cardHeader: colors.secondary900
};