"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.datetimepicker = void 0;

var _color = _interopRequireDefault(require("color"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var datetimepicker = {
  rangeDivider: {
    color: _colors.colors.secondary600
  },
  input: {
    border: {
      color: _colors.colors.secondary300
    },
    background: {
      color: _colors.colors.background.light
    },
    boxShadow: {
      color: (0, _color["default"])(_colors.colors.secondary900).alpha(0.08).hsl().string()
    },
    text: {
      family: _fonts.fonts.family["default"],
      size: _fonts.fonts.size.medium,
      color: _colors.colors.text.secondary
    },
    calendarIcon: {
      color: _colors.colors.secondary900
    },
    clearIcon: {
      color: {
        "default": _colors.colors.secondary400,
        active: _colors.colors.danger500
      }
    }
  },
  calendar: {
    background: {
      color: _colors.colors.background.lightAlt
    },
    navigation: {
      label: {
        text: {
          family: _fonts.fonts.family["default"],
          size: _fonts.fonts.size.small,
          color: _colors.colors.text.primary
        }
      },
      arrow: {
        text: {
          family: _fonts.fonts.family["default"],
          size: _fonts.fonts.size.large,
          color: _colors.colors.brand500
        },
        background: {
          color: {
            hover: _colors.colors.hover
          }
        }
      }
    },
    weekday: {
      text: {
        family: _fonts.fonts.family.regular,
        size: _fonts.fonts.size.xsmall,
        color: _colors.colors.text.primary
      }
    },
    tile: {
      text: {
        family: _fonts.fonts.family["default"],
        size: _fonts.fonts.size.small,
        color: {
          "default": _colors.colors.text.secondary,
          neighbor: _colors.colors.text.subtle,
          active: _colors.colors.text.dark
        }
      },
      background: {
        color: {
          active: _colors.colors.brand500,
          hover: _colors.colors.hover
        }
      }
    }
  }
};
exports.datetimepicker = datetimepicker;