"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dropdown = void 0;

var _colors = require("./colors");

var _fonts = require("./fonts");

var dropdown = {
  menu: {
    border: {
      color: _colors.colors.secondary200
    },
    background: {
      color: _colors.colors.background.light
    },
    header: {
      color: _colors.colors.text.secondary,
      family: _fonts.fonts.family["default"],
      size: _fonts.fonts.size.medium,
      weight: _fonts.fonts.weight.bold
    }
  },
  item: {
    hoverColor: {
      enabled: _colors.colors.hover,
      disabled: _colors.colors.background.light
    },
    text: {
      color: {
        enabled: _colors.colors.text.secondary,
        disabled: _colors.colors.text.disabled
      },
      size: _fonts.fonts.size.medium,
      family: _fonts.fonts.family["default"]
    },
    icon: {
      color: {
        enabled: _colors.colors.secondary400,
        disabled: _colors.colors.secondary200,
        hover: _colors.colors.brand500
      }
    }
  },
  "break": {
    color: _colors.colors.secondary200
  }
};
exports.dropdown = dropdown;