"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.form = void 0;

var _color = _interopRequireDefault(require("color"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var form = {
  field: {
    label: {
      text: {
        size: _fonts.fonts.size.xsmall,
        color: _colors.colors.text.secondary,
        weight: _fonts.fonts.weight.bold,
        family: _fonts.fonts.family["default"]
      }
    }
  },
  footer: {
    boxShadow: {
      color: (0, _color["default"])(_colors.colors.secondary900).alpha(0.08).hsl().string()
    }
  },
  section: {
    icon: {
      color: _colors.colors.secondary900
    },
    header: {
      text: {
        color: _colors.colors.text.primary,
        weight: _fonts.fonts.weight.medium,
        family: _fonts.fonts.family["default"],
        size: _fonts.fonts.size.large
      }
    },
    body: {
      background: {
        color: _colors.colors.background.lightAlt
      }
    }
  },
  flag: {
    color: _colors.colors.secondary300
  },
  help: {
    color: _colors.colors.secondary600,
    backgroundColor: _colors.colors.secondary200
  }
};
exports.form = form;