"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.input = void 0;

var _color = _interopRequireDefault(require("color"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var input = {
  border: {
    color: {
      "default": _colors.colors.secondary200,
      active: _colors.colors.secondary900,
      error: _colors.colors.danger500
    }
  },
  background: {
    color: _colors.colors.background.light
  },
  placeholder: {
    color: _colors.colors.secondary400
  },
  icon: {
    color: _colors.colors.secondary400
  },
  text: {
    family: _fonts.fonts.family["default"],
    color: _colors.colors.text.secondary,
    size: {
      "default": _fonts.fonts.size.medium,
      small: _fonts.fonts.size.small
    }
  },
  boxShadow: {
    color: (0, _color["default"])(_colors.colors.secondary900).alpha(0.08).hsl().string()
  }
};
exports.input = input;