"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getItemColor = exports.navbar = void 0;

var _color = _interopRequireDefault(require("color"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var navbar = {
  navbar: {
    background: {
      color: _colors.colors.background.dark
    }
  },
  item: {
    color: {
      "default": _colors.colors.secondary700,
      alt: _colors.colors.secondary300,
      active: _colors.colors.white
    },
    text: {
      size: _fonts.fonts.size.small,
      weight: _fonts.fonts.weight.regular,
      family: _fonts.fonts.family["default"]
    }
  },
  progress: {
    background: {
      color: {
        "default": _colors.colors.secondary700,
        active: _colors.colors.success500
      }
    },
    text: {
      color: _colors.colors.text.dark,
      size: _fonts.fonts.size.small,
      weight: _fonts.fonts.weight.bold,
      family: _fonts.fonts.family["default"]
    }
  },
  spinner: {
    background: {
      color: _colors.colors.secondary900
    },
    icon: {
      color: _colors.colors.success500
    }
  }
};
exports.navbar = navbar;

var getItemColor = function getItemColor(inContentBlock, activePath) {
  return activePath ? navbar.item.color.active : inContentBlock ? navbar.item.color["default"] : navbar.item.color.alt;
};

exports.getItemColor = getItemColor;