"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prompt = void 0;

var _colors = require("./colors");

var _fonts = require("./fonts");

var prompt = {
  mask: {
    color: _colors.colors.mask
  },
  header: {
    text: {
      size: _fonts.fonts.size.large,
      family: _fonts.fonts.family["default"],
      weight: _fonts.fonts.weight.bold,
      color: _colors.colors.text.secondary
    },
    background: {
      color: _colors.colors.background.light
    }
  },
  body: {
    extraContent: {
      border: {
        color: _colors.colors.secondary200
      }
    },
    text: {
      size: _fonts.fonts.size.medium,
      family: _fonts.fonts.family["default"],
      color: _colors.colors.text.secondary
    },
    background: {
      color: _colors.colors.background.lightAlt
    },
    alert: {
      color: _colors.colors.warning500
    }
  },
  footer: {
    background: {
      color: _colors.colors.background.light
    }
  }
};
exports.prompt = prompt;