"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.radioButton = exports.getRadioButtonState = exports.RadioButtonConstants = void 0;

var _colors = require("./colors");

var _fonts = require("./fonts");

var states = {
  checked: 'checked',
  unchecked: 'unchecked'
};
var RadioButtonConstants = {
  states: states
};
exports.RadioButtonConstants = RadioButtonConstants;

var getRadioButtonState = function getRadioButtonState(checked) {
  return checked ? RadioButtonConstants.states.checked : RadioButtonConstants.states.unchecked;
};

exports.getRadioButtonState = getRadioButtonState;
var radioButton = {
  color: _colors.colors.secondary900,
  text: {
    size: _fonts.fonts.size.medium,
    family: _fonts.fonts.family["default"],
    weight: {
      checked: _fonts.fonts.weight.medium,
      unchecked: _fonts.fonts.weight.regular
    },
    color: _colors.colors.text.secondary
  }
};
exports.radioButton = radioButton;