"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.select = void 0;

var _color = _interopRequireDefault(require("color"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var select = {
  input: {
    border: {
      color: {
        "default": _colors.colors.secondary200,
        active: _colors.colors.secondary900
      }
    },
    boxShadow: {
      color: (0, _color["default"])(_colors.colors.secondary900).alpha(0.08).hsl().string()
    },
    text: {
      weight: _fonts.fonts.weight.regular,
      size: {
        "default": _fonts.fonts.size.medium,
        small: _fonts.fonts.size.small
      },
      family: _fonts.fonts.family["default"],
      color: _colors.colors.text.secondary
    }
  },
  placeholder: {
    text: {
      color: _colors.colors.text.subtle,
      weight: _fonts.fonts.weight.regular,
      family: _fonts.fonts.family["default"],
      size: {
        "default": _fonts.fonts.size.medium,
        small: _fonts.fonts.size.small
      }
    }
  },
  dropdownIndicator: {
    color: _colors.colors.secondary900,
    colorHover: _colors.colors.brand500
  },
  loading: {
    color: _colors.colors.secondary900
  },
  value: {
    single: {
      text: {
        weight: _fonts.fonts.weight.regular,
        family: _fonts.fonts.family["default"],
        color: _colors.colors.text.secondary,
        size: {
          "default": _fonts.fonts.size.medium,
          small: _fonts.fonts.size.small
        }
      },
      icon: {
        color: _colors.colors.secondary400
      }
    },
    pill: {
      background: {
        color: _colors.colors.secondary200
      },
      icon: {
        color: _colors.colors.secondary400
      },
      border: {
        color: _colors.colors.secondary200
      },
      text: {
        weight: _fonts.fonts.weight.regular,
        color: _colors.colors.text.secondary,
        family: _fonts.fonts.family["default"],
        size: {
          "default": _fonts.fonts.size.medium,
          small: _fonts.fonts.size.xsmall
        }
      },
      clear: {
        color: {
          iconDefault: _colors.colors.secondary500,
          iconHover: _colors.colors.danger500
        }
      }
    }
  },
  option: {
    text: {
      family: _fonts.fonts.family["default"],
      color: {
        "default": _colors.colors.text.secondary,
        disabled: _colors.colors.text.disabled
      },
      size: {
        "default": _fonts.fonts.size.medium,
        small: _fonts.fonts.size.small
      },
      weight: _fonts.fonts.weight.regular
    },
    icon: {
      color: _colors.colors.secondary400
    },
    background: {
      color: {
        "default": _colors.colors.background.light,
        hover: _colors.colors.hover
      }
    }
  },
  groupHeader: {
    text: {
      family: _fonts.fonts.family["default"],
      color: _colors.colors.text.secondary,
      weight: _fonts.fonts.weight.bold,
      size: {
        "default": _fonts.fonts.size.medium,
        small: _fonts.fonts.size.small
      }
    },
    icon: {
      color: _colors.colors.secondary900
    }
  }
};
exports.select = select;