"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.slider = exports.getSliderState = exports.SliderConstants = void 0;

var _colors = require("./colors");

var _fonts = require("./fonts");

var states = {
  "default": 'default',
  active: 'active',
  disabled: 'disabled'
};
var SliderConstants = {
  states: states
};
exports.SliderConstants = SliderConstants;

var getSliderState = function getSliderState(disabled, active) {
  return disabled ? SliderConstants.states.disabled : active ? SliderConstants.states.active : SliderConstants.states["default"];
};

exports.getSliderState = getSliderState;
var slider = {
  input: {
    size: _fonts.fonts.size.small,
    family: _fonts.fonts.family["default"],
    color: _colors.colors.text.secondary
  },
  label: {
    size: _fonts.fonts.size.medium,
    family: _fonts.fonts.family["default"],
    color: {
      "default": _colors.colors.text.secondary,
      active: _colors.colors.brand500
    },
    weight: _fonts.fonts.weight.regular
  },
  color: {
    "default": _colors.colors.secondary300,
    active: _colors.colors.secondary900
  }
};
exports.slider = slider;