"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.table = void 0;

var _colors = require("./colors");

var _fonts = require("./fonts");

var table = {
  header: {
    text: {
      family: _fonts.fonts.family["default"],
      size: _fonts.fonts.size.small,
      weight: _fonts.fonts.weight.medium,
      color: _colors.colors.text.secondary
    },
    border: {
      color: _colors.colors.secondary900
    }
  },
  row: {
    text: {
      family: _fonts.fonts.family["default"],
      size: _fonts.fonts.size.small,
      weight: _fonts.fonts.weight.regular,
      color: _colors.colors.text.primary
    },
    border: {
      color: _colors.colors.secondary400
    },
    background: {
      color: {
        hover: _colors.colors.hover,
        readOnlyHover: _colors.colors.secondary200
      }
    }
  }
};
exports.table = table;