"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toggle = exports.getToggleState = exports.ToggleConstants = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _colors = require("./colors");

var _fonts = require("./fonts");

var states = {
  checked: 'checked',
  unchecked: 'unchecked'
};
var ToggleConstants = {
  states: states
};
exports.ToggleConstants = ToggleConstants;

var getToggleState = function getToggleState(checked) {
  return checked ? ToggleConstants.states.checked : ToggleConstants.states.unchecked;
};

exports.getToggleState = getToggleState;
var toggleSmall = {
  slider: {
    color: _colors.colors.white
  },
  label: {
    color: {
      checked: _colors.colors.success500,
      unchecked: _colors.colors.secondary300
    }
  }
};
var toggleMedium = {
  text: {
    color: _colors.colors.text.dark,
    family: _fonts.fonts.family["default"],
    size: _fonts.fonts.size.xsmall
  },
  slider: {
    color: {
      checked: _colors.colors.success700,
      unchecked: _colors.colors.secondary300,
      before: _colors.colors.white
    }
  },
  label: {
    color: {
      checked: _colors.colors.success500,
      unchecked: _colors.colors.secondary400
    }
  }
};
var toggleLarge = (0, _objectSpread2["default"])({}, toggleMedium, {
  text: (0, _objectSpread2["default"])({}, toggleMedium.text, {
    size: _fonts.fonts.size.small
  })
});
var toggle = {
  small: toggleSmall,
  medium: toggleMedium,
  large: toggleLarge
};
exports.toggle = toggle;