"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var keys = {
  '37': 1,
  '38': 1,
  '39': 1,
  '40': 1
};

var preventDefault = function preventDefault(e) {
  e = e || window.event;

  if (e.preventDefault) {
    e.preventDefault();
    e.returnValue = false;
  }
};

var preventDefaultForScrollKeys = function preventDefaultForScrollKeys(e) {
  if (keys[e.keyCode]) {
    preventDefault(e);
    return false;
  }
};

var disableScroll = function disableScroll() {
  if (window.addEventListener) {
    window.addEventListener('DOMMouseScroll', preventDefault, true); // older FF
  }

  window.onwheel = preventDefault; // modern standard

  window.onmousewheel = document.onmousewheel = preventDefault; // older browsers, IE

  window.ontouchmove = preventDefault; // mobile

  document.onkeydown = preventDefaultForScrollKeys;
};

var enableScroll = function enableScroll() {
  if (window.removeEventListener) {
    window.removeEventListener('DOMMouseScroll', preventDefault, true);
  }

  window.onmousewheel = document.onmousewheel = null;
  window.onwheel = null;
  window.ontouchmove = null;
  document.onkeydown = null;
};

var _default = {
  disableScroll: disableScroll,
  enableScroll: enableScroll
};
exports["default"] = _default;